-- UNIT TRANSPORTER
-- [[ By Sorfox]]
local transport = {}

local gen = require("generalLibrary")
--state.loadedTrucks = {}                                                        -- we have a nested table that holds following data: loadedTrucks[truck_ID] = {loadedUnit_ID1, loadedUnit_ID2, ...}
--
local activeTruck = nil                                                             -- a global variable is defined

local state = "stateTableNotLinked"

local storageTile = civ.getTile(129,185,0) -- p.g. Note I didn't replace civ.getTile(25,5,0) in the parts of the code I didn't write, so search for teleport or civ.teleportUnit to find those instances


-- 'traditional' link state system
function transport.linkState(stateTable)
    state = stateTable
    state.loadedTrucks = state.loadedTrucks or {}
end

-- link state not requiring access to onLoad
function transport.putInScenarioLoaded()
    state = gen.getState()
    state.loadedTrucks = state.loadedTrucks or {}
end



function transport.firstTimeFakeLoadingOnTruck()
    --print("Within the function: firstTimeFakeLoadingOnTruck.")
    local activeUnit = activeTruck                                                -- update the local variable (ID of the truck) with the data of the gloal variable, which was "filled" in the triggering functions (below) and which reference this function
    local unitsOnTruck = state.loadedTrucks[activeUnit.id]                         -- initialize local variable 'unitsOnTruck' [always first action in order to be able to use it] and connect it with exactly this truck; KEY for the state.table = activeUnit/currentUnit.id
    if unitsOnTruck == nil then
       --print("This truck (ID: " .. activeUnit.id .. ") has never been loaded before, so we do it by means of Lua artificially.")
       unitsOnTruck = {[1] = "firstUnitFakeLoading", [2] = "secondUnitFakeLoading"}
       state.loadedTrucks[activeUnit.id] = unitsOnTruck
       --print("Case ZERO - state.table successfully updated!")                -- just for checking if formula worked
    end
end                                                                            -- 'end' of function firstTimeFakeLoadingOnTruck()
local firstTimeFakeLoadingOnTruck = transport.firstTimeFakeLoadingOnTruck

-----------------------------------------------------------------------------------------------------------------------
function transport.loadUnitsOnTruck()
    --print("Within the function: loadUnitsOnTruck.")
    local unitTypeAllowedToBeLoaded = civ.getUnitType(76)                        -- defines which unit(s) can be loaded on the truck -> modifiable (!) -> references the position of '@UNITS' in 'rules.txt' file
    local supplyTruckType1 = civ.getUnitType(89)                                  -- defines which unit(s) count as 'truck' (= land transporter / carrying vehicle) -> modifiable (!) -> references the position of '@UNITS' in 'rules.txt' file
    local supplyTruckType2 = civ.getUnitType(98) 
    
    local transportVehicleType = {}
    transportVehicleType[89]=true
    transportVehicleType[98]=true
    
    local cargoUnitType = {}
    cargoUnitType[3]=true -- British Infantry Vet
    cargoUnitType[4]=true -- GI Infantry Vet
	cargoUnitType[11]=true -- Paracadutisto
	cargoUnitType[74]=true -- US Bazooka
    cargoUnitType[81]=true -- Ranger
	cargoUnitType[82]=true -- 82nd Airborne
	cargoUnitType[83]=true -- M1 57mm AT.	
	cargoUnitType[86]=true -- US Bofors 40mm AA
    cargoUnitType[87]=true -- M2A1 105mmArt
	cargoUnitType[88]=true -- M1 155mmArt
	cargoUnitType[92]=true -- British PIAT
    cargoUnitType[93]=true -- British MG
	cargoUnitType[99]=true -- Commandos
	cargoUnitType[100]=true -- 1stAirborne
	cargoUnitType[101]=true -- 6 pdr AT.
	cargoUnitType[105]=true -- UK Bofors 40mm AA
    cargoUnitType[106]=true -- 25pdr MKII Art
	cargoUnitType[107]=true -- 5.5inch Art
	cargoUnitType[121]=true -- Cdn Infantry
	cargoUnitType[122]=true -- Cdn 25pdr Art
	cargoUnitType[131]=true -- Gurkhas
	cargoUnitType[132]=true -- Indian Infantry
	cargoUnitType[133]=true -- 4th Indian Div
	cargoUnitType[134]=true -- Indian 25pdrArt
	cargoUnitType[135]=true -- Polish Infantry
	cargoUnitType[137]=true -- Polish 25pdr Art
	cargoUnitType[138]=true -- Infanterie Coloniale
	cargoUnitType[139]=true -- Goumier Marocain
	cargoUnitType[140]=true -- Tirailleur Algerien
	cargoUnitType[142]=true -- Free French 105Art 
	cargoUnitType[146]=true -- NZ 25pdrArt 
	cargoUnitType[153]=true -- Greek Mtn Bde	
	cargoUnitType[162]=true -- Jewish Bde
	cargoUnitType[163]=true -- GI Infantry Reg
	cargoUnitType[165]=true -- US 10th Mountain
	cargoUnitType[166]=true -- US Bazooka
	cargoUnitType[168]=true -- British Infantry Reg	
	cargoUnitType[188]=true -- British 52nd Mtn	
    
    local successfullFakeLoading = 0                                            -- helper local variable (0 = false / 1 = true)
    local activeUnit = civ.getActiveUnit()
    local activeTile = nil
    
    
    
    if activeUnit then                                                             -- check that there is an active unit
       activeTile = civ.getActiveUnit().location                                 -- gets the active unit and selects the tile
    else                                                                         -- if there is no active unit, then
       --print("No active unit.")                                                    -- 1) show this info in the console
       return                                                                    -- 2) and end the function, since there is no point in doing any further calculation
    end
    if not(cargoUnitType[activeUnit.type.id]) then                             -- if there is no unitTypeAllowedToBeLoaded /cagoUnitType on the tile then there is no point to continue the code -> Therefore: return
       --print("Active unit is NOT a unitTypeAllowedToBeLoaded.")
       return
    end
    --print("Active unit is a unitTypeAllowedToBeLoaded.")                    -- if this line is reached (not broken up before) there must be an active unit which is a unitTypeAllowedToBeLoaded
    for currentUnit in activeTile.units do                                     -- do a 'for loop' over every unit on the active tile, where (we already know) units of unitTypes allowed to be loaded exist
        --if currentUnit.type == supplyTruckType then
        if (currentUnit.type == supplyTruckType1 or currentUnit.type == supplyTruckType2) then
           --print("loadFunction - checking the truck ID " .. currentUnit.id) -- if this line is reached (not broken up before) there must be an active unit equal to supplyTruckType
           local unitsOnTruck = state.loadedTrucks[currentUnit.id]            -- "fill" the local variable 'unitsOnTruck' with data about the loaded units (IDs) on exactly this truck; KEY for the state.table = currentUnit.id
           activeTruck = currentUnit                                        -- update the global variable, i.e. ID of the truck used right at this moment; since this funtion - in one case - jump to the funtion 'firstTimeFakeLoadingOnTruck()', where the ID is needed
            if unitsOnTruck == nil then                                        -- if this line is reached (not broken up before) there must be an active unit equal to supplyTruckType (=2nd condition) BUT it still can be a "virgin" truck, which will always result in code errors
               --print("unitsOnTruck == nil | This truck (ID: " .. currentUnit.id .. ") has never been loaded before, so we do it by means of Lua artificially.")
               firstTimeFakeLoadingOnTruck()                                -- jump to and then execute this function
               successfullFakeLoading = 1                                    -- toggle local variable "on" = proof that each place of the truck is at least "fake loaded", since the line before 'function firstTimeFakeLoadingOnTruck()' did run
            end
            if unitsOnTruck ~= nil or successfullFakeLoading == 1 then        -- only now we can introduce the variables ('firstUnit'+'secondUnit') in the code, earlier there would be an error "attempt to index a nil value (global 'unitsOnTruck')" -> covered by 'firstTimeFakeLoadingOnTruck()'
               unitsOnTruck = state.loadedTrucks[currentUnit.id]
               activeTruck = nil                                            -- delete content of the global variable
               local firstUnit = unitsOnTruck[1]                            -- data of the first unit will be stored by means of their ID -> 'local' = initialize the variable within this function
               local secondUnit = unitsOnTruck[2]
                if firstUnit == nil or firstUnit == "firstUnitFakeLoading" then    -- if there is NO first - or only a "firstUnitFakeLoading" (which is also NO) - unit on the truck => LOAD IT!
                   civ.ui.text("Loading first unit on the truck.")
                   unitsOnTruck = {[1] = activeUnit.id, [2] = secondUnit}    -- 1st step of "table magic": update the locale variable 'unitsOnTruck' with the newest info about the activeUnit.id, which is now loaded in the table 
                   civ.teleportUnit(activeUnit, civ.getTile(129,185,0)) -- code to teleport the currently loaded unit to a certain square on night map
                   activeUnit.order = 3                                        -- after teleportation to 2. map -> unit is set to 'sleep'
                   state.loadedTrucks[currentUnit.id] = unitsOnTruck        -- 2nd step of "table magic": update the state.table with the newest info -> which was stored in the locale variable table 'unitsOnTruck' - done during the 1st step
                   currentUnit:activate()                                    -- activates the truck, after loading the 1st unit, clearing its orders, and, if it has a human owner and movement points left, selects it on the map
                     break
                  elseif secondUnit == nil or secondUnit == "secondUnitFakeLoading" then -- checking if there is still space on the selected truck (secondUnit == nil, or "secondUnitFakeLoading"), if yes => LOAD IT!
                   civ.ui.text("Loading second unit on the truck.")   
                   unitsOnTruck = {[1] = firstUnit, [2] = activeUnit.id}    -- same procedure + code as with firstUnit, but of course here the 2nd unit must be stored in the table differently => [2] = activeUnit.id
                   civ.teleportUnit(activeUnit, civ.getTile(129,185,0))
                   activeUnit.order = 3
                   state.loadedTrucks[currentUnit.id] = unitsOnTruck
                   currentUnit:activate()                                    -- activates the truck, after loading the 2nd unit, clearing its orders, and, if it has a human owner and movement points left, selects it on the map
                     break
                elseif (firstUnit ~= nil and firstUnit ~= "firstUnitFakeLoading") and (secondUnit ~= nil and secondUnit ~= "secondUnitFakeLoading") then
                     civ.ui.text("The truck is full, due to the fact that it is only possible to load two units on it.")   
                end
            end
        end
    end
end                                                                            -- 'end' of function loadUnitsOnTruck()

-----------------------------------------------------------------------------------------------------------------------
function transport.unloadUnitsOffTruck(truck)
    --print("Within the function: unloadUnitsOffTruck.")
    local supplyTruckType1 = civ.getUnitType(89)                         
    local supplyTruckType2 = civ.getUnitType(98) 
    local successfullFakeLoading = 0
    local activeUnit = truck or  civ.getActiveUnit() -- p.g. line change to add truck argument
    local activeTile = nil
    
    if activeUnit then                                                             -- check that there is an active unit
       activeTile = activeUnit.location  --p.g. changed line from civ.getActiveUnit() to activeUnit, for truck argument                               -- gets the acive unit and selects the tile
    else                                                                         -- if there is no active unit, then
       --print("No active unit.")                                                    -- 1) show this info in the console
       return                                                                    -- 2) and end the function, since there is no point in doing any further calculation
    end
   
   
   
    if (activeUnit.type ~= supplyTruckType1 and activeUnit.type ~= supplyTruckType2) then -- if there is no truck on the tile then there is no point to continue the code -> Therefore: return
       --print("Active unit is NOT the supplyTruckType.")
       return
    else
       --print("UN-loadFunction - checking the truck ID " .. activeUnit.id)     -- if this line is reached (not broken up before) there must be an active unit equal to supplyTruckType
       local unitsOnTruck = state.loadedTrucks[activeUnit.id]                -- "fill" the local variable 'unitsOnTruck' with data about the loaded units (IDs) on exactly this truck; KEY for the state.table = currentUnit.id
       activeTruck = activeUnit                                                -- update the global variable, i.e. ID of the truck used right at this moment; since this funtion - in one case - jump to the funtion 'firstTimeFakeLoadingOnTruck()', where the ID is needed
        if unitsOnTruck == nil then                                            -- if this line is reached (not broken up before) there must be an active unit equal to supplyTruckType (=2nd condition) BUT it still can be a "virgin" truck, which will always result in code errors
           --print("unitsOnTruck == nil | This truck (ID: " .. activeUnit.id .. ") has never been loaded before, so we do it by means of Lua artificially.")
           firstTimeFakeLoadingOnTruck()                                    -- from that code line on -> each place of the truck is at least "fake loaded"
           successfullFakeLoading = 1
        end
        if unitsOnTruck ~= nil or successfullFakeLoading == 1 then            -- only now we can introduce the variables ('firstUnit'+'secondUnit') in the code, earlier there would be an error "attempt to index a nil value (global 'unitsOnTruck')" -> covered by 'firstTimeFakeLoadingOnTruck()'
           unitsOnTruck = state.loadedTrucks[activeUnit.id]
           activeTruck = nil                                                -- delete content of the global variable
           local firstUnit = unitsOnTruck[1]                                -- data of the first unit will be stored by means of their ID -> 'local' = initialize the variable within this function
           local secondUnit = unitsOnTruck[2]
            if (firstUnit == nil or firstUnit == "firstUnitFakeLoading") and (secondUnit == nil or secondUnit == "secondUnitFakeLoading") then    -- Case ONE: the respective truck is empty
               civ.ui.text("There are NO units to unload from this (ID: " .. activeUnit.id .. ") empty truck.")
               return
            elseif firstUnit ~= nil and firstUnit ~= "firstUnitFakeLoading" then
               local firstUnitComplete = civ.getUnit(firstUnit)
               civ.teleportUnit(firstUnitComplete, activeTile)                 -- code to teleport the currently loaded unit to exactly the same tile as where the truck stands (first map)
               firstUnitComplete:activate()                                    -- activates the unloaded unit, clearing its orders, and, if it has a human owner and movement points left, selects it on the map
               unitsOnTruck[1] = "firstUnitFakeLoading"                        -- removes the value (ID of the firstUnit) from the table; Be aware: We do the procedure NOT on variable 'firstUnit' since it's just used for easier reading the code - i.e. a representation of 'unitsOnTruck[1]' => the direct table entry, which we have to change here
               state.loadedTrucks[activeUnit.id] = unitsOnTruck                -- update the state.table
            elseif secondUnit ~= nil and secondUnit ~= "secondUnitFakeLoading" then
               local secondUnitComplete = civ.getUnit(secondUnit)
               civ.teleportUnit(secondUnitComplete, activeTile)             -- code to teleport the currently loaded unit to exactly the same tile as where the truck stands (first map)
               secondUnitComplete:activate()                                -- activates the unloaded unit, clearing its orders, and, if it has a human owner and movement points left, selects it on the map
               unitsOnTruck[2] = "secondUnitFakeLoading"                    -- removes the value (ID of the secondUnit) from the table; Be aware: We do the procedure NOT on variable 'secondUnit' since it's just used for easier reading the code - i.e. a representation of 'unitsOnTruck[2]' => the direct table entry, which we have to change here
               state.loadedTrucks[activeUnit.id] = unitsOnTruck                -- update the state.table
            end
        end
    end
end                                                                            -- 'end' of function unloadUnitsOffTruck()

-----------------------------------------------------------------------------------------------------------------------
function transport.onActivateEveryUnit(activeUnit, source)
    --print("Within the function: onActivateEveryUnit.")
    local supplyTruckType1 = civ.getUnitType(89)                         
    local supplyTruckType2 = civ.getUnitType(98) 
    local successfullFakeLoading = 0
    
    if (activeUnit.type ~= supplyTruckType1 and activeUnit.type ~= supplyTruckType2) then                                    -- if the currently activeUnit is no truck then there is no point to continue the code -> Therefore:
       --print("Active unit is NOT the supplyTruckType.")                            -- 1) show this info in the console
       return                                                                    -- 2) and end the function
    else
       --print("Active unit (ID: " .. activeUnit.id .. ") is supplyTruckType.")     -- if this line is reached (not broken up before), the currently activeUnit must be a truck
       local unitsOnTruck = state.loadedTrucks[activeUnit.id]                    -- "fill" the local variable 'unitsOnTruck' with data about the loaded units (IDs) on exactly this truck; KEY for the state.table = activeUnit/currentUnit.id
       activeTruck = activeUnit                                                    -- update the global variable, i.e. ID of the truck used right at this moment; since this funtion - in one case - jump to the funtion 'firstTimeFakeLoadingOnTruck()', where the ID is needed
        if unitsOnTruck == nil then                                                -- if this line is reached (not broken up before) there must be an active unit equal to supplyTruckType (=2nd condition) BUT it still can be a "virgin" truck, which will always result in code errors
           --print("unitsOnTruck == nil | Therefore: Execute funtion: firstTimeFakeLoadingOnTruck.")

           firstTimeFakeLoadingOnTruck()                                         -- from that code line on -> each place of the truck is at least "fake loaded"
           successfullFakeLoading = 1
        end
        if unitsOnTruck ~= nil or successfullFakeLoading == 1 then                -- only now we can introduce the variables ('firstUnit'+'secondUnit') in the code, earlier there would be an error "attempt to index a nil value (global 'unitsOnTruck')" -> covered by 'firstTimeFakeLoadingOnTruck()'
           unitsOnTruck = state.loadedTrucks[activeUnit.id]
           activeTruck = nil                                                    -- delete content of the global variable
           local firstUnit = unitsOnTruck[1]                                    -- data of the first unit will be stored by means of their ID -> 'local' = initialize the variable within this function
           local secondUnit = unitsOnTruck[2]
            if (firstUnit == nil or firstUnit == "firstUnitFakeLoading") and (secondUnit == nil or secondUnit == "secondUnitFakeLoading") then            -- Case ONE: the respective truck is empty
               civ.ui.text("Empty truck (ID: " .. activeUnit.id .. ").")
               return
            elseif (firstUnit ~= nil and firstUnit ~= "firstUnitFakeLoading") and (secondUnit == nil or secondUnit == "secondUnitFakeLoading") then        -- Case TWO: if there is ONLY the firstUnit on the truck
               civ.ui.text("Currently only unit " .. civ.getUnit(firstUnit).type.name .. " is on the truck " .. activeUnit.id .. ".")
               return
            elseif (firstUnit == nil or firstUnit == "firstUnitFakeLoading") and (secondUnit ~= nil and secondUnit ~= "secondUnitFakeLoading") then        -- Case THREE: if there is ONLY the secondUnit on the truck
               civ.ui.text("Currently only unit " .. civ.getUnit(secondUnit).type.name .. " is on the truck " .. activeUnit.id .. ".")
               return
            elseif (firstUnit ~= nil and firstUnit ~= "firstUnitFakeLoading") and (secondUnit ~= nil and secondUnit ~= "secondUnitFakeLoading") then    -- Case FOUR: truck is full / loaded with "real" units
               civ.ui.text("Currently the units: " .. civ.getUnit(firstUnit).type.name .. ", " .. civ.getUnit(secondUnit).type.name .. " are on the truck " .. activeUnit.id .. ".")
            end
        end
    end
end   

--[[]]
-- transport.onChooseDefender by Prof. Garfield
function transport.onChooseDefender(defaultFunction,tile,attacker,isCombat)
    for unit in tile.units do
        -- max of two units on truck, so unload twice
        transport.unloadUnitsOffTruck(unit)
        transport.unloadUnitsOffTruck(unit)
    end
end

civ.scen.onChooseDefender(function(defaultFunction,tile,attacker,isCombat)
   transport.onChooseDefender(defaultFunction,tile,attacker,isCombat)
   return defaultFunction(tile,attacker)
end)

-- transport.onUnitKilled by Prof Garfield
-- if using this effect, add this line to the unitDefeated event
--    transport.onUnitKilled(loser,winner,aggressor,victim,loserLocation,winnerVetStatus,loserVetStatus)
local transportVehicleType = {}
transportVehicleType[89]=true
transportVehicleType[98]=true
--
function transport.onUnitKilled(loser,winner,aggressor,victim,loserLocation,winnerVetStatus,loserVetStatus)
    if state.loadedTrucks[loser.id] and transportVehicleType[loser.type.id] then
        -- truck is killed, get cargo, and kill it on the loser's square
        for _,cargoId in pairs(state.loadedTrucks[loser.id]) do
            if type(cargoId) == "number" then
                local cargoUnit = civ.getUnit(cargoId)
                if cargoUnit.owner == loser.owner and cargoUnit.location == storageTile then
                    -- this is to double check the unit is still on the truck
                    cargoUnit:teleport(loserLocation)
                    gen.defeatUnit(cargoUnit,winner,aggressor,victim,loserLocation,winnerVetStatus,loserVetStatus)
                end
            end
        end
        
        -- remove truck loaded status from table
        state.loadedTrucks[loser.id] = nil
        return
    elseif state.loadedTrucks[loser.id] then
        -- A unit with the id of a former truck is killed, but that unit isn't a truck
        -- clear the state table of that unit
        state.loadedTrucks[loser.id] = nil
        return
    else
--        -- some other unit was killed, return with no action
        return
    end
end

local discreteEvents = require("discreteEventsRegistrar")
function discreteEvents.linkStateToModules(state,stateTableKeys)
    local keyName = "transportModuleState"
    if stateTableKeys[keyName] then
        error('"'..keyName..'" is used as a key for the state table on at least two occasions.')
    else
        stateTableKeys[keyName] = true
    end
    -- link the state table to the module
    state[keyName] = state[keyName] or {}
    transport.linkState(state[keyName])
end

return transport
