local gen = require("generalLibrary")
local param = require("parameters")
local object = require("object")
local text = require("text")

local object = require("object")
local flag = require("flag")
local counter = require("counter")

local onTurn = require("onTurn")

local func = require("functions")

local function smallNestedMenu(menuType)

	-- INITILIAZE UNIT TOTALS
	-- AMERICAN
	local totalP40Warhawk = 0
	local totalP38Lightning = 0
	local totalP51DMustang = 0
	
	local totalA36Apache = 0
	local totalB17Fortress = 0
	local totalB24Liberator = 0
	local totalB25Mitchell = 0
	local totalB26Marauder = 0
	
	local totalM8Greyhound = 0
	local totalArmoredInfantry = 0
	local totalM5Stuart = 0
	local totalM4A1Sherman = 0
	local totalM4A376WSherman = 0
	local totalM10Wolverine = 0
	local totalM4A1ShermanInd = 0
	local totalUSTruck = 0
	local totalEngineer = 0

	local totalUS1stInfantry = 0
	local totalGIInfantryVet = 0
	local totalGIInfantryReg = 0
	local totalUSBazooka = 0
	local totalRanger = 0
	local total82ndAirborne = 0
	local totalUS10thMountain = 0
	local totalUS442ndRegt = 0
	
	local totalM7105mmHMC = 0
	local totalM12155mmHMC = 0
	local totalUSBofors40mmAA = 0
	local totalM2A1105mmArt = 0
	local totalM1155mmArt = 0
	local totalM157mmAT = 0
	
	local totalP40Warhawk = 0
	local totalP38Lightning = 0
	local totalP51DMustang = 0
	
	-- BRITISH
	local totalBeaufighterMkVI = 0
	local totalKittyhawk = 0
	local totalSpitfireMkV = 0
	local totalSeafireMkII = 0

	local totalHurricaneIIc = 0
	local totalMartinBaltimore = 0
	local totalVickersWellington = 0
	local totalBostonIII = 0
	local totalSunderlandIII = 0	
	local totalFaireyBarracuda = 0

	local totalDaimlerAC = 0
	local totalBrenCarrier = 0
	local totalShermanIIIBde = 0
	local totalShermanIII = 0
	local totalChurchillMkIV = 0
	local totalCromwell = 0
	local totalShermanFirefly = 0
	local totalChurchillAVRE = 0
	local totalUKTruck = 0	

	local totalBritishInfantryVet = 0
	local totalBritishInfantryReg = 0
	local totalBritishPIAT = 0
	local totalBritishMG = 0
	local totalCommandos = 0
	local total1stAirborne = 0
	local totalBritish52ndMtn = 0
	
	local totalBishop25pdr = 0
	local totalUKBofors40mmAA = 0
	local total25pdrMKIIArt = 0
	local total55inchArt = 0
	local total6pdrAT = 0

	-- ALLIED MINORS
	-- Canadian
	local totalCdnMotInf = 0
	local totalCdnSherman = 0
	local totalCdnM7105mm = 0	
	local totalCdnBrenCarrier = 0
	local totalCdnInfantry = 0

	-- Indian
	local totalIndianInfantry = 0
	local total4thIndianDiv = 0
	local totalGurkhas = 0
	local totalIndian25pdrArt = 0

	-- New Zealand
	local totalNZMotInf = 0
	local totalNZSherman = 0
	local totalNZSexton = 0

	-- South African
	local totalSAMotInf = 0
	local totalSASherman = 0
	local totalSASexton = 0
	local totalSABrenCarrier = 0

	-- Brazil et Al.
	local totalBraz1stInf = 0
	local totalGreekMtnBde = 0
	local totalJewishBde = 0

	-- French 
	local totalInfanterieColoniale = 0
	local totalGoumierMarocain = 0
	local totalTirailleurAlgrien = 0
	local totalFreeFrenchInfantry = 0
	local totalFreeFrench105Art = 0	
	local totalFreeFrenchM10 = 0
	
	-- Polish
	local totalPolishSherman = 0
	local totalPolishInfantry = 0
	local totalPolish25pdrArt = 0	

	-- ROYAL NAVY AND USN
	local totalDestroyers = 0
	local totalLightCruiser = 0
	local totalHeavyCruisers = 0
	local totalSubmarines = 0
	local totalLibertyShips = 0
	local totalOilTankers = 0
	local totalDUKW = 0
	
	-- COUNT EACH ALLIED UNIT
	for unit in civ.iterateUnits() do
		if unit.owner == object.pAllies then
			
			-- AMERICAN ===========================
			if unit.type == object.uP40Warhawk then
				totalP40Warhawk = totalP40Warhawk + 1
			end
			if unit.type == object.uP38Lightning then
				totalP38Lightning = totalP38Lightning + 1
			end
			if unit.type == object.uP51DMustang then
				totalP51DMustang = totalP51DMustang + 1
			end
						
			if unit.type == object.uA36Apache then
				totalA36Apache = totalA36Apache + 1
			end
			if unit.type == object.uB17Fortress then
				totalB17Fortress = totalB17Fortress + 1
			end
			if unit.type == object.uB24Liberator then
				totalB24Liberator = totalB24Liberator + 1
			end
			if unit.type == object.uB25Mitchell then
				totalB25Mitchell = totalB25Mitchell + 1
			end
			if unit.type == object.uB26Marauder then
				totalB26Marauder = totalB26Marauder + 1
			end
			
			if unit.type == object.uM8Greyhound then
				totalM8Greyhound = totalM8Greyhound + 1
			end
			if unit.type == object.uArmoredInfantry then
				totalArmoredInfantry = totalArmoredInfantry + 1
			end
			if unit.type == object.uM5Stuart then
				totalM5Stuart = totalM5Stuart + 1
			end
			if unit.type == object.uM4A1Sherman then
				totalM4A1Sherman = totalM4A1Sherman + 1
			end
			if unit.type == object.uM4A376WSherman then
				totalM4A376WSherman = totalM4A376WSherman + 1
			end
			if unit.type == object.uM10Wolverine then
				totalM10Wolverine = totalM10Wolverine + 1
			end
			if unit.type == object.uM4A1ShermanInd then
				totalM4A1ShermanInd = totalM4A1ShermanInd + 1
			end
			if unit.type == object.uUSTruck then
				totalUSTruck = totalUSTruck + 1
			end
			if unit.type == object.uEngineer then
				totalEngineer = totalEngineer + 1
			end
			
			if unit.type == object.uUS1stInfantry then
				totalUS1stInfantry = totalUS1stInfantry + 1
			end
			if unit.type == object.uGIVeteran then
				totalGIInfantryVet = totalGIInfantryVet + 1
			end
			if unit.type == object.uGIRegular then
				totalGIInfantryReg = totalGIInfantryReg + 1
			end
			if unit.type == object.uUSBazooka then
				totalUSBazooka = totalUSBazooka + 1
			end
			if unit.type == object.uRanger then
				totalRanger = totalRanger + 1
			end
			if unit.type == object.u82ndAirborne then
				total82ndAirborne = total82ndAirborne + 1
			end
			if unit.type == object.uUS10thMountain then
				totalUS10thMountain = totalUS10thMountain + 1
			end
			if unit.type == object.uUS442ndRegt then
				totalUS442ndRegt = totalUS442ndRegt + 1
			end
			
			if unit.type == object.uM7105mmHMC then
				totalM7105mmHMC = totalM7105mmHMC + 1
			end
			if unit.type == object.uM12155mmHMC then
				totalM12155mmHMC = totalM12155mmHMC + 1
			end
			if unit.type == object.uUSBofors40mmAA then
				totalUSBofors40mmAA = totalUSBofors40mmAA + 1
			end
			if unit.type == object.uM2A1105mmArt then
				totalM2A1105mmArt = totalM2A1105mmArt + 1
			end
			if unit.type == object.uM1155mmArt then
				totalM1155mmArt = totalM1155mmArt + 1
			end
			if unit.type == object.uM157mmAT then
				totalM157mmAT = totalM157mmAT + 1
			end
			
			-- BRITISH ===========================
			if unit.type == object.uBeaufighterMkVI then
				totalBeaufighterMkVI = totalBeaufighterMkVI + 1
			end
			if unit.type == object.uKittyhawk then
				totalKittyhawk = totalKittyhawk + 1
			end
			if unit.type == object.uSpitfireMkIX then
				totalSpitfireMkV = totalSpitfireMkV + 1
			end			
			if unit.type == object.uSeafireMkII then
				totalSeafireMkII = totalSeafireMkII + 1
			end		

			if unit.type == object.uHurricaneIIc then
				totalHurricaneIIc = totalHurricaneIIc + 1
			end	
			if unit.type == object.uMartinBaltimore then
				totalMartinBaltimore = totalMartinBaltimore + 1
			end	
			if unit.type == object.uVickersWellington then
				totalVickersWellington = totalVickersWellington + 1
			end	
			if unit.type == object.uBostonIII then
				totalBostonIII = totalBostonIII + 1
			end	
			if unit.type == object.uSunderlandIII then
				totalSunderlandIII = totalSunderlandIII + 1
			end	
			if unit.type == object.uFaireyBarracuda then
				totalFaireyBarracuda = totalFaireyBarracuda + 1
			end	

			if unit.type == object.uDaimlerAC then
				totalDaimlerAC = totalDaimlerAC + 1
			end	
			if unit.type == object.uBritishMotorTroops then
				totalBrenCarrier = totalBrenCarrier + 1
			end	
			if unit.type == object.uShermanIIaBde then
				totalShermanIIIBde = totalShermanIIIBde + 1
			end	
			if unit.type == object.uShermanIIa then
				totalShermanIII = totalShermanIII + 1
			end	
			if unit.type == object.uChurchillMkIV then
				totalChurchillMkIV = totalChurchillMkIV + 1
			end	
			if unit.type == object.uCromwellMkVII then
				totalCromwell = totalCromwell + 1
			end	
			if unit.type == object.uShermanVCFirefly then
				totalShermanFirefly = totalShermanFirefly + 1
			end	
			if unit.type == object.uChurchillAVRE then
				totalChurchillAVRE = totalChurchillAVRE + 1
			end				
			if unit.type == object.uUKTruck then
				totalUKTruck = totalUKTruck + 1
			end
			
			if unit.type == object.uBritishVeteran then
				totalBritishInfantryVet = totalBritishInfantryVet + 1
			end	
			if unit.type == object.uBritishRegular then
				totalBritishInfantryReg = totalBritishInfantryReg + 1
			end	
			if unit.type == object.uBritishPIAT then
				totalBritishPIAT = totalBritishPIAT + 1
			end	
			if unit.type == object.uBritishMG then
				totalBritishMG = totalBritishMG + 1
			end				
			if unit.type == object.uCommandos then
				totalCommandos = totalCommandos + 1
			end	
			if unit.type == object.u1stAirborne then
				total1stAirborne = total1stAirborne + 1
			end	
			if unit.type == object.uBritish52ndMtn then
				totalBritish52ndMtn = totalBritish52ndMtn + 1
			end	

			if unit.type == object.uBishop25pdr then
				totalBishop25pdr = totalBishop25pdr + 1
			end	
			if unit.type == object.uUKBofors40mmAA then
				totalUKBofors40mmAA = totalUKBofors40mmAA + 1
			end				
			if unit.type == object.u25pdrMKIIArt then
				total25pdrMKIIArt = total25pdrMKIIArt + 1
			end	
			if unit.type == object.u55inchArt then
				total55inchArt = total55inchArt + 1
			end				
			if unit.type == object.u6pdrAT then
				total6pdrAT = total6pdrAT + 1
			end	
			
			-- ALLIED MINORS =====================
			-- CANADIAN
			if unit.type == object.uCdnMotInf then
				totalCdnMotInf = totalCdnMotInf + 1
			end	
			if unit.type == object.uCdnShermanIII then
				totalCdnSherman = totalCdnSherman + 1
			end				
			if unit.type == object.uCdnM7105mm then
				totalCdnM7105mm = totalCdnM7105mm + 1
			end	
			if unit.type == object.uCdnMotorTroops then
				totalCdnBrenCarrier = totalCdnBrenCarrier + 1
			end	
			if unit.type == object.uCdnInfantry then
				totalCdnInfantry = totalCdnInfantry + 1
			end	

			-- INDIAN
			if unit.type == object.uIndianInfantry then
				totalIndianInfantry = totalIndianInfantry + 1
			end	
			if unit.type == object.u4thIndianDiv then
				total4thIndianDiv = total4thIndianDiv + 1
			end	
			if unit.type == object.uGurkhas then
				totalGurkhas = totalGurkhas + 1
			end	
			if unit.type == object.uIndian25pdrArt then
				totalIndian25pdrArt = totalIndian25pdrArt + 1
			end	

			-- NEW ZEALAND
			if unit.type == object.uNZMotInf then
				totalNZMotInf = totalNZMotInf + 1
			end	
			if unit.type == object.uNZShermanIII then
				totalNZSherman = totalNZSherman + 1
			end	
			if unit.type == object.uNZ25pdrArt then
				totalNZSexton = totalNZSexton + 1
			end	

			-- NEW ZEALAND
			if unit.type == object.uSAMotInf then
				totalSAMotInf = totalSAMotInf + 1
			end	
			if unit.type == object.uSAShermanIII then
				totalSASherman = totalSASherman + 1
			end	
			if unit.type == object.uSASexton then
				totalSASexton = totalSASexton + 1
			end				
			if unit.type == object.uSAMotorTroops then
				totalSABrenCarrier = totalSABrenCarrier + 1
			end	

			-- BRAZIL et AL
			if unit.type == object.uBraz1stInf then
				totalBraz1stInf = totalBraz1stInf + 1
			end				
			if unit.type == object.uGreekMtnBde then
				totalGreekMtnBde = totalGreekMtnBde + 1
			end	
			if unit.type == object.uJewishBde then
				totalJewishBde = totalJewishBde + 1
			end				

			-- FRENCH
			if unit.type == object.uInfanterieColoniale then
				totalInfanterieColoniale = totalInfanterieColoniale + 1
			end	
			if unit.type == object.uGoumierMarocain then
				totalGoumierMarocain = totalGoumierMarocain + 1
			end	
			if unit.type == object.uTirailleurAlgerien then
				totalTirailleurAlgrien = totalTirailleurAlgrien + 1
			end	
			if unit.type == object.uFreeFrenchInfantry then
				totalFreeFrenchInfantry = totalFreeFrenchInfantry + 1
			end				
			if unit.type == object.uFreeFrench105Art then
				totalFreeFrench105Art = totalFreeFrench105Art + 1
			end				
			if unit.type == object.uFreeFrenchM10 then
				totalFreeFrenchM10 = totalFreeFrenchM10 + 1
			end	

			-- POLISH
			if unit.type == object.uPolishShermanIII then
				totalPolishSherman = totalPolishSherman + 1
			end	
			if unit.type == object.uPolishInfantry then
				totalPolishInfantry = totalPolishInfantry + 1
			end				
			if unit.type == object.uPolish25pdrArt then
				totalPolish25pdrArt = totalPolish25pdrArt + 1
			end	

			-- ROYAL NAVY & USN ===========================
			if unit.type == object.uTribalClassDD then
				totalDestroyers = totalDestroyers + 1
			end
			if unit.type == object.uLeanderClassCL then
				totalLightCruiser = totalLightCruiser + 1
			end
			if unit.type == object.uYorkClassCA then
				totalHeavyCruisers = totalHeavyCruisers + 1
			end
			if unit.type == object.uSClass then
				totalSubmarines = totalSubmarines + 1
			end
			if unit.type == object.uLibertyShip then
				totalLibertyShips = totalLibertyShips + 1
			end
			if unit.type == object.uDUKW then
				totalDUKW = totalDUKW + 1
			end
			if unit.type == object.uOilTankerE or unit.type == object.uOilTankerF then
				totalOilTankers = totalOilTankers + 1
			end
			
		end
	end	

    menuType = menuType or "menu1" -- menu1 is the default menu
	
    -- MAIN MENU ========================================
	if menuType == "menu1" then
	
        local menuText = "Do you wish to procure replacements?"
        -- local menuTable = {"Yes, procure American replacements.","Yes, procure British replacements.","Yes, procure Commonwealth replacements.","No, do not procure replacements."}
        local menuOptions = {[1]="Yes, procure American replacements.", [2]="Yes, procure British replacements.", [3]="Yes, procure Allied Minor replacements.", [4]="Yes, procure Royal Navy replacements.", [5]="No, do not procure replacements."}
		local menuImage = civ.ui.loadImage("Images\\AlliedReplacements.bmp")
		-- local choice = text.menu(menuTable,menuText,menuTitle,menuImage)
		local menu1choice = text.menu(menuOptions,menuText,"Allied Replacement Procurement",menuImage)
        if menu1choice == 1 then
            return smallNestedMenu("menu2")
        elseif menu1choice == 2 then
            return smallNestedMenu("menu3")
        elseif menu1choice == 3 then
            return smallNestedMenu("menu4")
        elseif menu1choice == 4 then
            return smallNestedMenu("menu5")
        elseif menu1choice == 5 then
            return 
        end
    end
	
    -- AMERICAN REPLACEMENTS MENU ========================================
	if menuType == "menu2" then
	
        local menuText = "American Replacements: ".. object.pAllies.money.." supplies available"
		-- local menuTable = {"Fighters","Bombers","Armored","Infantry","Artillery","Return to main menu!"}
        -- local menuOptions = {[1]="Fighters: " .. tostring(param.maxtotalP40Warhawk - totalP40Warhawk) + tostring(param.maxtotalP38Lightning - totalP38Lightning) + tostring(param.maxtotalP51DMustang - totalP51DMustang) .. " available", [2]="Bombers", [3]="Armored", [4]="Infantry", [5]="Artillery", [6]="Return to main menu!", [7]="Exit procurement menu!"}
		local menuOptions = {}
		menuOptions[1]="Fighters:  " .. math.floor(tostring(counter.value("# P-40") - totalP40Warhawk) + tostring(counter.value("# P-38") - totalP38Lightning) + tostring(counter.value("# P-51") - totalP51DMustang)) .. "  available to build"
		menuOptions[2]="Bombers:  " .. math.floor(tostring(counter.value("# A-36") - totalA36Apache) + tostring(counter.value("# B-17") - totalB17Fortress) + tostring(counter.value("# B-24") - totalB24Liberator) + tostring(counter.value("# B-25") - totalB25Mitchell) + tostring(counter.value("# B-26") - totalB26Marauder)) .. "  available to build" 
		menuOptions[3]="Armored:  " .. math.floor(tostring(counter.value("# M8 Greyhound") - totalM8Greyhound) + tostring(counter.value("# Armored Infantry") - totalArmoredInfantry) + tostring(counter.value("# M5 Stuart") - totalM5Stuart) + tostring(counter.value("# M4A1") - totalM4A1Sherman) + tostring(counter.value("# M4A1 Ind") - totalM4A1ShermanInd) + tostring(counter.value("# M10 Wolverine") - totalM10Wolverine) + tostring(counter.value("# M4A3 (76)") - totalM4A376WSherman) + tostring(counter.value("# US Truck") - totalUSTruck) + tostring(counter.value("# Engineer") - totalEngineer)) .. "  available to build" 
		menuOptions[4]="Infantry:  " .. math.floor(tostring(counter.value("# 1st Infantry") - totalUS1stInfantry) + tostring(counter.value("# GI Veteran") - totalGIInfantryVet) + tostring(counter.value("# GI Regular") - totalGIInfantryReg) + tostring(counter.value("# US Bazooka") - totalUSBazooka) + tostring(counter.value("# US Ranger") - totalRanger) + tostring(counter.value("# 82nd Airborne") - total82ndAirborne) + tostring(counter.value("# 10th Mountain") - totalUS10thMountain) + tostring(counter.value("# US 442nd Regt") - totalUS442ndRegt)) .. "  available to build"  
		menuOptions[5]="Artillery:  " .. math.floor(tostring(counter.value("# M7 105mm HMC") - totalM7105mmHMC) + tostring(counter.value("# M12 155mm HMC") - totalM12155mmHMC) + tostring(counter.value("# US Bofors 40mm AA") - totalUSBofors40mmAA) + tostring(counter.value("# M2A1 105mm Art") - totalM2A1105mmArt) + tostring(counter.value("# M1 155mm Art") - totalM1155mmArt) + tostring(counter.value("# M1 57mm AT") - totalM157mmAT)) .. "  available to build"
		menuOptions[6]="Return to main menu!" 
		menuOptions[7]="Exit procurement menu!"
		local menu2choice = text.menu(menuOptions,menuText,"American Replacement Procurement")
        
		-- AMERICAN FIGHTERS
		if menu2choice == 1 then
         
			local menuTitle = "American Fighter Replacements"
			-- MENU CODE OPTION 1 - Straight forward menu option, i.e. all the menu options will always display
			--  local menuOptions = {
			--	[1]="" .. object.uP40Warhawk.name .. " at " .. param.replacementP40Cost .. " supplies: " .. tostring(counter.value("# P-40") - totalP40Warhawk) .. " available to build.", 
			--  [2]="" .. object.uP38Lightning.name .. " at " .. param.replacementP38Cost .. " supplies: " .. tostring(2 - totalP38Lightning) .. " available to build.", 
			--  [3]="" .. object.uP51DMustang.name .. " at " .. param.replacementP51Cost .. " supplies: " .. tostring(2 - totalP51DMustang) .. " available to build.", 
			--  [4]="No, do not procure a new fighter unit!"}
			
			-- MENU CODE OPTION 2 - Allows you to insert conditions within the menu if you want to prevent certain menu options from displaying
			local menuOptions = {}
			-- if totalP40Warhawk < param.maxtotalP40Warhawk then -- If totalP40Warhawk is 'less than' maximum # allowable P-40 fighters than do not display menu option
				-- menuOptions[1]="" .. object.uP40Warhawk.name .. " at " .. param.replacementP40Cost .. " supplies: " .. tostring(param.maxtotalP40Warhawk - totalP40Warhawk) .. " available to build."
			-- end
			menuOptions[1]="Return to American Replacements menu!"
			
			if totalP40Warhawk < counter.value("# P-40") then -- If totalP40Warhawk is 'less than' maximum # allowable P-40 fighters than do not display menu option
				menuOptions[2]="" .. object.uP40Warhawk.name .. " at " .. param.replacementP40Cost .. " supplies: " .. tostring(counter.value("# P-40") - totalP40Warhawk) .. " available to build."
			end
			if totalP38Lightning < counter.value("# P-38") then
				menuOptions[3]="" .. object.uP38Lightning.name .. " at " .. param.replacementP38Cost .. " supplies: " .. tostring(counter.value("# P-38") - totalP38Lightning) .. " available to build."
			end
			if totalP51DMustang < counter.value("# P-51") then
				menuOptions[4]="" .. object.uP51DMustang.name .. " at " .. param.replacementP51Cost .. " supplies: " .. tostring(counter.value("# P-51") - totalP51DMustang) .. " available to build."
			end
			-- menuOptions[4]="No, do not procure a new fighter unit!"
			menuOptions[5]="Return to main menu!"
			menuOptions[6]="Exit procurement menu!"
			
			local menuText = "Which type of unit do you wish to procure?\n^(Current stock of supplies: ".. object.pAllies.money..")"	
			local menu2choice_sub1 = text.menu(menuOptions,menuText,menuTitle)

			
			-- RETURN TO AMERICAN REPLACEMENTS MENU
			if menu2choice_sub1 == 1 then
				-- civ.ui.text("Don't procure any replacement fighters!")
				return smallNestedMenu("menu2")
			
			-- P-40 WARHAWK			
			elseif menu2choice_sub1 == 2 then
				if object.pAllies.money >= param.replacementP40Cost then
					-- INITIAL CODE using tile coordinates instead of city name in civ.ui.text line
					-- if totalP40Warhawk <= 1 then -- Cannot purchase unit if exceed maximum allowable
						-- gen.createUnit(object.uP40Warhawk, object.pAllies, {{32,136,0}, {0,136,0}}, {randomize=false, veteran=false})
						-- object.pAllies.money = object.pAllies.money - param.replacementP40Cost
						-- civ.ui.text("A new group of replacement " .. object.uP40Warhawk.name .. " fighters arrives in (" .. activeUnit.x .. "," .. activeUnit.y .. "," .. activeUnit.z .. ") at a cost of " .. param.replacementP40Cost .. " supplies!")

					-- ===================
					-- if totalP40Warhawk < param.maxtotalP40Warhawk then -- Cannot purchase unit if exceed maximum allowable
					if totalP40Warhawk < counter.value("# P-40") then
					local reinforcementsList = gen.createUnit(object.uP40Warhawk, object.pAllies, {{73,155,0}, {44,140,0}, {0,136,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacementP40Cost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A new group of replacement "..object.uP40Warhawk.name.." fighters arrives in "..reinforcementCity.name.." at a cost of "..param.replacementP40Cost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacementP40Cost)
								return smallNestedMenu("menu2")
							else
								text.simple("A new group of replacement " .. object.uP40Warhawk.name .. " fighters arrives at the airbase on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementP40Cost .. " supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")	
								counter.add("# Supplies Spent in Campaign",param.replacementP40Cost)
								return smallNestedMenu("menu2")
							end
						else
							text.simple("Our replacement "..object.uP40Warhawk.name.." fighters never arrived.")
						end	
					-- ===================
					
					else
						civ.ui.text("The current number of " .. totalP40Warhawk .. " '" .. object.uP40Warhawk.name .. "' equals the maximun allowed!")
						return smallNestedMenu("menu2")
					end
				else
					civ.ui.text("It requires " .. param.replacementP40Cost .. " supplies to procure a new " .. object.uP40Warhawk.name .. " group!")
					return smallNestedMenu("menu2")
				end
			-- end	

			-- P-38 LIGHTNING	
			elseif menu2choice_sub1 == 3 then
				if object.pAllies.money >= param.replacementP38Cost then
					-- ===================
					if totalP38Lightning < counter.value("# P-38") then -- Cannot purchase unit if exceed maximum allowable
					local reinforcementsList = gen.createUnit(object.uP38Lightning, object.pAllies, {{73,155,0}, {44,140,0}, {0,136,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacementP38Cost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A new group of replacement "..object.uP38Lightning.name.." fighters arrives in "..reinforcementCity.name.." at a cost of "..param.replacementP38Cost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacementP38Cost)
								return smallNestedMenu("menu2")
							else
								text.simple("A new group of replacement " .. object.uP38Lightning.name .. " fighters arrives at the airbase on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementP38Cost .. " supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")	
								counter.add("# Supplies Spent in Campaign",param.replacementP38Cost)
								return smallNestedMenu("menu2")
							end
						else
							text.simple("Our replacement "..object.uP38Lightning.name.." fighters never arrived.")
							return smallNestedMenu("menu2")
						end	
					-- ===================					
					else
						civ.ui.text("The current number of " .. totalP38Lightning .. " '" .. object.uP38Lightning.name .. "' equals the maximun allowed!")
						return smallNestedMenu("menu2")
					end
				else
					civ.ui.text("It requires " .. param.replacementP38Cost .. " supplies to procure a new " .. object.uP38Lightning.name .. " group!")
					return smallNestedMenu("menu2")
				end
			
			-- P-51 MUSTANG
			elseif menu2choice_sub1 == 4 then
				if object.pAllies.money >= param.replacementP51Cost then
					-- ===================
					if totalP51DMustang < counter.value("# P-51") then -- Cannot purchase unit if exceed maximum allowable
					local reinforcementsList = gen.createUnit(object.uP51DMustang, object.pAllies, {{73,155,0}, {44,140,0}, {0,136,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacementP51Cost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A new group of replacement "..object.uP51DMustang.name.." fighters arrives in "..reinforcementCity.name.." at a cost of "..param.replacementP51Cost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacementP51Cost)
								return smallNestedMenu("menu2")
							else
								text.simple("A new group of replacement " .. object.uP51DMustang.name .. " fighters arrives at the airbase on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementP51Cost .. " supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")	
								counter.add("# Supplies Spent in Campaign",param.replacementP51Cost)
								return smallNestedMenu("menu2")
							end
						else
							text.simple("Our replacement "..object.uP51DMustang.name.." fighters never arrived.")
							return smallNestedMenu("menu2")
						end	
					-- ===================						
					else
						civ.ui.text("The current number of " .. totalP51DMustang .. " '" .. object.uP51DMustang.name .. "' equals the maximun allowed!")
						return smallNestedMenu("menu2")
					end
				else
					civ.ui.text("It requires " .. param.replacementP51Cost .. " supplies to procure a new " .. object.uP51DMustang.name .. " group!")
					return smallNestedMenu("menu2")
				end
			
			-- EXIT MENUS
			elseif menu2choice_sub1 == 5 then
				-- civ.ui.text("Return to main menu!")
				return smallNestedMenu("menu1")
				-- civ.ui.text("Exit procurement menu!")
			elseif menu2choice_sub1 == 6 then
				return 
			end	
			
			
		-- AMERICAN BOMBERS	
		elseif menu2choice == 2 then

			local menuTitle = "American Bomber Replacements"
			local menuOptions = {}
			menuOptions[1]="Return to American Replacements menu!"
			
			if totalA36Apache < counter.value("# A-36") then
				menuOptions[2]="" .. object.uA36Apache.name .. " at " .. param.replacementA36Cost .. " supplies: " .. tostring(counter.value("# A-36") - totalA36Apache) .. " available to build." 
			end
			if totalB17Fortress < counter.value("# B-17") then
				menuOptions[3]="" .. object.uB17Fortress.name .. " at " .. param.replacementB17Cost .. " supplies: ".. tostring(counter.value("# B-17") - totalB17Fortress) .. " available to build." 
			end
			if totalB24Liberator < counter.value("# B-24") then
				menuOptions[4]="" .. object.uB24Liberator.name .. " at " .. param.replacementB24Cost .. " supplies: " .. tostring(counter.value("# B-24") - totalB24Liberator) .. " available to build."  
			end
			if totalB25Mitchell < counter.value("# B-25") then
				menuOptions[5]="" .. object.uB25Mitchell.name .. " at " .. param.replacementB25Cost .. " supplies: " .. tostring(counter.value("# B-25") - totalB25Mitchell) .. " available to build."  
			end
			if totalB26Marauder < counter.value("# B-26") then
				menuOptions[6]="" .. object.uB26Marauder.name .. " at " .. param.replacementB26Cost .. " supplies: " .. tostring(counter.value("# B-26") - totalB26Marauder) .. " available to build."  
			end
			
			menuOptions[7]="Return to main menu!"
			menuOptions[8]="Exit procurement menu!"
			
			local menuText = "Which type of unit do you wish to procure?\n^(Current stock of supplies: ".. object.pAllies.money..")"	
			local menu2choice_sub2 = text.menu(menuOptions,menuText,menuTitle)
			
			
			-- RETURN TO AMERICAN REPLACEMENTS MENU
			if menu2choice_sub2 == 1 then
				-- civ.ui.text("Don't procure any replacement bombers!")
				return smallNestedMenu("menu2")

			-- A-36 APACHE
			elseif menu2choice_sub2 == 2 then
				-- TEST EXAMPLE WHERE PURCHASE CANNOT EXCEED MAXIMUM NUMBER OF ALLOWABLE BOMBERS
				if object.pAllies.money >= param.replacementA36Cost then
					if totalA36Apache < counter.value("# A-36") then -- Cannot purchase unit if exceed maximum allowable
					-- ===================	
					local reinforcementsList = gen.createUnit(object.uA36Apache, object.pAllies, {{73,155,0}, {44,140,0}, {0,136,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacementA36Cost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A new group of replacement "..object.uA36Apache.name.." fighter-bombers arrives in "..reinforcementCity.name.." at a cost of "..param.replacementA36Cost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacementA36Cost)
								return smallNestedMenu("menu2")
							else
								civ.ui.text("A new group of replacement " .. object.uA36Apache.name .. " fighter-bombers arrives at the airbase on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementA36Cost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacementA36Cost)
								return smallNestedMenu("menu2")
							end
						else
							text.simple("Our replacement "..object.uA36Apache.name.." fighter-bombers never arrived.")
						end	
					-- ===================					
					else
						civ.ui.text("The current number of " .. totalA36Apache .. " '" .. object.uA36Apache.name .. "' equals the maximun allowed!")
					end
				else
					civ.ui.text("It requires " .. param.replacementA36Cost .. " supplies to procure a new " .. object.uA36Apache.name .. " group!")
					return smallNestedMenu("menu2")
				end
			
			-- B-17 FORTRESS
			elseif menu2choice_sub2 == 3 then
				if object.pAllies.money >= param.replacementB17Cost then
					if totalB17Fortress < counter.value("# B-17") then
					-- ===================	
					local reinforcementsList = gen.createUnit(object.uB17Fortress, object.pAllies, {{44,140,0}, {0,136,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacementB17Cost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A new group of replacement "..object.uB17Fortress.name.." bombers arrives in "..reinforcementCity.name.." at a cost of "..param.replacementB17Cost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacementB17Cost)
								return smallNestedMenu("menu2")
							else
								civ.ui.text("A new group of replacement " .. object.uB17Fortress.name .. " bombers arrives at the airbase on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementB17Cost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacementB17Cost)
								return smallNestedMenu("menu2")
							end
						else
							text.simple("Our replacement "..object.uB17Fortress.name.." bombers never arrived.")
						end	
					-- ===================							
					else
						civ.ui.text("The current number of " .. totalB17Fortress .. " '" .. object.uB17Fortress.name .. "' equals the maximun allowed!")
					end
				else
					civ.ui.text("It requires " .. param.replacementB17Cost .. " supplies to procure a new " .. object.uB17Fortress.name .. " group!")
					return smallNestedMenu("menu2")
				end
			
			-- B-24 LIBERATOR
			elseif menu2choice_sub2 == 4 then
				if object.pAllies.money >= param.replacementB24Cost then
					if totalB24Liberator < counter.value("# B-24") then
					-- ===================	
					local reinforcementsList = gen.createUnit(object.uB24Liberator, object.pAllies, {{44,140,0}, {0,136,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacementB24Cost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A new group of replacement "..object.uB24Liberator.name.." bombers arrives in "..reinforcementCity.name.." at a cost of "..param.replacementB24Cost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacementB24Cost)
								return smallNestedMenu("menu2")
							else
								civ.ui.text("A new group of replacement " .. object.uB24Liberator.name .. " bombers arrives at the airbase on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementB24Cost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacementB24Cost)
								return smallNestedMenu("menu2")
							end
						else
							text.simple("Our replacement "..object.uB24Liberator.name.." bombers never arrived.")
						end	
					-- ===================						
					else
						civ.ui.text("The current number of " .. totalB24Liberator .. " '" .. object.uB24Liberator.name .. "' equals the maximun allowed!")
					end
				else
					civ.ui.text("It requires " .. param.replacementB24Cost .. " supplies to procure a new " .. object.uB24Liberator.name .. " group!")
					return smallNestedMenu("menu2")
				end
			
			-- B-25 MITCHELL
			elseif menu2choice_sub2 == 5 then
				if object.pAllies.money >= param.replacementB25Cost then
					if totalB25Mitchell < counter.value("# B-25") then
					-- ===================	
					local reinforcementsList = gen.createUnit(object.uB25Mitchell, object.pAllies, {{44,140,0}, {0,136,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacementB25Cost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A new group of replacement "..object.uB25Mitchell.name.." bombers arrives in "..reinforcementCity.name.." at a cost of "..param.replacementB25Cost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacementB25Cost)
								return smallNestedMenu("menu2")
							else
								civ.ui.text("A new group of replacement " .. object.uB25Mitchell.name .. " bombers arrives at the airbase on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementB25Cost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacementB25Cost)
								return smallNestedMenu("menu2")
							end
						else
							text.simple("Our replacement "..object.uB25Mitchell.name.." bombers never arrived.")
						end	
					-- ===================						
					else
						civ.ui.text("The current number of " .. totalB25Mitchell .. " '" .. object.uB25Mitchell.name .. "' equals the maximun allowed!")
					end
				else
					civ.ui.text("It requires " .. param.replacementB25Cost .. " supplies to procure a new " .. object.uB25Mitchell.name .. " group!")
					return smallNestedMenu("menu2")
				end
			
			-- B-26 MARAUDER
			elseif menu2choice_sub2 == 6 then
				-- TEST EXAMPLE WHERE BOMBER UNIT ALSO REQUIRES A PREREQUISITE ADVANCE
				if object.pAllies.money >= param.replacementB26Cost then
					if civ.hasTech(object.pAllies, object.aSACAirForce) then -- Requires SAC AIR FORCE tech
						if totalB26Marauder < counter.value("# B-26") then
						-- ===================	
						local reinforcementsList = gen.createUnit(object.uB26Marauder, object.pAllies, {{44,140,0}, {0,136,0}}, {randomize=false, veteran=false})
							if reinforcementsList[1] then -- make sure there is actually a reinforcement created
								object.pAllies.money = object.pAllies.money - param.replacementB26Cost
								local firstUnit = reinforcementsList[1]
								local reinforcementCity = firstUnit.location.city
								if reinforcementCity then
									text.simple("A new group of replacement "..object.uB26Marauder.name.." bombers arrives in "..reinforcementCity.name.." at a cost of "..param.replacementB26Cost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
									counter.add("# Supplies Spent in Campaign",param.replacementB26Cost)
									return smallNestedMenu("menu2")
								else
									civ.ui.text("A new group of replacement " .. object.uB26Marauder.name .. " bombers arrives at the airbase on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementB26Cost .. " supplies!")	
									counter.add("# Supplies Spent in Campaign",param.replacementB26Cost)
									return smallNestedMenu("menu2")
								end
							else
								text.simple("Our replacement "..object.uB26Marauder.name.." bombers never arrived.")
							end	
						-- ===================							
						else
							civ.ui.text("The current number of " .. totalB26Marauder .. " '" .. object.uB26Marauder.name .. "' equals the maximun allowed!")
						end
					else
						civ.ui.text("You require the '" .. object.aSACAirForce.name .. "' advance to procure a new " .. object.uB26Marauder.name .. " replacement group!")
					end
				else
					civ.ui.text("It requires " .. param.replacementB26Cost .. " supplies to procure a new " .. object.uB26Marauder.name .. " group!")
					return smallNestedMenu("menu2")
				end
			
			-- EXIT MENUS	

			elseif menu2choice_sub2 == 7 then
				-- civ.ui.text("Return to main menu!")
				return smallNestedMenu("menu1")				
			elseif menu2choice_sub2 == 8 then
				-- civ.ui.text("Exit procurement menu!")
				return 
			end	
	
 		-- AMERICAN ARMORED
		elseif menu2choice == 3 then

			local menuTitle = "American Armored Replacements"
			local menuOptions = {}
			menuOptions[1]="Return to American Replacements menu!"

			if totalM8Greyhound < counter.value("# M8 Greyhound") then
				menuOptions[2]="" .. object.uM8Greyhound.name .. " at " .. param.replacementM8Cost .. " supplies: " .. tostring(counter.value("# M8 Greyhound") - totalM8Greyhound) .. " available to build."
			end
			if totalArmoredInfantry < counter.value("# Armored Infantry") and flag.value("US Armored Division is Active") == true then
				menuOptions[3]="" .. object.uArmoredInfantry.name .. " at " .. param.replacementArmInfCost .. " supplies: ".. tostring(counter.value("# Armored Infantry") - totalArmoredInfantry) .. " available to build."
			end
			if totalM5Stuart < counter.value("# M5 Stuart") and flag.value("US Armored Division is Active") == true then
				menuOptions[4]="" .. object.uM5Stuart.name .. " at " .. param.replacementM5Cost .. " supplies: " .. tostring(counter.value("# M5 Stuart") - totalM5Stuart) .. " available to build."  
			end
			if totalM4A1Sherman < counter.value("# M4A1") and flag.value("US Armored Division is Active") == true  then
				menuOptions[5]="" .. object.uM4A1Sherman.name .. " at " .. param.replacementM4A1Cost .. " supplies: " .. tostring(counter.value("# M4A1") - totalM4A1Sherman) .. " available to build." 
			end
			if totalM4A1ShermanInd < counter.value("# M4A1 Ind") then
				menuOptions[6]="" .. object.uM4A1ShermanInd.name .. " at " .. param.replacementM4A1IndCost .. " supplies: " .. tostring(counter.value("# M4A1 Ind") - totalM4A1ShermanInd) .. " available to build." 
			end
			if totalM10Wolverine < counter.value("# M10 Wolverine") then
				menuOptions[7]="" .. object.uM10Wolverine.name .. " at " .. param.replacementM10Cost .. " supplies: " .. tostring(counter.value("# M10 Wolverine") - totalM10Wolverine) .. " available to build."
			end
			if totalM4A376WSherman < counter.value("# M4A3 (76)") and flag.value("M4A3 76(W) enters US armor inventory") == true then
				menuOptions[8]="" .. object.uM4A376WSherman.name .. " at " .. param.replacementM4A3Cost .. " supplies: " .. tostring(counter.value("# M4A3 (76)") - totalM4A376WSherman) .. " available to build."
			end
			if totalUSTruck < counter.value("# US Truck") then
				menuOptions[9]="" .. object.uUSTruck.name .. " at " .. param.replacementUSTruckCost .. " supplies: " .. tostring(counter.value("# US Truck") - totalUSTruck) .. " available to build."
			end
			if totalEngineer < counter.value("# Engineer") then
				menuOptions[10]="" .. object.uEngineer.name .. " at " .. param.replacementEngineerCost .. " supplies: " .. tostring(counter.value("# Engineer") - totalEngineer) .. " available to build."
			end

			menuOptions[11]="Return to main menu!"
			menuOptions[12]="Exit procurement menu!"
			
			local menuText = "Which type of unit do you wish to procure?\n^(Current stock of supplies: ".. object.pAllies.money..")"	
			local menu2choice_sub3 = text.menu(menuOptions,menuText,menuTitle)

			-- RETURN TO AMERICAN REPLACEMENTS MENU
			if menu2choice_sub3 == 1 then
				-- civ.ui.text("Don't procure any replacement armored!")
				return smallNestedMenu("menu2")		
				
			-- M-8 GREYHOUND
			elseif menu2choice_sub3 == 2 then
				if object.pAllies.money >= param.replacementM8Cost then
					if totalM8Greyhound < counter.value("# M8 Greyhound") then -- Cannot purchase unit if exceed maximum allowable
					-- ===================	
					local reinforcementsList = gen.createUnit(object.uM8Greyhound, object.pAllies, {{44,140,0}, {0,136,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacementM8Cost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A battalion of new "..object.uM8Greyhound.name.." arrives in "..reinforcementCity.name.." at a cost of "..param.replacementM8Cost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacementM8Cost)
								return smallNestedMenu("menu2")
							else
								civ.ui.text("A battalion of new " .. object.uM8Greyhound.name .. " arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementM8Cost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacementM8Cost)
								return smallNestedMenu("menu2")
							end
						else
							text.simple("Our replacement "..object.uM8Greyhound.name.." unit never arrived.")
						end	
					-- ===================						
					else
						civ.ui.text("The current number of " .. totalM8Greyhound .. " '" .. object.uM8Greyhound.name .. "' equals the maximun allowed!")
					end
				else
					civ.ui.text("It requires " .. param.replacementM8Cost .. " supplies to procure a new " .. object.uM8Greyhound.name .. " unit!")
					return smallNestedMenu("menu2")
				end
			
			-- ARMORED INFANTRY
			elseif menu2choice_sub3 == 3 then
				if object.pAllies.money >= param.replacementArmInfCost then
					if totalArmoredInfantry < counter.value("# Armored Infantry") then -- Cannot purchase unit if exceed maximum allowable
					-- ===================	
					local reinforcementsList = gen.createUnit(object.uArmoredInfantry, object.pAllies, {{44,140,0}, {0,136,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacementArmInfCost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A battalion of new "..object.uArmoredInfantry.name.." arrives in "..reinforcementCity.name.." at a cost of "..param.replacementArmInfCost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacementArmInfCost)
								return smallNestedMenu("menu2")
							else
								civ.ui.text("A battalion of new " .. object.uArmoredInfantry.name .. " arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementArmInfCost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacementArmInfCost)
								return smallNestedMenu("menu2")
							end
						else
							text.simple("Our replacement "..object.uArmoredInfantry.name.." unit never arrived.")
						end	
					-- ===================	
					else
						civ.ui.text("The current number of " .. totalArmoredInfantry .. " '" .. object.uArmoredInfantry.name .. "' equals the maximun allowed!")
					end
				else
					civ.ui.text("It requires " .. param.replacementArmInfCost .. " supplies to procure a new " .. object.uArmoredInfantry.name .. " unit!")
					return smallNestedMenu("menu2")
				end			
			
			-- M5 STUART
			elseif menu2choice_sub3 == 4 then
				if object.pAllies.money >= param.replacementM5Cost then
					if totalM5Stuart < counter.value("# M5 Stuart") then -- Cannot purchase unit if exceed maximum allowable
					-- ===================	
					local reinforcementsList = gen.createUnit(object.uM5Stuart, object.pAllies, {{44,140,0}, {0,136,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacementM5Cost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A battalion of new "..object.uM5Stuart.name.." tanks arrives in "..reinforcementCity.name.." at a cost of "..param.replacementM5Cost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacementM5Cost)
								return smallNestedMenu("menu2")
							else
								civ.ui.text("A battalion of new " .. object.uM5Stuart.name .. " tanks arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementM5Cost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacementM5Cost)
								return smallNestedMenu("menu2")
							end
						else
							text.simple("Our replacement "..object.uM5Stuart.name.." tanks never arrived.")
						end	
					-- ===================						
					else
						civ.ui.text("The current number of " .. totalM5Stuart .. " '" .. object.uM5Stuart.name .. "' equals the maximun allowed!")
					end
				else
					civ.ui.text("It requires " .. param.replacementM5Cost .. " supplies to procure a new " .. object.uM5Stuart.name .. " unit!")
					return smallNestedMenu("menu2")
				end				
			
			-- M1A1 SHERMAN
			elseif menu2choice_sub3 == 5 then
				if object.pAllies.money >= param.replacementM4A1Cost then
					if totalM4A1Sherman < counter.value("# M4A1") then -- Cannot purchase unit if exceed maximum allowable
					-- ===================	
					local reinforcementsList = gen.createUnit(object.uM4A1Sherman, object.pAllies, {{44,140,0}, {0,136,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacementM4A1Cost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A battalion of new "..object.uM4A1Sherman.name.." tanks arrives in "..reinforcementCity.name.." at a cost of "..param.replacementM4A1Cost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacementM4A1Cost)
								return smallNestedMenu("menu2")
							else
								civ.ui.text("A battalion of new " .. object.uM4A1Sherman.name .. " tanks arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementM4A1Cost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacementM4A1Cost)
								return smallNestedMenu("menu2")
							end
						else
							text.simple("Our replacement "..object.uM4A1Sherman.name.." tanks never arrived.")
						end	
					-- ===================						
					else
						civ.ui.text("The current number of " .. totalM4A1Sherman .. " '" .. object.uM4A1Sherman.name .. "' equals the maximun allowed!")
					end
				else
					civ.ui.text("It requires " .. param.replacementM4A1Cost .. " supplies to procure a new " .. object.uM4A1Sherman.name .. " unit!")
					return smallNestedMenu("menu2")
				end	

			-- M1A1 SHERMAN IND
			elseif menu2choice_sub3 == 6 then
				if object.pAllies.money >= param.replacementM4A1IndCost then
					if totalM4A1ShermanInd < counter.value("# M4A1 Ind") then -- Cannot purchase unit if exceed maximum allowable
					-- ===================	
					local reinforcementsList = gen.createUnit(object.uM4A1ShermanInd, object.pAllies, {{44,140,0}, {0,136,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacementM4A1IndCost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A battalion of new "..object.uM4A1ShermanInd.name.." tanks arrives in "..reinforcementCity.name.." at a cost of "..param.replacementM4A1IndCost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacementM4A1IndCost)
								return smallNestedMenu("menu2")
							else
								civ.ui.text("A battalion of new " .. object.uM4A1ShermanInd.name .. " tanks arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementM4A1IndCost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacementM4A1IndCost)
								return smallNestedMenu("menu2")
							end
						else
							text.simple("Our replacement "..object.uM4A1ShermanInd.name.." tanks never arrived.")
						end	
					-- ===================						
					else
						civ.ui.text("The current number of " .. totalM4A1ShermanInd .. " '" .. object.uM4A1ShermanInd.name .. "' equals the maximun allowed!")
					end
				else
					civ.ui.text("It requires " .. param.replacementM4A1IndCost .. " supplies to procure a new " .. object.uM4A1ShermanInd.name .. " unit!")
					return smallNestedMenu("menu2")
				end					
			
			-- M10 WOLVERINE
			elseif menu2choice_sub3 == 7 then
				if object.pAllies.money >= param.replacementM10Cost then
					if totalM10Wolverine < counter.value("# M10 Wolverine") then -- Cannot purchase unit if exceed maximum allowable
					-- ===================	
					local reinforcementsList = gen.createUnit(object.uM10Wolverine, object.pAllies, {{44,140,0}, {0,136,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacementM10Cost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A battalion of new "..object.uM10Wolverine.name.." tank-destroyers arrives in "..reinforcementCity.name.." at a cost of "..param.replacementM10Cost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacementM10Cost)
								return smallNestedMenu("menu2")
							else
								civ.ui.text("A battalion of new " .. object.uM10Wolverine.name .. " tank-destroyers arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementM10Cost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacementM10Cost)
								return smallNestedMenu("menu2")
							end
						else
							text.simple("Our replacement "..object.uM10Wolverine.name.." tank-destroyers never arrived.")
						end	
					-- ===================		
					else
						civ.ui.text("The current number of " .. totalM10Wolverine .. " '" .. object.uM10Wolverine.name .. "' equals the maximun allowed!")
					end
				else
					civ.ui.text("It requires " .. param.replacementM10Cost .. " supplies to procure a new " .. object.uM10Wolverine.name .. " unit!")
					return smallNestedMenu("menu2")
				end	
			
			-- M4A3 76(W) SHERMAN
			elseif menu2choice_sub3 == 8 then
				-- EXAMPLE WHERE ARMORED UNIT ALSO REQUIRES A PREREQUISITE ADVANCE
				if object.pAllies.money >= param.replacementM4A3Cost then
					if civ.hasTech(object.pAllies, object.aUSArmor) then -- Requires SAC AIR FORCE tech
						if totalM4A376WSherman < counter.value("# M4A3 (76)") then
						-- ===================	
						local reinforcementsList = gen.createUnit(object.uM4A376WSherman, object.pAllies, {{44,140,0}, {0,136,0}}, {randomize=false, veteran=false})
							if reinforcementsList[1] then -- make sure there is actually a reinforcement created
								object.pAllies.money = object.pAllies.money - param.replacementM4A3Cost
								local firstUnit = reinforcementsList[1]
								local reinforcementCity = firstUnit.location.city
								if reinforcementCity then
									text.simple("A battalion of new "..object.uM4A376WSherman.name.." tanks arrives in "..reinforcementCity.name.." at a cost of "..param.replacementM4A3Cost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
									counter.add("# Supplies Spent in Campaign",param.replacementM4A3Cost)
									return smallNestedMenu("menu2")
								else
									civ.ui.text("A battalion of new " .. object.uM4A376WSherman.name .. " tanks arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementM4A3Cost .. " supplies!")	
									counter.add("# Supplies Spent in Campaign",param.replacementM4A3Cost)
									return smallNestedMenu("menu2")
								end
							else
								text.simple("Our replacement "..object.uM4A376WSherman.name.." tanks never arrived.")
							end	
						-- ===================	
						else
							civ.ui.text("The current number of " .. totalM4A376WSherman .. " '" .. object.uM4A376WSherman.name .. "' equals the maximun allowed!")
						end
					else
						civ.ui.text("You require the '" .. object.aUSArmor.name .. "' advance to procure a new " .. object.uM4A376WSherman.name .. " replacement unit!")
					end
				else
					civ.ui.text("It requires " .. param.replacementM4A3Cost .. " supplies to procure a new " .. object.uM4A376WSherman.name .. " unit!")
					return smallNestedMenu("menu2")
				end			
			
			-- US TRUCK
			elseif menu2choice_sub3 == 9 then
				if object.pAllies.money >= param.replacementUSTruckCost then
					-- if totalUSTruck < counter.value("# US Truck") then -- Cannot purchase unit if exceed maximum allowable
					-- ===================	
					local reinforcementsList = gen.createUnit(object.uUSTruck, object.pAllies, {{73,155,0}, {44,140,0}, {0,136,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacementUSTruckCost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A regiment of new "..object.uUSTruck.name.." arrives in "..reinforcementCity.name.." at a cost of "..param.replacementUSTruckCost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacementUSTruckCost)
								return smallNestedMenu("menu2")
							else
								civ.ui.text("A regiment of new " .. object.uUSTruck.name .. " arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementUSTruckCost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacementUSTruckCost)
								return smallNestedMenu("menu2")
							end
						else
							text.simple("Our replacement "..object.uUSTruck.name.." unit never arrived.")
						end	
					-- ===================						
					-- else
						-- civ.ui.text("The current number of " .. totalUSTruck .. " '" .. object.uUSTruck.name .. "' equals the maximun allowed!")
					-- end
				else
					civ.ui.text("It requires " .. param.replacementUSTruckCost .. " supplies to procure a new " .. object.uUSTruck.name .. " unit!")
					return smallNestedMenu("menu2")
				end
			
			-- ENGINEER
			elseif menu2choice_sub3 == 10 then
				if object.pAllies.money >= param.replacementEngineerCost then
					-- if totalEngineer < counter.value("# Engineer") then -- Cannot purchase unit if exceed maximum allowable
					-- ===================	
					local reinforcementsList = gen.createUnit(object.uEngineer, object.pAllies, {{73,155,0}, {62,162,0}, {40,180,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacementEngineerCost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A regiment of new "..object.uEngineer.name.." arrives in "..reinforcementCity.name.." at a cost of "..param.replacementEngineerCost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacementEngineerCost)
								return smallNestedMenu("menu2")
							else
								civ.ui.text("A regiment of new " .. object.uEngineer.name .. " arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementEngineerCost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacementEngineerCost)
								return smallNestedMenu("menu2")
							end
						else
							text.simple("Our replacement "..object.uEngineer.name.." unit never arrived.")
						end	
					-- ===================						
					-- else
						-- civ.ui.text("The current number of " .. totalEngineer .. " '" .. object.uEngineer.name .. "' equals the maximun allowed!")
					-- end
				else
					civ.ui.text("It requires " .. param.replacementEngineerCost .. " supplies to procure a new " .. object.uEngineer.name .. " unit!")
					return smallNestedMenu("menu2")
				end
								
			-- EXIT MENUS	
			elseif menu2choice_sub3 == 11 then
				-- civ.ui.text("Return to main menu!")
				return smallNestedMenu("menu1")
			elseif menu2choice_sub3 == 12 then
				-- civ.ui.text("Exit procurement menu!")
				return 
			end	
			
		-- AMERICAN INFANTRY
		elseif menu2choice == 4 then

			local menuTitle = "American Infantry Replacements"
			local menuOptions = {}
			
			menuOptions[1]="Return to American Replacements menu!"
			if totalUS1stInfantry < counter.value("# 1st Infantry") and flag.value("1st Infantry units withdrawn") == false then
				menuOptions[2]="" .. object.uUS1stInfantry.name .. " at " .. param.replacement1stInfCost .. " supplies: " .. tostring(counter.value("# 1st Infantry") - totalUS1stInfantry) .. " available to build." 
			end
			if totalGIInfantryVet < counter.value("# GI Veteran") and flag.value("Veteran US Infantry units withdrawn") == false then
				menuOptions[3]="" .. object.uGIVeteran.name .. " at " .. param.replacementGIVetCost .. " supplies: " .. tostring(counter.value("# GI Veteran") - totalGIInfantryVet) .. " available to build." 
			end
			if totalGIInfantryReg < counter.value("# GI Regular") then
				menuOptions[4]="" .. object.uGIRegular.name .. " at " .. param.replacementGIRegCost .. " supplies: " .. tostring(counter.value("# GI Regular") - totalGIInfantryReg) .. " available to build." 
			end
			if totalUSBazooka < counter.value("# US Bazooka") then
				menuOptions[5]="" .. object.uUSBazooka.name .. " at " .. param.replacementBazookaCost .. " supplies: ".. tostring(counter.value("# US Bazooka") - totalUSBazooka) .. " available to build." 
			end
			if totalRanger < counter.value("# US Ranger") and flag.value("Ranger units withdrawn") == false then
				menuOptions[6]="" .. object.uRanger.name .. " at " .. param.replacementRangerCost .. " supplies: " .. tostring(counter.value("# US Ranger") - totalRanger) .. " available to build."  
			end
			if total82ndAirborne < counter.value("# 82nd Airborne") and flag.value("82nd Airborne units withdrawn") == false then
				menuOptions[7]="" .. object.u82ndAirborne.name .. " at " .. param.replacement82ndCost .. " supplies: " .. tostring(counter.value("# 82nd Airborne") - total82ndAirborne) .. " available to build."  
			end
			if totalUS10thMountain < counter.value("# 10th Mountain") and flag.value("10th Mountain units arrive") == true then
				menuOptions[8]="" .. object.uUS10thMountain.name .. " at " .. param.replacement82ndCost .. " supplies: " .. tostring(counter.value("# 10th Mountain") - totalUS10thMountain) .. " available to build."  
			end
			if totalUS442ndRegt < counter.value("# US 442nd Regt") then
				menuOptions[9]="" .. object.uUS442ndRegt.name .. " at " .. param.replacement442ndCost .. " supplies: " .. tostring(counter.value("# US 442nd Regt") - totalUS442ndRegt) .. " available to build."  
			end
			
			menuOptions[10]="Return to main menu!"
			menuOptions[11]="Exit procurement menu!"
			
			local menuText = "Which type of unit do you wish to procure?\n^(Current stock of supplies: ".. object.pAllies.money..")"	
			local menu2choice_sub4 = text.menu(menuOptions,menuText,menuTitle)
		
			
			-- RETURN TO AMERICAN REPLACEMENTS MENU
			if menu2choice_sub4 == 1 then
				-- civ.ui.text("Don't procure any replacement infantry!")
				return smallNestedMenu("menu2")			
			
			-- 1st INFANTRY
			elseif menu2choice_sub4 == 2 then
				if object.pAllies.money >= param.replacement1stInfCost then
					-- if totalUS1stInfantry < counter.value("# 1st Infantry") then -- Cannot purchase unit if exceed maximum allowable
					-- ===================	
					local reinforcementsList = gen.createUnit(object.uUS1stInfantry, object.pAllies, {{44,140,0}, {0,136,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacement1stInfCost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A regiment of new "..object.uUS1stInfantry.name.." arrives in "..reinforcementCity.name.." at a cost of "..param.replacement1stInfCost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacement1stInfCost)
								return smallNestedMenu("menu2")
							else
								civ.ui.text("A regiment of new " .. object.uUS1stInfantry.name .. " arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacement1stInfCost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacement1stInfCost)
								return smallNestedMenu("menu2")
							end
						else
							text.simple("Our replacement "..object.uUS1stInfantry.name.." never arrived.")
						end	
					-- ===================	
					-- else
						-- civ.ui.text("The current number of " .. totalUS1stInfantry .. " '" .. object.uUS1stInfantry.name .. "' equals the maximun allowed!")
					-- end
				else
					civ.ui.text("It requires " .. param.replacement1stInfCost .. " supplies to procure a new " .. object.uUS1stInfantry.name .. " unit!")
					return smallNestedMenu("menu2")
				end
		
			-- GI INFANTRY VET
			elseif menu2choice_sub4 == 3 then
				if object.pAllies.money >= param.replacementGIVetCost then
					-- if totalGIInfantryVet < counter.value("# GI Veteran") then -- Cannot purchase unit if exceed maximum allowable
					-- ===================	
					local reinforcementsList = gen.createUnit(object.uGIVeteran, object.pAllies, {{44,140,0}, {0,136,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacementGIVetCost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A regiment of new "..object.uGIVeteran.name.." arrives in "..reinforcementCity.name.." at a cost of "..param.replacementGIVetCost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacementGIVetCost)
								return smallNestedMenu("menu2")
							else
								civ.ui.text("A regiment of new " .. object.uGIVeteran.name .. " arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementGIVetCost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacementGIVetCost)
								return smallNestedMenu("menu2")
							end
						else
							text.simple("Our replacement "..object.uGIVeteran.name.." never arrived.")
						end	
					-- ===================	
					-- else
						-- civ.ui.text("The current number of " .. totalGIInfantryVet .. " '" .. object.uGIVeteran.name .. "' equals the maximun allowed!")
					-- end
				else
					civ.ui.text("It requires " .. param.replacementGIVetCost .. " supplies to procure a new " .. object.uGIVeteran.name .. " unit!")
					return smallNestedMenu("menu2")
				end

			-- GI INFANTRY REG
			elseif menu2choice_sub4 == 4 then
				if object.pAllies.money >= param.replacementGIRegCost then
					-- if totalGIInfantryReg < counter.value("# GI Regular") then -- Cannot purchase unit if exceed maximum allowable
					-- ===================	
					local reinforcementsList = gen.createUnit(object.uGIRegular, object.pAllies, {{44,140,0}, {0,136,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacementGIRegCost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A regiment of new "..object.uGIRegular.name.." arrives in "..reinforcementCity.name.." at a cost of "..param.replacementGIRegCost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacementGIRegCost)
								return smallNestedMenu("menu2")
							else
								civ.ui.text("A regiment of new " .. object.uGIRegular.name .. " arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementGIRegCost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacementGIRegCost)
								return smallNestedMenu("menu2")
							end
						else
							text.simple("Our replacement "..object.uGIRegular.name.." never arrived.")
						end	
					-- ===================	
					-- else
						-- civ.ui.text("The current number of " .. totalGIInfantryReg .. " '" .. object.uGIRegular.name .. "' equals the maximun allowed!")
					-- end
				else
					civ.ui.text("It requires " .. param.replacementGIRegCost .. " supplies to procure a new " .. object.uGIRegular.name .. " unit!")
					return smallNestedMenu("menu2")
				end
				
			-- US BAZOOKA
			elseif menu2choice_sub4 == 5 then
				if object.pAllies.money >= param.replacementBazookaCost then
					-- if totalUSBazooka < counter.value("# US Bazooka") then -- Cannot purchase unit if exceed maximum allowable
					-- ===================	
					local reinforcementsList = gen.createUnit(object.uUSBazooka, object.pAllies, {{44,140,0}, {0,136,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacementBazookaCost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A regiment of new "..object.uUSBazooka.name.." arrives in "..reinforcementCity.name.." at a cost of "..param.replacementBazookaCost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacementBazookaCost)
								return smallNestedMenu("menu2")
							else
								civ.ui.text("A regiment of new " .. object.uUSBazooka.name .. " arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementBazookaCost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacementBazookaCost)
								return smallNestedMenu("menu2")
							end
						else
							text.simple("Our replacement "..object.uUSBazooka.name.." never arrived.")
						end	
					-- ===================	
					-- else
						-- civ.ui.text("The current number of " .. totalUSBazooka .. " '" .. object.uUSBazooka.name .. "' equals the maximun allowed!")
					-- end
				else
					civ.ui.text("It requires " .. param.replacementBazookaCost .. " supplies to procure a new " .. object.uUSBazooka.name .. " unit!")
					return smallNestedMenu("menu2")
				end
			
			-- US RANGERS
			elseif menu2choice_sub4 == 6 then
				-- EXAMPLE WHERE UNIT CANNOT BE PURCHASED AFTER A CERTAIN POINT
				if object.pAllies.money >= param.replacementRangerCost then
					if flag.value("Ranger units withdrawn") == false then -- Check if Ranger units are withdrawn from theather
						if totalRanger < counter.value("# US Ranger") then -- Cannot purchase unit if exceed maximum allowable
						-- ===================	
						local reinforcementsList = gen.createUnit(object.uRanger, object.pAllies, {{44,140,0}, {0,136,0}}, {randomize=false, veteran=false})
							if reinforcementsList[1] then -- make sure there is actually a reinforcement created
								object.pAllies.money = object.pAllies.money - param.replacementRangerCost
								local firstUnit = reinforcementsList[1]
								local reinforcementCity = firstUnit.location.city
								if reinforcementCity then
									text.simple("A regiment of new "..object.uRanger.name.." arrives in "..reinforcementCity.name.." at a cost of "..param.replacementRangerCost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
									counter.add("# Supplies Spent in Campaign",param.replacementRangerCost)
									return smallNestedMenu("menu2")
								else
									civ.ui.text("A regiment of new " .. object.uRanger.name .. " arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementRangerCost .. " supplies!")	
									counter.add("# Supplies Spent in Campaign",param.replacementRangerCost)
									return smallNestedMenu("menu2")
								end
							else
								text.simple("Our replacement "..object.uRanger.name.." never arrived.")
							end	
						-- ===================	
						else
							civ.ui.text("The current number of " .. totalRanger .. " '" .. object.uRanger.name .. "' equals the maximun allowed!")
						end
					else
						civ.ui.text("The " .. object.uRanger.name .. " units have been withdrawn from the theather and are no longer available for recruitment!")
					end
				else
					civ.ui.text("It requires " .. param.replacementRangerCost .. " supplies to procure a new " .. object.uRanger.name .. " unit!")
					return smallNestedMenu("menu2")
				end	
			
			-- 82nd AIRBORNE
			elseif menu2choice_sub4 == 7 then
				-- EXAMPLE WHERE UNIT CANNOT BE PURCHASED AFTER A CERTAIN POINT
				if object.pAllies.money >= param.replacement82ndCost then
					if flag.value("82nd Airborne units withdrawn") == false then -- Check if 82nd Airborne units are withdrawn from theather 
						if total82ndAirborne < counter.value("# 82nd Airborne") then
						-- ===================	
						local reinforcementsList = gen.createUnit(object.u82ndAirborne, object.pAllies, {{44,140,0}, {0,136,0}}, {randomize=false, veteran=false})
							if reinforcementsList[1] then -- make sure there is actually a reinforcement created
								object.pAllies.money = object.pAllies.money - param.replacement82ndCost
								local firstUnit = reinforcementsList[1]
								local reinforcementCity = firstUnit.location.city
								if reinforcementCity then
									text.simple("A regiment of new "..object.u82ndAirborne.name.." arrives in "..reinforcementCity.name.." at a cost of "..param.replacement82ndCost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
									counter.add("# Supplies Spent in Campaign",param.replacement82ndCost)
									return smallNestedMenu("menu2")
								else
									civ.ui.text("A regiment of new " .. object.u82ndAirborne.name .. " arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacement82ndCost .. " supplies!")	
									counter.add("# Supplies Spent in Campaign",param.replacement82ndCost)
									return smallNestedMenu("menu2")
								end
							else
								text.simple("Our replacement "..object.u82ndAirborne.name.." never arrived.")
							end	
						-- ===================	
						else
							civ.ui.text("The current number of " .. total82ndAirborne .. " '" .. object.u82ndAirborne.name .. "' equals the maximun allowed!")
						end
					else
						civ.ui.text("The " .. object.u82ndAirborne.name .. " units have been withdrawn from the theather and are no longer available for recruitment!")
					end
				else
					civ.ui.text("It requires " .. param.replacement82ndCost .. " supplies to procure a new " .. object.u82ndAirborne.name .. " unit!")
					return smallNestedMenu("menu2")
				end	

			-- 10th MOUNTAIN
			elseif menu2choice_sub4 == 8 then
				if object.pAllies.money >= param.replacement10thMtnCost then
					-- if totalUS10thMountain < counter.value("# 10th Mountain") then -- Cannot purchase unit if exceed maximum allowable
					-- ===================	
					local reinforcementsList = gen.createUnit(object.uUS10thMountain, object.pAllies, {{44,140,0}, {0,136,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacement10thMtnCost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A regiment of new "..object.uUS10thMountain.name.." arrives in "..reinforcementCity.name.." at a cost of "..param.replacement10thMtnCost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacement10thMtnCost)
								return smallNestedMenu("menu2")
							else
								civ.ui.text("A regiment of new " .. object.uUS10thMountain.name .. " arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacement10thMtnCost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacement10thMtnCost)
								return smallNestedMenu("menu2")
							end
						else
							text.simple("Our replacement "..object.uUS10thMountain.name.." never arrived.")
						end	
					-- ===================	
					-- else
						-- civ.ui.text("The current number of " .. totalUS10thMountain .. " '" .. object.uUS10thMountain.name .. "' equals the maximun allowed!")
					-- end
				else
					civ.ui.text("It requires " .. param.replacement10thMtnCost .. " supplies to procure a new " .. object.uUS10thMountain.name .. " unit!")
					return smallNestedMenu("menu2")
				end
		
			-- 442nd REGIMENT
			elseif menu2choice_sub4 == 9 then
				if object.pAllies.money >= param.replacement442ndCost then
					-- if totalUS442ndRegt < counter.value("# US 442nd Regt") then -- Cannot purchase unit if exceed maximum allowable
					-- ===================	
					local reinforcementsList = gen.createUnit(object.uUS442ndRegt, object.pAllies, {{44,140,0}, {0,136,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacement442ndCost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A regiment of new "..object.uUS442ndRegt.name.." arrives in "..reinforcementCity.name.." at a cost of "..param.replacement442ndCost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacement442ndCost)
								return smallNestedMenu("menu2")
							else
								civ.ui.text("A regiment of new " .. object.uUS442ndRegt.name .. " arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacement442ndCost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacement442ndCost)
								return smallNestedMenu("menu2")
							end
						else
							text.simple("Our replacement "..object.uUS442ndRegt.name.." never arrived.")
						end	
					-- ===================	
					-- else
						-- civ.ui.text("The current number of " .. totalUS442ndRegt .. " '" .. object.uUS442ndRegt.name .. "' equals the maximun allowed!")
					-- end
				else
					civ.ui.text("It requires " .. param.replacement442ndCost .. " supplies to procure a new " .. object.uUS442ndRegt.name .. " unit!")
					return smallNestedMenu("menu2")
				end

			-- EXIT MENUS
			elseif menu2choice_sub4 == 10 then
				-- civ.ui.text("Return to main menu!")
				return smallNestedMenu("menu1")				
			elseif menu2choice_sub4 == 11 then
				-- civ.ui.text("Exit procurement menu!")
				return 
			end
            
		-- AMERICAN ARTILLERY
		elseif menu2choice == 5 then

			local menuTitle = "American Artillery Replacements"
			local menuOptions = {}
			
			menuOptions[1]="Return to American Replacements menu!"
			if totalM7105mmHMC < counter.value("# M7 105mm HMC") then
				menuOptions[2]="" .. object.uM7105mmHMC.name .. " at " .. param.replacement105HMCCost .. " supplies: " .. tostring(counter.value("# M7 105mm HMC") - totalM7105mmHMC) .. " available to build."
			end
			if totalM12155mmHMC < counter.value("# M12 155mm HMC") and flag.value("US Armored Division is Active") == true then
				menuOptions[3]="" .. object.uM12155mmHMC.name .. " at " .. param.replacement155HMCCost .. " supplies: ".. tostring(counter.value("# M12 155mm HMC") - totalM12155mmHMC) .. " available to build." 
			end
			if totalUSBofors40mmAA < counter.value("# US Bofors 40mm AA") then
				menuOptions[4]="" .. object.uUSBofors40mmAA.name .. " at " .. param.replacementUSBoforsCost .. " supplies: " .. tostring(counter.value("# US Bofors 40mm AA") - totalUSBofors40mmAA) .. " available to build."
			end
			if totalM2A1105mmArt < counter.value("# M2A1 105mm Art") then
				menuOptions[5]="" .. object.uM2A1105mmArt.name .. " at " .. param.replacement105ArtCost .. " supplies: " .. tostring(counter.value("# M2A1 105mm Art") - totalM2A1105mmArt) .. " available to build."  
			end
			if totalM1155mmArt < counter.value("# M1 155mm Art") then
				menuOptions[6]="" .. object.uM1155mmArt.name .. " at " .. param.replacement155ArtCost .. " supplies: " .. tostring(counter.value("# M1 155mm Art") - totalM1155mmArt) .. " available to build."
			end
			if totalM157mmAT < counter.value("# M1 57mm AT") then
				menuOptions[7]="" .. object.uM157mmAT.name .. " at " .. param.replacement57ATCost .. " supplies: " .. tostring(counter.value("# M1 57mm AT") - totalM157mmAT) .. " available to build."
			end
			
			menuOptions[8]="Return to main menu!"
			menuOptions[9]="Exit procurement menu!"
			
			local menuText = "Which type of unit do you wish to procure?\n^(Current stock of supplies: ".. object.pAllies.money..")"	
			local menu2choice_sub5 = text.menu(menuOptions,menuText,menuTitle)		

			-- RETURN TO AMERICAN REPLACEMENTS MENU
			if menu2choice_sub5 == 1 then
				-- civ.ui.text("Don't procure any replacement artillery!")
				return smallNestedMenu("menu2")
				
			-- 105mm HMC
			elseif menu2choice_sub5 == 2 then
				if object.pAllies.money >= param.replacement105HMCCost then
					if totalM7105mmHMC < counter.value("# M7 105mm HMC") then -- Cannot purchase unit if exceed maximum allowable
					-- ===================	
					local reinforcementsList = gen.createUnit(object.uM7105mmHMC, object.pAllies, {{44,140,0}, {0,136,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacement105HMCCost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A regiment of new "..object.uM7105mmHMC.name.." arrives in "..reinforcementCity.name.." at a cost of "..param.replacement105HMCCost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacement105HMCCost)
								return smallNestedMenu("menu2")
							else
								civ.ui.text("A regiment of new " .. object.uM7105mmHMC.name .. " arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacement105HMCCost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacement105HMCCost)
								return smallNestedMenu("menu2")
							end
						else
							text.simple("Our replacement "..object.uM7105mmHMC.name.." never arrived.")
						end	
					-- ===================	
					else
						civ.ui.text("The current number of " .. totalM7105mmHMC .. " '" .. object.uM7105mmHMC.name .. "' equals the maximun allowed!")
					end
				else
					civ.ui.text("It requires " .. param.replacement105HMCCost .. " supplies to procure a new " .. object.uM7105mmHMC.name .. " unit!")
					return smallNestedMenu("menu2")
				end
			
			-- 155mm HMC
			elseif menu2choice_sub5 == 3 then
				if object.pAllies.money >= param.replacement155HMCCost then
					if totalM12155mmHMC < counter.value("# M12 155mm HMC") then -- Cannot purchase unit if exceed maximum allowable
					-- ===================	
					local reinforcementsList = gen.createUnit(object.uM12155mmHMC, object.pAllies, {{44,140,0}, {0,136,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacement155HMCCost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A regiment of new "..object.uM12155mmHMC.name.." arrives in "..reinforcementCity.name.." at a cost of "..param.replacement155HMCCost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacement155HMCCost)
								return smallNestedMenu("menu2")
							else
								civ.ui.text("A regiment of new " .. object.uM12155mmHMC.name .. " arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacement155HMCCost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacement155HMCCost)
								return smallNestedMenu("menu2")
							end
						else
							text.simple("Our replacement "..object.uM12155mmHMC.name.." never arrived.")
						end	
					-- ===================	
					else
						civ.ui.text("The current number of " .. totalM12155mmHMC .. " '" .. object.uM12155mmHMC.name .. "' equals the maximun allowed!")
					end
				else
					civ.ui.text("It requires " .. param.replacement155HMCCost .. " supplies to procure a new " .. object.uM12155mmHMC.name .. " unit!")
					return smallNestedMenu("menu2")
				end
			
			-- US Bofors 40mm AA
			elseif menu2choice_sub5 == 4 then
				if object.pAllies.money >= param.replacementUSBoforsCost then
					if totalUSBofors40mmAA < counter.value("# US Bofors 40mm AA") then -- Cannot purchase unit if exceed maximum allowable
					-- ===================	
					local reinforcementsList = gen.createUnit(object.uUSBofors40mmAA, object.pAllies, {{44,140,0}, {0,136,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacementUSBoforsCost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A regiment of new "..object.uUSBofors40mmAA.name.." arrives in "..reinforcementCity.name.." at a cost of "..param.replacementUSBoforsCost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacementUSBoforsCost)
								return smallNestedMenu("menu2")
							else
								civ.ui.text("A regiment of new " .. object.uUSBofors40mmAA.name .. " arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementUSBoforsCost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacementUSBoforsCost)
								return smallNestedMenu("menu2")
							end
						else
							text.simple("Our replacement "..object.uUSBofors40mmAA.name.." never arrived.")
						end	
					-- ===================	
					else
						civ.ui.text("The current number of " .. totalUSBofors40mmAA .. " '" .. object.uUSBofors40mmAA.name .. "' equals the maximun allowed!")
					end
				else
					civ.ui.text("It requires " .. param.replacementUSBoforsCost .. " supplies to procure a new " .. object.uUSBofors40mmAA.name .. " unit!")
					return smallNestedMenu("menu2")
				end
			
			-- 105mm ARTILLERY
			elseif menu2choice_sub5 == 5 then
				if object.pAllies.money >= param.replacement105ArtCost then
					if totalM2A1105mmArt < counter.value("# M2A1 105mm Art") then -- Cannot purchase unit if exceed maximum allowable
					-- ===================	
					local reinforcementsList = gen.createUnit(object.uM2A1105mmArt, object.pAllies, {{44,140,0}, {0,136,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacement105ArtCost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A regiment of new "..object.uM2A1105mmArt.name.." arrives in "..reinforcementCity.name.." at a cost of "..param.replacement105ArtCost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacement105ArtCost)
								return smallNestedMenu("menu2")
							else
								civ.ui.text("A regiment of new " .. object.uM2A1105mmArt.name .. " arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacement105ArtCost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacement105ArtCost)
								return smallNestedMenu("menu2")
							end
						else
							text.simple("Our replacement "..object.uM2A1105mmArt.name.." never arrived.")
						end	
					-- ===================	
					else
						civ.ui.text("The current number of " .. totalM2A1105mmArt .. " '" .. object.uM2A1105mmArt.name .. "' equals the maximun allowed!")
					end
				else
					civ.ui.text("It requires " .. param.replacement105ArtCost .. " supplies to procure a new " .. object.uM2A1105mmArt.name .. " unit!")
					return smallNestedMenu("menu2")
				end
			
			-- 155mm ARTILLERY
			elseif menu2choice_sub5 == 6 then
				if object.pAllies.money >= param.replacement155ArtCost then
					if totalM1155mmArt < counter.value("# M1 155mm Art") then -- Cannot purchase unit if exceed maximum allowable
					-- ===================	
					local reinforcementsList = gen.createUnit(object.uM1155mmArt, object.pAllies, {{44,140,0}, {0,136,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacement155ArtCost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A regiment of new "..object.uM1155mmArt.name.." arrives in "..reinforcementCity.name.." at a cost of "..param.replacement155ArtCost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacement155ArtCost)
								return smallNestedMenu("menu2")
							else
								civ.ui.text("A regiment of new " .. object.uM1155mmArt.name .. " arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacement155ArtCost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacement155ArtCost)
								return smallNestedMenu("menu2")
							end
						else
							text.simple("Our replacement "..object.uM1155mmArt.name.." never arrived.")
						end	
					-- ===================	
					else
						civ.ui.text("The current number of " .. totalM1155mmArt .. " '" .. object.uM1155mmArt.name .. "' equals the maximun allowed!")
					end
				else
					civ.ui.text("It requires " .. param.replacement155ArtCost .. " supplies to procure a new " .. object.uM1155mmArt.name .. " unit!")
					return smallNestedMenu("menu2")
				end
			
			-- 57mm ANTI-TANK
			elseif menu2choice_sub5 == 7 then
				if object.pAllies.money >= param.replacement57ATCost then
					if totalM157mmAT < counter.value("# M1 57mm AT") then -- Cannot purchase unit if exceed maximum allowable
					-- ===================	
					local reinforcementsList = gen.createUnit(object.uM157mmAT, object.pAllies, {{44,140,0}, {0,136,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacement57ATCost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A regiment of new "..object.uM157mmAT.name.." arrives in "..reinforcementCity.name.." at a cost of "..param.replacement57ATCost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacement57ATCost)
								return smallNestedMenu("menu2")
							else
								civ.ui.text("A regiment of new " .. object.uM157mmAT.name .. " arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacement57ATCost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacement57ATCost)
								return smallNestedMenu("menu2")
							end
						else
							text.simple("Our replacement "..object.uM157mmAT.name.." never arrived.")
						end	
					-- ===================	
					else
						civ.ui.text("The current number of " .. totalM157mmAT .. " '" .. object.uM157mmAT.name .. "' equals the maximun allowed!")
					end
				else
					civ.ui.text("It requires " .. param.replacement57ATCost .. " supplies to procure a new " .. object.uM157mmAT.name .. " unit!")
					return smallNestedMenu("menu2")
				end
				
			-- EXIT MENUS
			elseif menu2choice_sub5 == 8 then
				-- civ.ui.text("Return to main menu!")
				return smallNestedMenu("menu1")					
			elseif menu2choice_sub5 == 9 then
				-- civ.ui.text("Exit procurement menu!")
				return 
			end	
        
		-- Return to main menu
		elseif menu2choice == 6 then
            return smallNestedMenu("menu1")			
		
		-- Exit procurement menu
		elseif menu2choice == 7 then
            return 		
        end
    end
	
	-- BRITISH REPLACEMENTS MENU ========================================
    if menuType == "menu3" then
	
        local menuText = "British Replacements: ".. object.pAllies.money.." supplies"
        -- local menuTable = {"Fighters","Bombers","Armored","Infantry","Artillery","Return to main menu!"}
        local menuOptions = {}
		menuOptions[1]="Fighters:  " .. math.floor(tostring(counter.value("# Beaufighter MkVI") - totalBeaufighterMkVI) + tostring(counter.value("# Kittyhawk") - totalKittyhawk) + tostring(counter.value("# Spitfire MkIX") - totalSpitfireMkV) + tostring(counter.value("# Seafire MkII") - totalSeafireMkII)) .. "  available to build"
		menuOptions[2]="Bombers:  " .. math.floor(tostring(counter.value("# Hurricane IIc") - totalHurricaneIIc) + tostring(counter.value("# Martin Baltimore") - totalMartinBaltimore) + tostring(counter.value("# Vickers Wellington") - totalVickersWellington) + tostring(counter.value("# Boston III") - totalBostonIII) + tostring(counter.value("# Sunderland III") - totalSunderlandIII) + tostring(counter.value("# Fairey Barracuda") - totalFaireyBarracuda)) .. "  available to build" 
		menuOptions[3]="Armored:  " .. math.floor(tostring(counter.value("# Daimler AC") - totalDaimlerAC) + tostring(counter.value("# Bren Carrier") - totalBrenCarrier) + tostring(counter.value("# Sherman IIa Bde") - totalShermanIIIBde) + tostring(counter.value("# Sherman IIa") - totalShermanIII) + tostring(counter.value("# Churchill Mk IV") - totalChurchillMkIV) + tostring(counter.value("# Cromwell Mk VII") - totalCromwell) + tostring(counter.value("# Sherman Firefly") - totalShermanFirefly) + tostring(counter.value("# Churchill AVRE") - totalChurchillAVRE) + tostring(counter.value("# UK Truck") - totalUKTruck)) .. "  available to build" 
		menuOptions[4]="Infantry:  " .. math.floor(tostring(counter.value("# British Veteran") - totalBritishInfantryVet) + tostring(counter.value("# British Regular") - totalBritishInfantryReg) + tostring(counter.value("# British PIAT") - totalBritishPIAT) + tostring(counter.value("# British MG") - totalBritishMG) + tostring(counter.value("# Commandos") - totalCommandos) + tostring(counter.value("# 1st Airborne") - total1stAirborne) + tostring(counter.value("# British 52nd Mountain") - totalBritish52ndMtn)) .. "  available to build" 
		menuOptions[5]="Artillery:  " .. math.floor(tostring(counter.value("# Bishop 25pdr") - totalBishop25pdr) + tostring(counter.value("# UK Bofors 40mm AA") - totalUKBofors40mmAA) + tostring(counter.value("# 25pdr MKII Art") - total25pdrMKIIArt) + tostring(counter.value("# 55inch Art") - total55inchArt) + tostring(counter.value("# 6pdr AT") - total6pdrAT)) .. "  available to build" 
		menuOptions[6]="Return to main menu!" 
		menuOptions[7]="Exit procurement menu!"
		local menu3choice = text.menu(menuOptions,menuText,"British Replacement Procurement")
        
		-- BRITISH FIGHTERS
		if menu3choice == 1 then
			
			local menuTitle = "British Fighter Replacements"
			-- MENU CODE OPTION 2 - Allows you to insert conditions within the menu if you want to prevent certain menu options from displaying
			local menuOptions = {} 

			menuOptions[1]="Return to British Replacements menu!"
			if totalBeaufighterMkVI < counter.value("# Beaufighter MkVI") then -- 
				menuOptions[2]="" .. object.uBeaufighterMkVI.name .. " at " .. param.replacementBeaufighterCost .. " supplies: " .. tostring(counter.value("# Beaufighter MkVI") - totalBeaufighterMkVI) .. " available to build."
			end
			if totalKittyhawk < counter.value("# Kittyhawk") then
				menuOptions[3]="" .. object.uKittyhawk.name .. " at " .. param.replacementKittyhawkCost .. " supplies: " .. tostring(counter.value("# Kittyhawk") - totalKittyhawk) .. " available to build."
			end
			if totalSpitfireMkV < counter.value("# Spitfire MkIX") then
				menuOptions[4]="" .. object.uSpitfireMkIX.name .. " at " .. param.replacementSpitfireMkVCost .. " supplies: " .. tostring(counter.value("# Spitfire MkIX") - totalSpitfireMkV) .. " available to build."
			end
			if totalSeafireMkII < counter.value("# Seafire MkII") and flag.value("Seafire MkII carrier aircraft withdrawn") == false then
				menuOptions[5]="" .. object.uSeafireMkII.name .. " at " .. param.replacementSeafireMkIICost .. " supplies: " .. tostring(counter.value("# Seafire MkII") - totalSeafireMkII) .. " available to build."
			end

			menuOptions[6]="Return to main menu!"
			menuOptions[7]="Exit procurement menu!"
			
			local menuText = "Which type of unit do you wish to procure?\n^(Current stock of supplies: ".. object.pAllies.money..")"	
			local menu3choice_sub1 = text.menu(menuOptions,menuText,menuTitle)		
		
			-- RETURN TO BRITISH REPLACEMENTS MENU
			if menu3choice_sub1 == 1 then
				-- civ.ui.text("Don't procure any replacement fighters!")
				return smallNestedMenu("menu3")
				
			-- BEAUFIGHTER MKVI
			elseif menu3choice_sub1 == 2 then
				if object.pAllies.money >= param.replacementBeaufighterCost then
					-- ===================
					-- if totalBeaufighterMkVI < counter.value("# Beaufighter MkVI") then -- Cannot purchase unit if exceed maximum allowable
					local reinforcementsList = gen.createUnit(object.uBeaufighterMkVI, object.pAllies, {{73,155,0}, {62,162,0}, {39,177,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacementBeaufighterCost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A new group of replacement "..object.uBeaufighterMkVI.name.." fighters arrives in "..reinforcementCity.name.." at a cost of "..param.replacementBeaufighterCost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacementBeaufighterCost)
								return smallNestedMenu("menu3")
							else
								text.simple("A new group of replacement " .. object.uBeaufighterMkVI.name .. " fighters arrives at the airbase on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementBeaufighterCost .. " supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")	
								counter.add("# Supplies Spent in Campaign",param.replacementBeaufighterCost)
								return smallNestedMenu("menu3")
							end
						else
							text.simple("Our replacement "..object.uBeaufighterMkVI.name.." fighters never arrived.")
						end	
					-- ===================
					-- else
						-- civ.ui.text("The current number of " .. totalBeaufighterMkVI .. " '" .. object.uBeaufighterMkVI.name .. "' equals the maximun allowed!")
					-- end
				else
					civ.ui.text("It requires " .. param.replacementBeaufighterCost .. " supplies to procure a new " .. object.uBeaufighterMkVI.name .. " group!")
					return smallNestedMenu("menu3")
				end		
		
			-- KITTYHAWK
			elseif menu3choice_sub1 == 3 then
				if object.pAllies.money >= param.replacementKittyhawkCost then
					-- ===================
					-- if totalKittyhawk < counter.value("# Kittyhawk") then -- Cannot purchase unit if exceed maximum allowable
					local reinforcementsList = gen.createUnit(object.uKittyhawk, object.pAllies, {{73,155,0}, {62,162,0}, {39,177,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacementKittyhawkCost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A new group of replacement "..object.uKittyhawk.name.." fighters arrives in "..reinforcementCity.name.." at a cost of "..param.replacementKittyhawkCost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacementKittyhawkCost)
								return smallNestedMenu("menu3")
							else
								text.simple("A new group of replacement " .. object.uKittyhawk.name .. " fighters arrives at the airbase on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementKittyhawkCost .. " supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")	
								counter.add("# Supplies Spent in Campaign",param.replacementKittyhawkCost)
								return smallNestedMenu("menu3")
							end
						else
							text.simple("Our replacement "..object.uKittyhawk.name.." fighters never arrived.")
						end	
					-- ===================
					-- else
						-- civ.ui.text("The current number of " .. totalKittyhawk .. " '" .. object.uKittyhawk.name .. "' equals the maximun allowed!")
					-- end
				else
					civ.ui.text("It requires " .. param.replacementKittyhawkCost .. " supplies to procure a new " .. object.uKittyhawk.name .. " group!")
					return smallNestedMenu("menu3")
				end	
				
			-- SPITFIRE MKV
			elseif menu3choice_sub1 == 4 then
				if object.pAllies.money >= param.replacementSpitfireMkVCost then
					-- ===================
					-- if totalSpitfireMkV < counter.value("# Spitfire MkIX") then -- Cannot purchase unit if exceed maximum allowable
					local reinforcementsList = gen.createUnit(object.uSpitfireMkIX, object.pAllies, {{73,155,0}, {62,162,0}, {39,177,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacementSpitfireMkVCost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A new group of replacement "..object.uSpitfireMkIX.name.." fighters arrives in "..reinforcementCity.name.." at a cost of "..param.replacementSpitfireMkVCost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacementSpitfireMkVCost)
								return smallNestedMenu("menu3")
							else
								text.simple("A new group of replacement " .. object.uSpitfireMkIX.name .. " fighters arrives at the airbase on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementSpitfireMkVCost .. " supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")	
								counter.add("# Supplies Spent in Campaign",param.replacementSpitfireMkVCost)
								return smallNestedMenu("menu3")
							end
						else
							text.simple("Our replacement "..object.uSpitfireMkIX.name.." fighters never arrived.")
						end	
					-- ===================
					-- else
						-- civ.ui.text("The current number of " .. totalSpitfireMkV .. " '" .. object.uSpitfireMkIX.name .. "' equals the maximun allowed!")
					-- end
				else
					civ.ui.text("It requires " .. param.replacementSpitfireMkVCost .. " supplies to procure a new " .. object.uSpitfireMkIX.name .. " group!")
					return smallNestedMenu("menu3")
				end				
			-- SEAFIRE MKII
			elseif menu3choice_sub1 == 5 then
				if object.pAllies.money >= param.replacementSeafireMkIICost then
					-- ===================
					-- if totalSeafireMkII < counter.value("# Seafire MkII") then -- Cannot purchase unit if exceed maximum allowable
					local reinforcementsList = gen.createUnit(object.uSeafireMkII, object.pAllies, {{73,155,0}, {40,180,0}}, {randomize=true, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacementSeafireMkIICost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A new group of replacement "..object.uSeafireMkII.name.." fighters arrives in "..reinforcementCity.name.." at a cost of "..param.replacementSeafireMkIICost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacementSeafireMkIICost)
								return smallNestedMenu("menu3")
							else
								text.simple("A new group of replacement " .. object.uSeafireMkII.name .. " fighters arrives at the airbase on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementSeafireMkIICost .. " supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")	
								counter.add("# Supplies Spent in Campaign",param.replacementSeafireMkIICost)
								return smallNestedMenu("menu3")
							end
						else
							text.simple("Our replacement "..object.uSeafireMkII.name.." fighters never arrived.")
						end	
					-- ===================
					-- else
						-- civ.ui.text("The current number of " .. totalSeafireMkII .. " '" .. object.uSeafireMkII.name .. "' equals the maximun allowed!")
					-- end
				else
					civ.ui.text("It requires " .. param.replacementSeafireMkIICost .. " supplies to procure a new " .. object.uSeafireMkII.name .. " group!")
					return smallNestedMenu("menu3")
				end	

			-- EXIT MENU
			elseif menu3choice_sub1 == 6 then
				-- civ.ui.text("Return to main menu!")
				return smallNestedMenu("menu1")				
			elseif menu3choice_sub1 == 7 then
				-- civ.ui.text("Exit procurement menu!")
				return 
			end
		
		-- BRITISH BOMBERS
		elseif menu3choice == 2 then

			local menuTitle = "British Bomber Replacements"
			local menuOptions = {}

			menuOptions[1]="Return to British Replacements menu!"
			if totalHurricaneIIc < counter.value("# Hurricane IIc") then
				menuOptions[2]="" .. object.uHurricaneIIc.name .. " at " .. param.replacementHurricaneIIcCost .. " supplies: " .. tostring(counter.value("# Hurricane IIc") - totalHurricaneIIc) .. " available to build." 
			end
			if totalMartinBaltimore < counter.value("# Martin Baltimore") then
				menuOptions[3]="" .. object.uMartinBaltimore.name .. " at " .. param.replacementMartinBaltimoreCost .. " supplies: ".. tostring(counter.value("# Martin Baltimore") - totalMartinBaltimore) .. " available to build." 
			end
			if totalVickersWellington < counter.value("# Vickers Wellington") then
				menuOptions[4]="" .. object.uVickersWellington.name .. " at " .. param.replacementVickersWellingtonCost .. " supplies: " .. tostring(counter.value("# Vickers Wellington") - totalVickersWellington) .. " available to build."  
			end
			if totalBostonIII < counter.value("# Boston III") then
				menuOptions[5]="" .. object.uBostonIII.name .. " at " .. param.replacementBostonIIICost .. " supplies: " .. tostring(counter.value("# Boston III") - totalBostonIII) .. " available to build."  
			end
			if totalSunderlandIII < counter.value("# Sunderland III") then
				menuOptions[6]="" .. object.uSunderlandIII.name .. " at " .. param.replacementSunderlandIIICost .. " supplies: " .. tostring(counter.value("# Sunderland III") - totalSunderlandIII) .. " available to build."  
			end
			if totalFaireyBarracuda < counter.value("# Fairey Barracuda") and flag.value("Fairey Barracuda carrier aircraft withdrawn") == false then
				menuOptions[7]="" .. object.uFaireyBarracuda.name .. " at " .. param.replacementFaireyBarracudaCost .. " supplies: " .. tostring(counter.value("# Fairey Barracuda") - totalFaireyBarracuda) .. " available to build."  
			end

			menuOptions[8]="Return to main menu!"
			menuOptions[9]="Exit procurement menu!"
			
			local menuText = "Which type of unit do you wish to procure?\n^(Current stock of supplies: ".. object.pAllies.money..")"	
			local menu3choice_sub2 = text.menu(menuOptions,menuText,menuTitle)

			-- RETURN TO BRITISH REPLACEMENTS MENU
			if menu3choice_sub2 == 1 then
				-- civ.ui.text("Don't procure any replacement bombers!")
				return smallNestedMenu("menu3")
				
			-- HURRICANE IIc
			elseif menu3choice_sub2 == 2 then
				if object.pAllies.money >= param.replacementHurricaneIIcCost then
					-- if totalHurricaneIIc < counter.value("# Hurricane IIc") then -- Cannot purchase unit if exceed maximum allowable
					-- ===================	
					local reinforcementsList = gen.createUnit(object.uHurricaneIIc, object.pAllies, {{120,138,0}, {73,155,0}, {62,162,0}, {39,177,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacementHurricaneIIcCost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A new group of replacement "..object.uHurricaneIIc.name.." fighter-bombers arrives in "..reinforcementCity.name.." at a cost of "..param.replacementHurricaneIIcCost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacementHurricaneIIcCost)
								return smallNestedMenu("menu3")
							else
								text.simple("A new group of replacement " .. object.uHurricaneIIc.name .. " fighter-bombers arrives at the airbase on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementHurricaneIIcCost .. " supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")	
								counter.add("# Supplies Spent in Campaign",param.replacementHurricaneIIcCost)
								return smallNestedMenu("menu3")
							end
						else
							text.simple("Our replacement "..object.uHurricaneIIc.name.." fighter-bombers never arrived.")
						end	
					-- ===================					
					-- else
						-- civ.ui.text("The current number of " .. totalHurricaneIIc .. " '" .. object.uHurricaneIIc.name .. "' equals the maximun allowed!")
					-- end
				else
					civ.ui.text("It requires " .. param.replacementHurricaneIIcCost .. " supplies to procure a new " .. object.uHurricaneIIc.name .. " group!")
					return smallNestedMenu("menu3")
				end
			
			-- MARTIN BALTIMORE
			elseif menu3choice_sub2 == 3 then
				if object.pAllies.money >= param.replacementMartinBaltimoreCost then
					-- if totalMartinBaltimore < counter.value("# Martin Baltimore") then
					-- ===================	
					local reinforcementsList = gen.createUnit(object.uMartinBaltimore, object.pAllies, {{62,162,0}, {40,180,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacementMartinBaltimoreCost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A new group of replacement "..object.uMartinBaltimore.name.." bombers arrives in "..reinforcementCity.name.." at a cost of "..param.replacementMartinBaltimoreCost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacementMartinBaltimoreCost)
								return smallNestedMenu("menu3")
							else
								civ.ui.text("A new group of replacement " .. object.uMartinBaltimore.name .. " bombers arrives at the airbase on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementMartinBaltimoreCost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacementMartinBaltimoreCost)
								return smallNestedMenu("menu3")
							end
						else
							text.simple("Our replacement "..object.uMartinBaltimore.name.." bombers never arrived.")
						end	
					-- ===================							
					-- else
						-- civ.ui.text("The current number of " .. totalMartinBaltimore .. " '" .. object.uMartinBaltimore.name .. "' equals the maximun allowed!")
					-- end
				else
					civ.ui.text("It requires " .. param.replacementMartinBaltimoreCost .. " supplies to procure a new " .. object.uMartinBaltimore.name .. " group!")
					return smallNestedMenu("menu3")
				end
				
			-- VICKERS WELLINGTON
			elseif menu3choice_sub2 == 4 then
				if object.pAllies.money >= param.replacementVickersWellingtonCost then
					-- if totalVickersWellington < counter.value("# Vickers Wellington") then
					-- ===================	
					local reinforcementsList = gen.createUnit(object.uVickersWellington, object.pAllies, {{62,162,0}, {40,180,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacementVickersWellingtonCost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A new group of replacement "..object.uVickersWellington.name.." bombers arrives in "..reinforcementCity.name.." at a cost of "..param.replacementVickersWellingtonCost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacementVickersWellingtonCost)
								return smallNestedMenu("menu3")
							else
								civ.ui.text("A new group of replacement " .. object.uVickersWellington.name .. " bombers arrives at the airbase on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementVickersWellingtonCost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacementVickersWellingtonCost)
								return smallNestedMenu("menu3")
							end
						else
							text.simple("Our replacement "..object.uVickersWellington.name.." bombers never arrived.")
						end	
					-- ===================							
					-- else
						-- civ.ui.text("The current number of " .. totalVickersWellington .. " '" .. object.uVickersWellington.name .. "' equals the maximun allowed!")
					-- end
				else
					civ.ui.text("It requires " .. param.replacementVickersWellingtonCost .. " supplies to procure a new " .. object.uVickersWellington.name .. " group!")
					return smallNestedMenu("menu3")
				end
			
			-- BOSTON III
			elseif menu3choice_sub2 == 5 then
				if object.pAllies.money >= param.replacementBostonIIICost then
					-- if totalBostonIII < counter.value("# Boston III") then
					-- ===================	
					local reinforcementsList = gen.createUnit(object.uBostonIII, object.pAllies, {{62,162,0}, {40,180,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacementBostonIIICost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A new group of replacement "..object.uBostonIII.name.." bombers arrives in "..reinforcementCity.name.." at a cost of "..param.replacementBostonIIICost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacementBostonIIICost)
								return smallNestedMenu("menu3")
							else
								civ.ui.text("A new group of replacement " .. object.uBostonIII.name .. " bombers arrives at the airbase on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementBostonIIICost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacementBostonIIICost)
								return smallNestedMenu("menu3")
							end
						else
							text.simple("Our replacement "..object.uBostonIII.name.." bombers never arrived.")
						end	
					-- ===================							
					-- else
						-- civ.ui.text("The current number of " .. totalBostonIII .. " '" .. object.uBostonIII.name .. "' equals the maximun allowed!")
					-- end
				else
					civ.ui.text("It requires " .. param.replacementBostonIIICost .. " supplies to procure a new " .. object.uBostonIII.name .. " group!")
					return smallNestedMenu("menu3")
				end
			
			-- SUNDERLAND III
			elseif menu3choice_sub2 == 6 then
				if object.pAllies.money >= param.replacementSunderlandIIICost then
					-- if totalSunderlandIII < counter.value("# Sunderland III") then
					-- ===================	
					local reinforcementsList = gen.createUnit(object.uSunderlandIII, object.pAllies, {{62,162,0}, {40,180,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacementSunderlandIIICost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A new group of replacement "..object.uSunderlandIII.name.." patrol bombers arrives in "..reinforcementCity.name.." at a cost of "..param.replacementSunderlandIIICost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacementSunderlandIIICost)
								return smallNestedMenu("menu3")
							else
								civ.ui.text("A new group of replacement " .. object.uSunderlandIII.name .. " patrol bombers arrives at the airbase on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementSunderlandIIICost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacementSunderlandIIICost)
								return smallNestedMenu("menu3")
							end
						else
							text.simple("Our replacement "..object.uSunderlandIII.name.." patrol bombers never arrived.")
						end	
					-- ===================							
					-- else
						-- civ.ui.text("The current number of " .. totalSunderlandIII .. " '" .. object.uSunderlandIII.name .. "' equals the maximun allowed!")
					-- end
				else
					civ.ui.text("It requires " .. param.replacementSunderlandIIICost .. " supplies to procure a new " .. object.uSunderlandIII.name .. " group!")
					return smallNestedMenu("menu3")
				end

			-- FAIREY BARRACUDA
			elseif menu3choice_sub2 == 7 then
				if object.pAllies.money >= param.replacementFaireyBarracudaCost then
					-- if totalFaireyBarracuda < counter.value("# Fairey Barracuda") then
					-- ===================	
					local reinforcementsList = gen.createUnit(object.uFaireyBarracuda, object.pAllies, {{73,155,0}, {40,180,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacementFaireyBarracudaCost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A new group of replacement "..object.uFaireyBarracuda.name.." patrol bombers arrives in "..reinforcementCity.name.." at a cost of "..param.replacementFaireyBarracudaCost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacementFaireyBarracudaCost)
								return smallNestedMenu("menu3")
							else
								civ.ui.text("A new group of replacement " .. object.uFaireyBarracuda.name .. " patrol bombers arrives at the airbase on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementFaireyBarracudaCost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacementFaireyBarracudaCost)
								return smallNestedMenu("menu3")
							end
						else
							text.simple("Our replacement "..object.uFaireyBarracuda.name.." patrol bombers never arrived.")
						end	
					-- ===================							
					-- else
						-- civ.ui.text("The current number of " .. totalFaireyBarracuda .. " '" .. object.uFaireyBarracuda.name .. "' equals the maximun allowed!")
					-- end
				else
					civ.ui.text("It requires " .. param.replacementFaireyBarracudaCost .. " supplies to procure a new " .. object.uFaireyBarracuda.name .. " group!")
					return smallNestedMenu("menu3")
				end
				
			-- EXIT MENUS
			elseif menu3choice_sub2 == 8 then
				-- civ.ui.text("Return to main menu!")
				return smallNestedMenu("menu1")	
			elseif menu3choice_sub2 == 9 then
				-- civ.ui.text("Exit procurement menu!")
				return 	
			end
			
		-- BRITISH ARMORED
		elseif menu3choice == 3 then

			local menuTitle = "British Armored Replacements"
			local menuOptions = {}

			menuOptions[1]="Return to British Replacements menu!"
			if totalDaimlerAC < counter.value("# Daimler AC") then
				menuOptions[2]="" .. object.uDaimlerAC.name .. " at " .. param.replacementDaimlerACCost .. " supplies: " .. tostring(counter.value("# Daimler AC") - totalDaimlerAC) .. " available to build."
			end
			if totalBrenCarrier < counter.value("# Bren Carrier") and flag.value("British Armored Division Deployed") == true then
				menuOptions[3]="" .. object.uBritishMotorTroops.name .. " at " .. param.replacementBrenCarrierCost .. " supplies: ".. tostring(counter.value("# Bren Carrier") - totalBrenCarrier) .. " available to build."
			end
			if totalShermanIIIBde < counter.value("# Sherman IIa Bde") then
				menuOptions[4]="" .. object.uShermanIIaBde.name .. " at " .. param.replacementShermanIIIBdeCost .. " supplies: " .. tostring(counter.value("# Sherman IIa Bde") - totalShermanIIIBde) .. " available to build."  
			end
			if totalShermanIII < counter.value("# Sherman IIa") and flag.value("British Armored Division Deployed") == true then
				menuOptions[5]="" .. object.uShermanIIa.name .. " at " .. param.replacementShermanIIICost .. " supplies: " .. tostring(counter.value("# Sherman IIa") - totalShermanIII) .. " available to build."  
			end
			if totalChurchillMkIV < counter.value("# Churchill Mk IV") and flag.value("Churchill MkIV enters UK armor inventory") == true then
				menuOptions[6]="" .. object.uChurchillMkIV.name .. " at " .. param.replacementChurchillMkIVCost .. " supplies: " .. tostring(counter.value("# Churchill Mk IV") - totalChurchillMkIV) .. " available to build." 
			end
			if totalCromwell < counter.value("# Cromwell Mk VII") and flag.value("British Armored Division Deployed") == true then
				menuOptions[7]="" .. object.uCromwellMkVII.name .. " at " .. param.replacementCromwellCost .. " supplies: " .. tostring(counter.value("# Cromwell Mk VII") - totalCromwell) .. " available to build."
			end
			if totalShermanFirefly < counter.value("# Sherman Firefly") and flag.value("Sherman Firefly enters UK armor inventory") == true then
				menuOptions[8]="" .. object.uShermanVCFirefly.name .. " at " .. param.replacementShermanFireflyCost .. " supplies: " .. tostring(counter.value("# Sherman Firefly") - totalShermanFirefly) .. " available to build."
			end
			if totalChurchillAVRE < counter.value("# Churchill AVRE") and flag.value("Churchill AVRE enters UK armor inventory") == true then
				menuOptions[9]="" .. object.uChurchillAVRE.name .. " at " .. param.replacementChurchillAVRECost .. " supplies: " .. tostring(counter.value("# Churchill AVRE") - totalChurchillAVRE) .. " available to build."
			end
			if totalUKTruck < counter.value("# UK Truck") then
				menuOptions[10]="" .. object.uUKTruck.name .. " at " .. param.replacementUKTruckCost .. " supplies: " .. tostring(counter.value("# UK Truck") - totalUKTruck) .. " available to build."
			end

			menuOptions[11]="Return to main menu!"
			menuOptions[12]="Exit procurement menu!"
			
			local menuText = "Which type of unit do you wish to procure?\n^(Current stock of supplies: ".. object.pAllies.money..")"	
			local menu3choice_sub3 = text.menu(menuOptions,menuText,menuTitle)		

			-- RETURN TO BRITISH REPLACEMENTS MENU
			if menu3choice_sub3 == 1 then
				-- civ.ui.text("Don't procure any replacement armored!")
				return smallNestedMenu("menu3")

			-- DAIMLER AC
			elseif menu3choice_sub3 == 2 then
				if object.pAllies.money >= param.replacementDaimlerACCost then
					-- if totalDaimlerAC < counter.value("# Daimler AC") then -- Cannot purchase unit if exceed maximum allowable
					-- ===================	
					local reinforcementsList = gen.createUnit(object.uDaimlerAC, object.pAllies, {{73,155,0}, {62,162,0}, {40,180,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacementDaimlerACCost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A battalion of new "..object.uDaimlerAC.name.." arrives in "..reinforcementCity.name.." at a cost of "..param.replacementDaimlerACCost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacementDaimlerACCost)
								return smallNestedMenu("menu3")
							else
								civ.ui.text("A battalion of new " .. object.uDaimlerAC.name .. " arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementDaimlerACCost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacementDaimlerACCost)
								return smallNestedMenu("menu3")
							end
						else
							text.simple("Our replacement "..object.uDaimlerAC.name.." unit never arrived.")
						end	
					-- ===================						
					-- else
						-- civ.ui.text("The current number of " .. totalDaimlerAC .. " '" .. object.uDaimlerAC.name .. "' equals the maximun allowed!")
					-- end
				else
					civ.ui.text("It requires " .. param.replacementDaimlerACCost .. " supplies to procure a new " .. object.uDaimlerAC.name .. " unit!")
					return smallNestedMenu("menu3")
				end
			
			-- BREN CARRIER
			elseif menu3choice_sub3 == 3 then
				if object.pAllies.money >= param.replacementBrenCarrierCost then
					-- if totalBrenCarrier < counter.value("# Bren Carrier") then -- Cannot purchase unit if exceed maximum allowable
					-- ===================	
					local reinforcementsList = gen.createUnit(object.uBritishMotorTroops, object.pAllies, {{73,155,0}, {62,162,0}, {40,180,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacementBrenCarrierCost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A battalion of new "..object.uBritishMotorTroops.name.." arrives in "..reinforcementCity.name.." at a cost of "..param.replacementBrenCarrierCost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacementBrenCarrierCost)
								return smallNestedMenu("menu3")
							else
								civ.ui.text("A battalion of new " .. object.uBritishMotorTroops.name .. " arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementBrenCarrierCost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacementBrenCarrierCost)
								return smallNestedMenu("menu3")
							end
						else
							text.simple("Our replacement "..object.uBritishMotorTroops.name.." unit never arrived.")
						end	
					-- ===================						
					-- else
						-- civ.ui.text("The current number of " .. totalBrenCarrier .. " '" .. object.uBritishMotorTroops.name .. "' equals the maximun allowed!")
					-- end
				else
					civ.ui.text("It requires " .. param.replacementBrenCarrierCost .. " supplies to procure a new " .. object.uBritishMotorTroops.name .. " unit!")
					return smallNestedMenu("menu3")
				end
				
			-- SHERMAN III BDE
			elseif menu3choice_sub3 == 4 then
				if object.pAllies.money >= param.replacementShermanIIIBdeCost then
					-- if totalShermanIIIBde < counter.value("# Sherman IIa Bde") then -- Cannot purchase unit if exceed maximum allowable
					-- ===================	
					local reinforcementsList = gen.createUnit(object.uShermanIIaBde, object.pAllies, {{73,155,0}, {62,162,0}, {40,180,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacementShermanIIIBdeCost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A battalion of new "..object.uShermanIIaBde.name.." arrives in "..reinforcementCity.name.." at a cost of "..param.replacementShermanIIIBdeCost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacementShermanIIIBdeCost)
								return smallNestedMenu("menu3")
							else
								civ.ui.text("A battalion of new " .. object.uShermanIIaBde.name .. " arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementShermanIIIBdeCost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacementShermanIIIBdeCost)
								return smallNestedMenu("menu3")
							end
						else
							text.simple("Our replacement "..object.uShermanIIaBde.name.." unit never arrived.")
						end	
					-- ===================						
					-- else
						-- civ.ui.text("The current number of " .. totalShermanIIIBde .. " '" .. object.uShermanIIaBde.name .. "' equals the maximun allowed!")
					-- end
				else
					civ.ui.text("It requires " .. param.replacementShermanIIIBdeCost .. " supplies to procure a new " .. object.uShermanIIaBde.name .. " unit!")
					return smallNestedMenu("menu3")
				end

			-- SHERMAN III
			elseif menu3choice_sub3 == 5 then
				if object.pAllies.money >= param.replacementShermanIIICost then
					-- if totalShermanIII < counter.value("# Sherman IIa") then -- Cannot purchase unit if exceed maximum allowable
					-- ===================	
					local reinforcementsList = gen.createUnit(object.uShermanIIa, object.pAllies, {{73,155,0}, {62,162,0}, {40,180,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacementShermanIIICost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A battalion of new "..object.uShermanIIa.name.." arrives in "..reinforcementCity.name.." at a cost of "..param.replacementShermanIIICost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacementShermanIIICost)
								return smallNestedMenu("menu3")
							else
								civ.ui.text("A battalion of new " .. object.uShermanIIa.name .. " arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementShermanIIICost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacementShermanIIICost)
								return smallNestedMenu("menu3")
							end
						else
							text.simple("Our replacement "..object.uShermanIIa.name.." unit never arrived.")
						end	
					-- ===================						
					-- else
						-- civ.ui.text("The current number of " .. totalShermanIII .. " '" .. object.uShermanIIa.name .. "' equals the maximun allowed!")
					-- end
				else
					civ.ui.text("It requires " .. param.replacementShermanIIICost .. " supplies to procure a new " .. object.uShermanIIa.name .. " unit!")
					return smallNestedMenu("menu3")
				end
				
			-- CHURCHILL IV
			elseif menu3choice_sub3 == 6 then
				if object.pAllies.money >= param.replacementChurchillMkIVCost then
					-- if totalChurchillMkIV < counter.value("# Churchill Mk IV") then -- Cannot purchase unit if exceed maximum allowable
					-- ===================	
					local reinforcementsList = gen.createUnit(object.uChurchillMkIV, object.pAllies, {{73,155,0}, {62,162,0}, {40,180,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacementChurchillMkIVCost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A battalion of new "..object.uChurchillMkIV.name.." arrives in "..reinforcementCity.name.." at a cost of "..param.replacementChurchillMkIVCost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacementChurchillMkIVCost)
								return smallNestedMenu("menu3")
							else
								civ.ui.text("A battalion of new " .. object.uChurchillMkIV.name .. " arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementChurchillMkIVCost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacementChurchillMkIVCost)
								return smallNestedMenu("menu3")
							end
						else
							text.simple("Our replacement "..object.uChurchillMkIV.name.." unit never arrived.")
						end	
					-- ===================						
					-- else
						-- civ.ui.text("The current number of " .. totalChurchillMkIV .. " '" .. object.uChurchillMkIV.name .. "' equals the maximun allowed!")
					-- end
				else
					civ.ui.text("It requires " .. param.replacementChurchillMkIVCost .. " supplies to procure a new " .. object.uChurchillMkIV.name .. " unit!")
					return smallNestedMenu("menu3")
				end
				
			-- CROMWELL
			elseif menu3choice_sub3 == 7 then
				if object.pAllies.money >= param.replacementCromwellCost then
					-- if totalCromwell < counter.value("# Cromwell Mk VII") then -- Cannot purchase unit if exceed maximum allowable
					-- ===================	
					local reinforcementsList = gen.createUnit(object.uCromwellMkVII, object.pAllies, {{73,155,0}, {62,162,0}, {40,180,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacementCromwellCost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A battalion of new "..object.uCromwellMkVII.name.." arrives in "..reinforcementCity.name.." at a cost of "..param.replacementCromwellCost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacementCromwellCost)
								return smallNestedMenu("menu3")
							else
								civ.ui.text("A battalion of new " .. object.uCromwellMkVII.name .. " arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementCromwellCost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacementCromwellCost)
								return smallNestedMenu("menu3")
							end
						else
							text.simple("Our replacement "..object.uCromwellMkVII.name.." unit never arrived.")
						end	
					-- ===================						
					-- else
						-- civ.ui.text("The current number of " .. totalCromwell .. " '" .. object.uCromwellMkVII.name .. "' equals the maximun allowed!")
					-- end
				else
					civ.ui.text("It requires " .. param.replacementCromwellCost .. " supplies to procure a new " .. object.uCromwellMkVII.name .. " unit!")
					return smallNestedMenu("menu3")
				end

			-- SHERMAN FIREFLY
			elseif menu3choice_sub3 == 8 then
				if object.pAllies.money >= param.replacementShermanFireflyCost then
					-- if totalShermanFirefly < counter.value("# Sherman Firefly") then -- Cannot purchase unit if exceed maximum allowable
					-- ===================	
					local reinforcementsList = gen.createUnit(object.uShermanVCFirefly, object.pAllies, {{73,155,0}, {62,162,0}, {40,180,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacementShermanFireflyCost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A battalion of new "..object.uShermanVCFirefly.name.." arrives in "..reinforcementCity.name.." at a cost of "..param.replacementShermanFireflyCost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacementShermanFireflyCost)
								return smallNestedMenu("menu3")
							else
								civ.ui.text("A battalion of new " .. object.uShermanVCFirefly.name .. " arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementShermanFireflyCost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacementShermanFireflyCost)
								return smallNestedMenu("menu3")
							end
						else
							text.simple("Our replacement "..object.uShermanVCFirefly.name.." unit never arrived.")
						end	
					-- ===================						
					-- else
						-- civ.ui.text("The current number of " .. totalShermanFirefly .. " '" .. object.uShermanVCFirefly.name .. "' equals the maximun allowed!")
					-- end
				else
					civ.ui.text("It requires " .. param.replacementShermanFireflyCost .. " supplies to procure a new " .. object.uShermanVCFirefly.name .. " unit!")
					return smallNestedMenu("menu3")
				end
				
			-- CHURCHILL AVRE
			elseif menu3choice_sub3 == 9 then
				if object.pAllies.money >= param.replacementChurchillAVRECost then
					-- if totalChurchillAVRE < counter.value("# Churchill AVRE") then -- Cannot purchase unit if exceed maximum allowable
					-- ===================	
					local reinforcementsList = gen.createUnit(object.uChurchillAVRE, object.pAllies, {{73,155,0}, {62,162,0}, {40,180,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacementChurchillAVRECost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A battalion of new "..object.uChurchillAVRE.name.." arrives in "..reinforcementCity.name.." at a cost of "..param.replacementChurchillAVRECost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacementChurchillAVRECost)
								return smallNestedMenu("menu3")
							else
								civ.ui.text("A battalion of new " .. object.uChurchillAVRE.name .. " arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementChurchillAVRECost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacementChurchillAVRECost)
								return smallNestedMenu("menu3")
							end
						else
							text.simple("Our replacement "..object.uChurchillAVRE.name.." unit never arrived.")
						end	
					-- ===================						
					-- else
						-- civ.ui.text("The current number of " .. totalChurchillAVRE .. " '" .. object.uChurchillAVRE.name .. "' equals the maximun allowed!")
					-- end
				else
					civ.ui.text("It requires " .. param.replacementChurchillAVRECost .. " supplies to procure a new " .. object.uChurchillAVRE.name .. " unit!")
					return smallNestedMenu("menu3")
				end
				
			-- UK TRUCK
			elseif menu3choice_sub3 == 10 then
				if object.pAllies.money >= param.replacementUKTruckCost then
					-- if totalUKTruck < counter.value("# UK Truck") then -- Cannot purchase unit if exceed maximum allowable
					-- ===================	
					local reinforcementsList = gen.createUnit(object.uUKTruck, object.pAllies, {{73,155,0}, {62,162,0}, {40,180,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacementUKTruckCost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A regiment of new "..object.uUKTruck.name.." arrives in "..reinforcementCity.name.." at a cost of "..param.replacementUKTruckCost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacementUKTruckCost)
								return smallNestedMenu("menu3")
							else
								civ.ui.text("A regiment of new " .. object.uUKTruck.name .. " arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementUKTruckCost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacementUKTruckCost)
								return smallNestedMenu("menu3")
							end
						else
							text.simple("Our replacement "..object.uUKTruck.name.." unit never arrived.")
						end	
					-- ===================						
					-- else
						-- civ.ui.text("The current number of " .. totalUKTruck .. " '" .. object.uUKTruck.name .. "' equals the maximun allowed!")
					-- end
				else
					civ.ui.text("It requires " .. param.replacementUKTruckCost .. " supplies to procure a new " .. object.uUKTruck.name .. " unit!")
					return smallNestedMenu("menu3")
				end
				
			-- EXIT MENUS
			elseif menu3choice_sub3 == 11 then
				-- civ.ui.text("Return to main menu!")
				return smallNestedMenu("menu1")	
			elseif menu3choice_sub3 == 12 then
				-- civ.ui.text("Exit procurement menu!")
				return 	
			end
			
		-- BRITISH INFANTRY
		elseif menu3choice == 4 then

			local menuTitle = "British Infantry Replacements"
			local menuOptions = {}

			menuOptions[1]="Return to British Replacements menu!"	
			if totalBritishInfantryVet < counter.value("# British Veteran") and flag.value("Veteran UK Infantry units withdrawn") == false then
				menuOptions[2]="" .. object.uBritishVeteran.name .. " at " .. param.replacementBritishInfantryVetCost .. " supplies: " .. tostring(counter.value("# British Veteran") - totalBritishInfantryVet) .. " available to build." 
			end
			if totalBritishInfantryReg < counter.value("# British Regular") then
				menuOptions[3]="" .. object.uBritishRegular.name .. " at " .. param.replacementBritishInfantryRegCost .. " supplies: " .. tostring(counter.value("# British Regular") - totalBritishInfantryReg) .. " available to build." 
			end
			if totalBritishPIAT < counter.value("# British PIAT") then
				menuOptions[4]="" .. object.uBritishPIAT.name .. " at " .. param.replacementBritishPIATCost .. " supplies: " .. tostring(counter.value("# British PIAT") - totalBritishPIAT) .. " available to build." 
			end
			if totalBritishMG < counter.value("# British MG") then
				menuOptions[5]="" .. object.uBritishMG.name .. " at " .. param.replacementBritishMGCost .. " supplies: ".. tostring(counter.value("# British MG") - totalBritishMG) .. " available to build." 
			end
			if totalCommandos < counter.value("# Commandos") and flag.value("Commandos units withdrawn") == false then
				menuOptions[6]="" .. object.uCommandos.name .. " at " .. param.replacementCommandosCost .. " supplies: " .. tostring(counter.value("# Commandos") - totalCommandos) .. " available to build."  
			end
			if total1stAirborne < counter.value("# 1st Airborne") and flag.value("1st Airborne units withdrawn") == false then
				menuOptions[7]="" .. object.u1stAirborne.name .. " at " .. param.replacement1stAirborneCost .. " supplies: " .. tostring(counter.value("# 1st Airborne") - total1stAirborne) .. " available to build."  
			end
			if totalBritish52ndMtn < counter.value("# British 52nd Mountain") and flag.value("British 52nd Mountain Deployed") == true then
				menuOptions[8]="" .. object.uBritish52ndMtn.name .. " at " .. param.replacementBritish52ndMtnCost .. " supplies: " .. tostring(counter.value("# British 52nd Mountain") - totalBritish52ndMtn) .. " available to build."  
			end

			menuOptions[9]="Return to main menu!"
			menuOptions[10]="Exit procurement menu!"
			
			local menuText = "Which type of unit do you wish to procure?\n^(Current stock of supplies: ".. object.pAllies.money..")"	
			local menu3choice_sub4 = text.menu(menuOptions,menuText,menuTitle)		

			-- RETURN TO BRITISH REPLACEMENTS MENU
			if menu3choice_sub4 == 1 then
				-- civ.ui.text("Don't procure any replacement infantry!")
				return smallNestedMenu("menu3")

			-- BRITISH INFANTRY VET
			elseif menu3choice_sub4 == 2 then
				if object.pAllies.money >= param.replacementBritishInfantryVetCost then
					-- if totalBritishInfantryVet < counter.value("# British Veteran") then -- Cannot purchase unit if exceed maximum allowable
					-- ===================	
					local reinforcementsList = gen.createUnit(object.uBritishVeteran, object.pAllies, {{73,155,0}, {62,162,0}, {40,180,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacementBritishInfantryVetCost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A regiment of new "..object.uBritishVeteran.name.." arrives in "..reinforcementCity.name.." at a cost of "..param.replacementBritishInfantryVetCost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacementBritishInfantryVetCost)
								return smallNestedMenu("menu3")
							else
								civ.ui.text("A regiment of new " .. object.uBritishVeteran.name .. " arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementBritishInfantryVetCost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacementBritishInfantryVetCost)
								return smallNestedMenu("menu3")
							end
						else
							text.simple("Our replacement "..object.uBritishVeteran.name.." never arrived.")
						end	
					-- ===================	
					-- else
						-- civ.ui.text("The current number of " .. totalBritishInfantryVet .. " '" .. object.uBritishVeteran.name .. "' equals the maximun allowed!")
					-- end
				else
					civ.ui.text("It requires " .. param.replacementBritishInfantryVetCost .. " supplies to procure a new " .. object.uBritishVeteran.name .. " unit!")
					return smallNestedMenu("menu3")
				end	

			-- BRITISH INFANTRY REG
			elseif menu3choice_sub4 == 3 then	
				if object.pAllies.money >= param.replacementBritishInfantryRegCost then
					-- if totalBritishInfantryReg < counter.value("# British Regular") then -- Cannot purchase unit if exceed maximum allowable
					-- ===================	
					local reinforcementsList = gen.createUnit(object.uBritishRegular, object.pAllies, {{73,155,0}, {62,162,0}, {40,180,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacementBritishInfantryRegCost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A regiment of new "..object.uBritishRegular.name.." arrives in "..reinforcementCity.name.." at a cost of "..param.replacementBritishInfantryRegCost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacementBritishInfantryRegCost)
								return smallNestedMenu("menu3")
							else
								civ.ui.text("A regiment of new " .. object.uBritishRegular.name .. " arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementBritishInfantryRegCost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacementBritishInfantryRegCost)
								return smallNestedMenu("menu3")
							end
						else
							text.simple("Our replacement "..object.uBritishRegular.name.." never arrived.")
						end	
					-- ===================	
					-- else
						-- civ.ui.text("The current number of " .. totalBritishInfantryReg .. " '" .. object.uBritishRegular.name .. "' equals the maximun allowed!")
					-- end
				else
					civ.ui.text("It requires " .. param.replacementBritishInfantryRegCost .. " supplies to procure a new " .. object.uBritishRegular.name .. " unit!")
					return smallNestedMenu("menu3")
				end	
				
			-- BRITISH PIAT
			elseif menu3choice_sub4 == 4 then
				if object.pAllies.money >= param.replacementBritishPIATCost then
					-- if totalBritishPIAT < counter.value("# British PIAT") then -- Cannot purchase unit if exceed maximum allowable
					-- ===================	
					local reinforcementsList = gen.createUnit(object.uBritishPIAT, object.pAllies, {{73,155,0}, {62,162,0}, {40,180,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacementBritishPIATCost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A regiment of new "..object.uBritishPIAT.name.." arrives in "..reinforcementCity.name.." at a cost of "..param.replacementBritishPIATCost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacementBritishPIATCost)
								return smallNestedMenu("menu3")
							else
								civ.ui.text("A regiment of new " .. object.uBritishPIAT.name .. " arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementBritishPIATCost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacementBritishPIATCost)
								return smallNestedMenu("menu3")
							end
						else
							text.simple("Our replacement "..object.uBritishPIAT.name.." never arrived.")
						end	
					-- ===================	
					-- else
						-- civ.ui.text("The current number of " .. totalBritishPIAT .. " '" .. object.uBritishPIAT.name .. "' equals the maximun allowed!")
					-- end
				else
					civ.ui.text("It requires " .. param.replacementBritishPIATCost .. " supplies to procure a new " .. object.uBritishPIAT.name .. " unit!")
					return smallNestedMenu("menu3")
				end	
				
			-- BRITISH MG
			elseif menu3choice_sub4 == 5 then
				if object.pAllies.money >= param.replacementBritishMGCost then
					-- if totalBritishMG < counter.value("# British MG") then -- Cannot purchase unit if exceed maximum allowable
					-- ===================	
					local reinforcementsList = gen.createUnit(object.uBritishMG, object.pAllies, {{73,155,0}, {62,162,0}, {40,180,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacementBritishMGCost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A regiment of new "..object.uBritishMG.name.." arrives in "..reinforcementCity.name.." at a cost of "..param.replacementBritishMGCost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacementBritishMGCost)
								return smallNestedMenu("menu3")
							else
								civ.ui.text("A regiment of new " .. object.uBritishMG.name .. " arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementBritishMGCost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacementBritishMGCost)
								return smallNestedMenu("menu3")
							end
						else
							text.simple("Our replacement "..object.uBritishMG.name.." never arrived.")
						end	
					-- ===================	
					-- else
						-- civ.ui.text("The current number of " .. totalBritishMG .. " '" .. object.uBritishMG.name .. "' equals the maximun allowed!")
					-- end
				else
					civ.ui.text("It requires " .. param.replacementBritishMGCost .. " supplies to procure a new " .. object.uBritishMG.name .. " unit!")
					return smallNestedMenu("menu3")
				end	
				
			-- BRITISH COMMANDOS
			elseif menu3choice_sub4 == 6 then
				if object.pAllies.money >= param.replacementCommandosCost then
					-- if totalCommandos < counter.value("# Commandos") then -- Cannot purchase unit if exceed maximum allowable
					-- ===================	
					local reinforcementsList = gen.createUnit(object.uCommandos, object.pAllies, {{73,155,0}, {62,162,0}, {40,180,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacementCommandosCost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A regiment of new "..object.uCommandos.name.." arrives in "..reinforcementCity.name.." at a cost of "..param.replacementCommandosCost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacementCommandosCost)
								return smallNestedMenu("menu3")
							else
								civ.ui.text("A regiment of new " .. object.uCommandos.name .. " arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementCommandosCost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacementCommandosCost)
								return smallNestedMenu("menu3")
							end
						else
							text.simple("Our replacement "..object.uCommandos.name.." never arrived.")
						end	
					-- ===================	
					-- else
						-- civ.ui.text("The current number of " .. totalCommandos .. " '" .. object.uCommandos.name .. "' equals the maximun allowed!")
					-- end
				else
					civ.ui.text("It requires " .. param.replacementCommandosCost .. " supplies to procure a new " .. object.uCommandos.name .. " unit!")
					return smallNestedMenu("menu3")
				end	
				
			-- BRITISH 1ST AIRBORNE
			elseif menu3choice_sub4 == 7 then
				if object.pAllies.money >= param.replacement1stAirborneCost then
					-- if total1stAirborne < counter.value("# 1st Airborne") then -- Cannot purchase unit if exceed maximum allowable
					-- ===================	
					local reinforcementsList = gen.createUnit(object.u1stAirborne, object.pAllies, {{73,155,0}, {62,162,0}, {40,180,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacement1stAirborneCost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A regiment of new "..object.u1stAirborne.name.." arrives in "..reinforcementCity.name.." at a cost of "..param.replacement1stAirborneCost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacement1stAirborneCost)
								return smallNestedMenu("menu3")
							else
								civ.ui.text("A regiment of new " .. object.u1stAirborne.name .. " arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacement1stAirborneCost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacement1stAirborneCost)
								return smallNestedMenu("menu3")
							end
						else
							text.simple("Our replacement "..object.u1stAirborne.name.." never arrived.")
						end	
					-- ===================	
					-- else
						-- civ.ui.text("The current number of " .. total1stAirborne .. " '" .. object.u1stAirborne.name .. "' equals the maximun allowed!")
					-- end
				else
					civ.ui.text("It requires " .. param.replacement1stAirborneCost .. " supplies to procure a new " .. object.u1stAirborne.name .. " unit!")
					return smallNestedMenu("menu3")
				end	
				
			-- BRITISH 52ND MOUNTAIN
			elseif menu3choice_sub4 == 8 then
				if object.pAllies.money >= param.replacementBritish52ndMtnCost then
					-- if totalBritish52ndMtn < counter.value("# British 52nd Mountain") then -- Cannot purchase unit if exceed maximum allowable
					-- ===================	
					local reinforcementsList = gen.createUnit(object.uBritish52ndMtn, object.pAllies, {{73,155,0}, {62,162,0}, {40,180,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacementBritish52ndMtnCost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A regiment of new "..object.uBritish52ndMtn.name.." arrives in "..reinforcementCity.name.." at a cost of "..param.replacementBritish52ndMtnCost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacementBritish52ndMtnCost)
								return smallNestedMenu("menu3")
							else
								civ.ui.text("A regiment of new " .. object.uBritish52ndMtn.name .. " arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementBritish52ndMtnCost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacementBritish52ndMtnCost)
								return smallNestedMenu("menu3")
							end
						else
							text.simple("Our replacement "..object.uBritish52ndMtn.name.." never arrived.")
						end	
					-- ===================	
					-- else
						-- civ.ui.text("The current number of " .. totalBritish52ndMtn .. " '" .. object.uBritish52ndMtn.name .. "' equals the maximun allowed!")
					-- end
				else
					civ.ui.text("It requires " .. param.replacementBritish52ndMtnCost .. " supplies to procure a new " .. object.uBritish52ndMtn.name .. " unit!")
					return smallNestedMenu("menu3")
				end	
				
			-- EXIT MENUS
			elseif menu3choice_sub4 == 9 then
				-- civ.ui.text("Return to main menu!")
				return smallNestedMenu("menu1")	
			elseif menu3choice_sub4 == 10 then
				-- civ.ui.text("Exit procurement menu!")
				return 	
			end
		
		-- BRITISH ARTILLERY
		elseif menu3choice == 5 then
		
			local menuTitle = "British Artillery Replacements"
			local menuOptions = {}

			menuOptions[1]="Return to British Replacements menu!"
			if totalBishop25pdr < counter.value("# Bishop 25pdr") then
				menuOptions[2]="" .. object.uBishop25pdr.name .. " at " .. param.replacementBishop25pdrCost .. " supplies: " .. tostring(counter.value("# Bishop 25pdr") - totalBishop25pdr) .. " available to build."
			end
			if totalUKBofors40mmAA < counter.value("# UK Bofors 40mm AA") then
				menuOptions[3]="" .. object.uUKBofors40mmAA.name .. " at " .. param.replacementUKBofors40mmAACost .. " supplies: ".. tostring(counter.value("# UK Bofors 40mm AA") - totalUKBofors40mmAA) .. " available to build." 
			end
			if total25pdrMKIIArt < counter.value("# 25pdr MKII Art") then
				menuOptions[4]="" .. object.u25pdrMKIIArt.name .. " at " .. param.replacement25pdrMKIIArtCost .. " supplies: " .. tostring(counter.value("# 25pdr MKII Art") - total25pdrMKIIArt) .. " available to build."
			end
			if total55inchArt < counter.value("# 55inch Art") then
				menuOptions[5]="" .. object.u55inchArt.name .. " at " .. param.replacement55inchArtCost .. " supplies: " .. tostring(counter.value("# 55inch Art") - total55inchArt) .. " available to build."  
			end
			if total6pdrAT < counter.value("# 6pdr AT") then
				menuOptions[6]="" .. object.u6pdrAT.name .. " at " .. param.replacement6pdrATCost .. " supplies: " .. tostring(counter.value("# 6pdr AT") - total6pdrAT) .. " available to build."  
			end

			menuOptions[7]="Return to main menu!"
			menuOptions[8]="Exit procurement menu!"
			
			local menuText = "Which type of unit do you wish to procure?\n^(Current stock of supplies: ".. object.pAllies.money..")"	
			local menu3choice_sub5 = text.menu(menuOptions,menuText,menuTitle)			
			
			-- RETURN TO BRITISH REPLACEMENTS MENU
			if menu3choice_sub5 == 1 then
				-- civ.ui.text("Don't procure any replacement artillery!")
				return smallNestedMenu("menu3")
				
			-- BISHOP 25PDR
			elseif menu3choice_sub5 == 2 then
				if object.pAllies.money >= param.replacementBishop25pdrCost then
					-- if totalBishop25pdr < counter.value("# Bishop 25pdr") then -- Cannot purchase unit if exceed maximum allowable
					-- ===================	
					local reinforcementsList = gen.createUnit(object.uBishop25pdr, object.pAllies, {{73,155,0}, {62,162,0}, {40,180,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacementBishop25pdrCost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A regiment of new "..object.uBishop25pdr.name.." arrives in "..reinforcementCity.name.." at a cost of "..param.replacementBishop25pdrCost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacementBishop25pdrCost)
								return smallNestedMenu("menu3")
							else
								civ.ui.text("A regiment of new " .. object.uBishop25pdr.name .. " arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementBishop25pdrCost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacementBishop25pdrCost)
								return smallNestedMenu("menu3")
							end
						else
							text.simple("Our replacement "..object.uBishop25pdr.name.." never arrived.")
						end	
					-- ===================	
					-- else
						-- civ.ui.text("The current number of " .. totalBishop25pdr .. " '" .. object.uBishop25pdr.name .. "' equals the maximun allowed!")
					-- end
				else
					civ.ui.text("It requires " .. param.replacementBishop25pdrCost .. " supplies to procure a new " .. object.uBishop25pdr.name .. " unit!")
					return smallNestedMenu("menu3")
				end
			
			-- UK BOFORS 40MM AA
			elseif menu3choice_sub5 == 3 then
				if object.pAllies.money >= param.replacementUKBofors40mmAACost then
					-- if totalUKBofors40mmAA < counter.value("# UK Bofors 40mm AA") then -- Cannot purchase unit if exceed maximum allowable
					-- ===================	
					local reinforcementsList = gen.createUnit(object.uUKBofors40mmAA, object.pAllies, {{73,155,0}, {62,162,0}, {40,180,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacementUKBofors40mmAACost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A regiment of new "..object.uUKBofors40mmAA.name.." arrives in "..reinforcementCity.name.." at a cost of "..param.replacementUKBofors40mmAACost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacementUKBofors40mmAACost)
								return smallNestedMenu("menu3")
							else
								civ.ui.text("A regiment of new " .. object.uUKBofors40mmAA.name .. " arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementUKBofors40mmAACost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacementUKBofors40mmAACost)
								return smallNestedMenu("menu3")
							end
						else
							text.simple("Our replacement "..object.uUKBofors40mmAA.name.." never arrived.")
						end	
					-- ===================	
					-- else
						-- civ.ui.text("The current number of " .. totalUKBofors40mmAA .. " '" .. object.uUKBofors40mmAA.name .. "' equals the maximun allowed!")
					-- end
				else
					civ.ui.text("It requires " .. param.replacementUKBofors40mmAACost .. " supplies to procure a new " .. object.uUKBofors40mmAA.name .. " unit!")
					return smallNestedMenu("menu3")
				end
				
			-- 25PDR MKII ART
			elseif menu3choice_sub5 == 4 then
				if object.pAllies.money >= param.replacement25pdrMKIIArtCost then
					-- if total25pdrMKIIArt < counter.value("# 25pdr MKII Art") then -- Cannot purchase unit if exceed maximum allowable
					-- ===================	
					local reinforcementsList = gen.createUnit(object.u25pdrMKIIArt, object.pAllies, {{73,155,0}, {62,162,0}, {40,180,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacement25pdrMKIIArtCost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A regiment of new "..object.u25pdrMKIIArt.name.." arrives in "..reinforcementCity.name.." at a cost of "..param.replacement25pdrMKIIArtCost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacement25pdrMKIIArtCost)
								return smallNestedMenu("menu3")
							else
								civ.ui.text("A regiment of new " .. object.u25pdrMKIIArt.name .. " arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacement25pdrMKIIArtCost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacement25pdrMKIIArtCost)
								return smallNestedMenu("menu3")
							end
						else
							text.simple("Our replacement "..object.u25pdrMKIIArt.name.." never arrived.")
						end	
					-- ===================	
					-- else
						-- civ.ui.text("The current number of " .. total25pdrMKIIArt .. " '" .. object.u25pdrMKIIArt.name .. "' equals the maximun allowed!")
					-- end
				else
					civ.ui.text("It requires " .. param.replacement25pdrMKIIArtCost .. " supplies to procure a new " .. object.u25pdrMKIIArt.name .. " unit!")
					return smallNestedMenu("menu3")
				end
				
			-- 5.5INCH ART
			elseif menu3choice_sub5 == 5 then
				if object.pAllies.money >= param.replacement55inchArtCost then
					-- if total55inchArt < counter.value("# 55inch Art") then -- Cannot purchase unit if exceed maximum allowable
					-- ===================	
					local reinforcementsList = gen.createUnit(object.u55inchArt, object.pAllies, {{73,155,0}, {62,162,0}, {40,180,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacement55inchArtCost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A regiment of new "..object.u55inchArt.name.." arrives in "..reinforcementCity.name.." at a cost of "..param.replacement55inchArtCost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacement55inchArtCost)
								return smallNestedMenu("menu3")
							else
								civ.ui.text("A regiment of new " .. object.u55inchArt.name .. " arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacement55inchArtCost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacement55inchArtCost)
								return smallNestedMenu("menu3")
							end
						else
							text.simple("Our replacement "..object.u55inchArt.name.." never arrived.")
						end	
					-- ===================	
					-- else
						-- civ.ui.text("The current number of " .. total55inchArt .. " '" .. object.u55inchArt.name .. "' equals the maximun allowed!")
					-- end
				else
					civ.ui.text("It requires " .. param.replacement55inchArtCost .. " supplies to procure a new " .. object.u55inchArt.name .. " unit!")
					return smallNestedMenu("menu3")
				end
				
			-- 6 PDR ANTI-TANK
			elseif menu3choice_sub5 == 6 then
				if object.pAllies.money >= param.replacement6pdrATCost then
					-- if total6pdrAT < counter.value("# 6pdr AT") then -- Cannot purchase unit if exceed maximum allowable
					-- ===================	
					local reinforcementsList = gen.createUnit(object.u6pdrAT, object.pAllies, {{73,155,0}, {62,162,0}, {40,180,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacement6pdrATCost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A regiment of new "..object.u6pdrAT.name.." arrives in "..reinforcementCity.name.." at a cost of "..param.replacement6pdrATCost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacement6pdrATCost)
								return smallNestedMenu("menu3")
							else
								civ.ui.text("A regiment of new " .. object.u6pdrAT.name .. " arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacement6pdrATCost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacement6pdrATCost)
								return smallNestedMenu("menu3")
							end
						else
							text.simple("Our replacement "..object.u6pdrAT.name.." never arrived.")
						end	
					-- ===================	
					-- else
						-- civ.ui.text("The current number of " .. total6pdrAT .. " '" .. object.u6pdrAT.name .. "' equals the maximun allowed!")
					-- end
				else
					civ.ui.text("It requires " .. param.replacement6pdrATCost .. " supplies to procure a new " .. object.u6pdrAT.name .. " unit!")
					return smallNestedMenu("menu3")
				end
				
			-- EXIT MENUS
			elseif menu3choice_sub5 == 7 then
				-- civ.ui.text("Return to main menu!")
				return smallNestedMenu("menu1")	
			elseif menu3choice_sub5 == 8 then
				-- civ.ui.text("Exit procurement menu!")
				return 	
			end	
			
		-- Return to main menu
		elseif menu3choice == 6 then
            return smallNestedMenu("menu1")			
		
		-- Exit procurement menu
		elseif menu3choice == 7 then
            return 		
        end
		
	end
	
	-- ALLIED MINORS REPLACEMENTS MENU ========================================
    if menuType == "menu4" then
	
        local menuTitle = "Allied Minor Replacements"
		-- local menuOptions = {[1]="Canadian", [2]="Indian", [3]="New Zealand", [4]="South Africa", [5]="Brazil", [6]="France", [7]="Polish", [8]="Exit, do not procure replacements"}
		local menuOptions = {}
		if flag.value("Canadian units withdrawn") == false then
			-- menuOptions[1]="Canadian" 
			menuOptions[1]="Canadian:  " .. math.floor(tostring(counter.value("# Cdn Mot Inf") - totalCdnMotInf) + tostring(counter.value("# Cdn Sherman") - totalCdnSherman) + tostring(counter.value("# Cdn M7 105mm") - totalCdnM7105mm) + tostring(counter.value("# Cdn Bren Carrier") - totalCdnBrenCarrier) + tostring(counter.value("# Cdn Infantry") - totalCdnInfantry)) .. "  available to build." 
		end
		if flag.value("Indian Infantry units arrive") == true then
			-- menuOptions[2]="Indian" 
			menuOptions[2]="Indian:  " .. math.floor(tostring(counter.value("# Indian Infantry") - totalIndianInfantry) + tostring(counter.value("# 4th Indian Div") - total4thIndianDiv) + tostring(counter.value("# Gurkhas") - totalGurkhas) + tostring(counter.value("# Indian 25pdr Art") - totalIndian25pdrArt)) .. "  available to build."
		end	
		if flag.value("New Zealand units arrive") == true then
			-- menuOptions[3]="New Zealand" 
			menuOptions[3]="New Zealand:  " .. math.floor(tostring(counter.value("# NZ Mot Inf") - totalNZMotInf) + tostring(counter.value("# NZ Sherman") - totalNZSherman) + tostring(counter.value("# NZ 25pdr Art") - totalNZSexton)) .. "  available to build."
		end	
		if flag.value("South African units arrive") == true then
			-- menuOptions[4]="South African" 
			menuOptions[4]="South African:  " .. math.floor(tostring(counter.value("# SA Mot Inf") - totalSAMotInf) + tostring(counter.value("# SA Sherman") - totalSASherman) + tostring(counter.value("# SA Sexton") - totalSASexton) + tostring(counter.value("# SA Bren Carrier") - totalSABrenCarrier)) .. "  available to build."
		end
		if flag.value("Brazil Infantry units arrive") == true then
			-- menuOptions[5]="Brazil et al."
			menuOptions[5]="Brazil et al.:  " .. math.floor(tostring(counter.value("# Braz 1st Inf") - totalBraz1stInf) + tostring(counter.value("# Greek Mtn Bde") - totalGreekMtnBde) + tostring(counter.value("# Jewish Bde") - totalJewishBde)) .. "  available to build."
		end	
		if flag.value("Free French units arrive") == true then
			-- menuOptions[6]="French"
			menuOptions[6]="French:  " .. math.floor(tostring(counter.value("# Infanterie Coloniale") - totalInfanterieColoniale) + tostring(counter.value("# Goumier Marocain") - totalGoumierMarocain) + tostring(counter.value("# Tirailleur Algerien") - totalTirailleurAlgrien) + tostring(counter.value("# Free French Infantry") - totalFreeFrenchInfantry) + tostring(counter.value("# Free French 105Art") - totalFreeFrench105Art) + tostring(counter.value("# FreeFrenchM10") - totalFreeFrenchM10)) .. "  available to build."
		end		
		if flag.value("Polish units arrive") == true then
			-- menuOptions[7]="Polish" 
			menuOptions[7]="Polish:  " .. math.floor(tostring(counter.value("# Polish Sherman") - totalPolishSherman) + tostring(counter.value("# Polish Infantry") - totalPolishInfantry) + tostring(counter.value("# Polish 25pdr Art") - totalPolish25pdrArt)) .. "  available to build."
		end
		menuOptions[8]="Return to main menu!"
		menuOptions[9]="Exit procurement menu!"
		
		
		-- local menuText = "For which Allied Minor do you wish to procure units?: ".. object.pAllies.money.." supplies""	
		local menuText = "Allied Minor Replacements: ".. object.pAllies.money.." supplies"	
		local menu4choice = text.menu(menuOptions,menuText,menuTitle)	
		
		-- CANADIAN REPLACEMENTS
		if menu4choice == 1 then
			
			local menuTitle = "Canadian Replacements"
			
			-- Allows you to insert conditions within the menu if you want to prevent certain menu options from displaying
			local menuOptions = {}

			menuOptions[1]="Return to Allied Replacements menu!!"
			if totalCdnMotInf < counter.value("# Cdn Mot Inf") and flag.value("Cdn 5th Armored units arrive") == true then -- 
				menuOptions[2]="" .. object.uCdnMotInf.name .. " at " .. param.replacementCdnMotInfCost .. " supplies: " .. tostring(counter.value("# Cdn Mot Inf") - totalCdnMotInf) .. " available to build."
			end
			if totalCdnSherman < counter.value("# Cdn Sherman") and flag.value("Canadian units withdrawn") == false then
				menuOptions[3]="" .. object.uCdnShermanIII.name .. " at " .. param.replacementCdnShermanCost .. " supplies: " .. tostring(counter.value("# Cdn Sherman") - totalCdnSherman) .. " available to build."
			end
			if totalCdnM7105mm < counter.value("# Cdn M7 105mm") and flag.value("Cdn 5th Armored units arrive") == true then
				menuOptions[4]="" .. object.uCdnM7105mm.name .. " at " .. param.replacementCdnM7105mmCost .. " supplies: " .. tostring(counter.value("# Cdn M7 105mm") - totalCdnM7105mm) .. " available to build."
			end
			if totalCdnBrenCarrier < counter.value("# Cdn Bren Carrier") and flag.value("Cdn 5th Armored units arrive") == true then
				menuOptions[5]="" .. object.uCdnMotorTroops.name .. " at " .. param.replacementCdnBrenCarrierCost .. " supplies: " .. tostring(counter.value("# Cdn Bren Carrier") - totalCdnBrenCarrier) .. " available to build."
			end
			if totalCdnInfantry < counter.value("# Cdn Infantry") and flag.value("Canadian units withdrawn") == false then
				menuOptions[6]="" .. object.uCdnInfantry.name .. " at " .. param.replacementCdnInfantryCost .. " supplies: " .. tostring(counter.value("# Cdn Infantry") - totalCdnInfantry) .. " available to build."
			end

			menuOptions[7]="Return to main menu!"
			menuOptions[8]="Exit procurement menu!"
			
			local menuText = "Which type of unit do you wish to procure?\n^(Current stock of supplies: ".. object.pAllies.money..")"	
			local menu4choice_sub1 = text.menu(menuOptions,menuText,menuTitle)		

			-- RETURN TO ALLIED REPLACEMENTS MENU
			if menu4choice_sub1 == 1 then
				-- civ.ui.text("Don't procure any Canadian replacements!")
				return smallNestedMenu("menu4")			
			
			-- CANADIAN MOTORIZED INFANTRY
			elseif menu4choice_sub1 == 2 then
				if object.pAllies.money >= param.replacementCdnMotInfCost then
					-- if totalCdnMotInf < counter.value("# Cdn Mot Inf") then -- Cannot purchase unit if exceed maximum allowable
					-- ===================	
					local reinforcementsList = gen.createUnit(object.uCdnMotInf, object.pAllies, {{73,155,0}, {62,162,0}, {40,180,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacementCdnMotInfCost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A regiment of new "..object.uCdnMotInf.name.." arrives in "..reinforcementCity.name.." at a cost of "..param.replacementCdnMotInfCost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacementCdnMotInfCost)
								return smallNestedMenu("menu4")
							else
								civ.ui.text("A regiment of new " .. object.uCdnMotInf.name .. " arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementCdnMotInfCost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacementCdnMotInfCost)
								return smallNestedMenu("menu4")
							end
						else
							text.simple("Our replacement "..object.uCdnMotInf.name.." never arrived.")
						end	
					-- ===================	
					-- else
						-- civ.ui.text("The current number of " .. totalCdnMotInf .. " '" .. object.uCdnMotInf.name .. "' equals the maximun allowed!")
					-- end
				else
					civ.ui.text("It requires " .. param.replacementCdnMotInfCost .. " supplies to procure a new " .. object.uCdnMotInf.name .. " unit!")
					return smallNestedMenu("menu4")
				end	
			
			-- CANADIAN SHERMAN		
			elseif menu4choice_sub1 == 3 then	
				if object.pAllies.money >= param.replacementCdnShermanCost then
					-- if totalCdnSherman < counter.value("# Cdn Sherman") then -- Cannot purchase unit if exceed maximum allowable
					-- ===================	
					local reinforcementsList = gen.createUnit(object.uCdnShermanIII, object.pAllies, {{73,155,0}, {62,162,0}, {40,180,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacementCdnShermanCost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A regiment of new "..object.uCdnShermanIII.name.." arrives in "..reinforcementCity.name.." at a cost of "..param.replacementCdnShermanCost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacementCdnShermanCost)
								return smallNestedMenu("menu4")
							else
								civ.ui.text("A regiment of new " .. object.uCdnShermanIII.name .. " arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementCdnShermanCost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacementCdnShermanCost)
								return smallNestedMenu("menu4")
							end
						else
							text.simple("Our replacement "..object.uCdnShermanIII.name.." never arrived.")
						end	
					-- ===================	
					-- else
						-- civ.ui.text("The current number of " .. totalCdnSherman .. " '" .. object.uCdnShermanIII.name .. "' equals the maximun allowed!")
					-- end
				else
					civ.ui.text("It requires " .. param.replacementCdnShermanCost .. " supplies to procure a new " .. object.uCdnShermanIII.name .. " unit!")
					return smallNestedMenu("menu4")
				end	
				
			-- CANADIAN M7 105MM
			elseif menu4choice_sub1 == 4 then
				if object.pAllies.money >= param.replacementCdnM7105mmCost then
					-- if totalCdnM7105mm < counter.value("# Cdn M7 105mm") then -- Cannot purchase unit if exceed maximum allowable
					-- ===================	
					local reinforcementsList = gen.createUnit(object.uCdnM7105mm, object.pAllies, {{73,155,0}, {62,162,0}, {40,180,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacementCdnM7105mmCost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A regiment of new "..object.uCdnM7105mm.name.." arrives in "..reinforcementCity.name.." at a cost of "..param.replacementCdnM7105mmCost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacementCdnM7105mmCost)
								return smallNestedMenu("menu4")
							else
								civ.ui.text("A regiment of new " .. object.uCdnM7105mm.name .. " arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementCdnM7105mmCost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacementCdnM7105mmCost)
								return smallNestedMenu("menu4")
							end
						else
							text.simple("Our replacement "..object.uCdnM7105mm.name.." never arrived.")
						end	
					-- ===================	
					-- else
						-- civ.ui.text("The current number of " .. totalCdnM7105mm .. " '" .. object.uCdnM7105mm.name .. "' equals the maximun allowed!")
					-- end
				else
					civ.ui.text("It requires " .. param.replacementCdnM7105mmCost .. " supplies to procure a new " .. object.uCdnM7105mm.name .. " unit!")
					return smallNestedMenu("menu4")
				end	
				
			-- CANADIAN BREN CARRIER
			elseif menu4choice_sub1 == 5 then
				if object.pAllies.money >= param.replacementCdnBrenCarrierCost then
					-- if totalCdnBrenCarrier < counter.value("# Cdn Bren Carrier") then -- Cannot purchase unit if exceed maximum allowable
					-- ===================	
					local reinforcementsList = gen.createUnit(object.uCdnMotorTroops, object.pAllies, {{73,155,0}, {62,162,0}, {40,180,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacementCdnBrenCarrierCost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A regiment of new "..object.uCdnMotorTroops.name.." arrives in "..reinforcementCity.name.." at a cost of "..param.replacementCdnBrenCarrierCost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacementCdnBrenCarrierCost)
								return smallNestedMenu("menu4")
							else
								civ.ui.text("A regiment of new " .. object.uCdnMotorTroops.name .. " arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementCdnBrenCarrierCost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacementCdnBrenCarrierCost)
								return smallNestedMenu("menu4")
							end
						else
							text.simple("Our replacement "..object.uCdnMotorTroops.name.." never arrived.")
						end	
					-- ===================	
					-- else
						-- civ.ui.text("The current number of " .. totalCdnBrenCarrier .. " '" .. object.uCdnMotorTroops.name .. "' equals the maximun allowed!")
					-- end
				else
					civ.ui.text("It requires " .. param.replacementCdnBrenCarrierCost .. " supplies to procure a new " .. object.uCdnMotorTroops.name .. " unit!")
					return smallNestedMenu("menu4")
				end	
				
			-- CANADIAN INFANTRY
			elseif menu4choice_sub1 == 6 then
				if object.pAllies.money >= param.replacementCdnInfantryCost then
					-- if totalCdnInfantry < counter.value("# Cdn Infantry") then -- Cannot purchase unit if exceed maximum allowable
					-- ===================	
					local reinforcementsList = gen.createUnit(object.uCdnInfantry, object.pAllies, {{73,155,0}, {62,162,0}, {40,180,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacementCdnInfantryCost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A regiment of new "..object.uCdnInfantry.name.." arrives in "..reinforcementCity.name.." at a cost of "..param.replacementCdnInfantryCost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacementCdnInfantryCost)
								return smallNestedMenu("menu4")
							else
								civ.ui.text("A regiment of new " .. object.uCdnInfantry.name .. " arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementCdnInfantryCost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacementCdnInfantryCost)
								return smallNestedMenu("menu4")
							end
						else
							text.simple("Our replacement "..object.uCdnInfantry.name.." never arrived.")
						end	
					-- ===================	
					-- else
						-- civ.ui.text("The current number of " .. totalCdnInfantry .. " '" .. object.uCdnInfantry.name .. "' equals the maximun allowed!")
					-- end
				else
					civ.ui.text("It requires " .. param.replacementCdnInfantryCost .. " supplies to procure a new " .. object.uCdnInfantry.name .. " unit!")
					return smallNestedMenu("menu4")
				end	
				
			-- EXIT MENUS
			elseif menu4choice_sub1 == 7 then
				-- civ.ui.text("Return to main menu!")
				return smallNestedMenu("menu1")	
			elseif menu4choice_sub1 == 8 then
				-- civ.ui.text("Exit procurement menu!")
				return 	
			end
			
		-- INDIAN REPLACEMENTS
		elseif menu4choice == 2 then

			local menuTitle = "Indian Replacements"
			
			-- Allows you to insert conditions within the menu if you want to prevent certain menu options from displaying
			local menuOptions = {}

			menuOptions[1]="Return to Allied Replacements menu!"
			if totalIndianInfantry < counter.value("# Indian Infantry") and flag.value("Indian Infantry units arrive") == true then -- 
				menuOptions[2]="" .. object.uIndianInfantry.name .. " at " .. param.replacementIndianInfantryCost .. " supplies: " .. tostring(counter.value("# Indian Infantry") - totalIndianInfantry) .. " available to build."
			end
			if total4thIndianDiv < counter.value("# 4th Indian Div") and flag.value("4th Indian Infantry units arrive") == true then
				menuOptions[3]="" .. object.u4thIndianDiv.name .. " at " .. param.replacement4thIndianDivCost .. " supplies: " .. tostring(counter.value("# 4th Indian Div") - total4thIndianDiv) .. " available to build."
			end
			if totalGurkhas < counter.value("# Gurkhas") and flag.value("Gurkhas units arrived") == true then
				menuOptions[4]="" .. object.uGurkhas.name .. " at " .. param.replacementGurkhasCost .. " supplies: " .. tostring(counter.value("# Gurkhas") - totalGurkhas) .. " available to build."  
			end			
			if totalIndian25pdrArt < counter.value("# Indian 25pdr Art") and flag.value("10th Indian Infantry units arrive") == true then
				menuOptions[5]="" .. object.uIndian25pdrArt.name .. " at " .. param.replacementIndian25pdrArtCost .. " supplies: " .. tostring(counter.value("# Indian 25pdr Art") - totalIndian25pdrArt) .. " available to build."
			end

			menuOptions[6]="Return to main menu!"
			menuOptions[7]="Exit procurement menu!"
			
			local menuText = "Which type of unit do you wish to procure?\n^(Current stock of supplies: ".. object.pAllies.money..")"	
			local menu4choice_sub2 = text.menu(menuOptions,menuText,menuTitle)		

			-- RETURN TO ALLIED REPLACEMENTS MENU
			if menu4choice_sub2 == 1 then
				-- civ.ui.text("Don't procure any Canadian replacements!")
				return smallNestedMenu("menu4")

			-- INDIAN INFANTRY
			elseif menu4choice_sub2 == 2 then
				if object.pAllies.money >= param.replacementIndianInfantryCost then
					-- if totalIndianInfantry < counter.value("# Indian Infantry") then -- Cannot purchase unit if exceed maximum allowable
					-- ===================	
					local reinforcementsList = gen.createUnit(object.uIndianInfantry, object.pAllies, {{73,155,0}, {62,162,0}, {40,180,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacementIndianInfantryCost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A regiment of new "..object.uIndianInfantry.name.." arrives in "..reinforcementCity.name.." at a cost of "..param.replacementIndianInfantryCost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacementIndianInfantryCost)
								return smallNestedMenu("menu4")
							else
								civ.ui.text("A regiment of new " .. object.uIndianInfantry.name .. " arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementIndianInfantryCost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacementIndianInfantryCost)
								return smallNestedMenu("menu4")
							end
						else
							text.simple("Our replacement "..object.uIndianInfantry.name.." never arrived.")
						end	
					-- ===================	
					-- else
						-- civ.ui.text("The current number of " .. totalIndianInfantry .. " '" .. object.uIndianInfantry.name .. "' equals the maximun allowed!")
					-- end
				else
					civ.ui.text("It requires " .. param.replacementIndianInfantryCost .. " supplies to procure a new " .. object.uIndianInfantry.name .. " unit!")
					return smallNestedMenu("menu4")
				end	

			-- 4th INDIAN INFANTRY
			elseif menu4choice_sub2 == 3 then	
				if object.pAllies.money >= param.replacement4thIndianDivCost then
					-- if total4thIndianDiv < counter.value("# 4th Indian Div") then -- Cannot purchase unit if exceed maximum allowable
					-- ===================	
					local reinforcementsList = gen.createUnit(object.u4thIndianDiv, object.pAllies, {{73,155,0}, {62,162,0}, {40,180,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacement4thIndianDivCost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A regiment of new "..object.u4thIndianDiv.name.." arrives in "..reinforcementCity.name.." at a cost of "..param.replacement4thIndianDivCost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacement4thIndianDivCost)
								return smallNestedMenu("menu4")
							else
								civ.ui.text("A regiment of new " .. object.u4thIndianDiv.name .. " arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacement4thIndianDivCost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacement4thIndianDivCost)
								return smallNestedMenu("menu4")
							end
						else
							text.simple("Our replacement "..object.u4thIndianDiv.name.." never arrived.")
						end	
					-- ===================	
					-- else
						-- civ.ui.text("The current number of " .. total4thIndianDiv .. " '" .. object.u4thIndianDiv.name .. "' equals the maximun allowed!")
					-- end
				else
					civ.ui.text("It requires " .. param.replacement4thIndianDivCost .. " supplies to procure a new " .. object.u4thIndianDiv.name .. " unit!")
					return smallNestedMenu("menu4")
				end	

			-- GURKHAS
			elseif menu4choice_sub2 == 4 then
				if object.pAllies.money >= param.replacementGurkhasCost then
					-- if totalGurkhas < counter.value("# Gurkhas") then -- Cannot purchase unit if exceed maximum allowable
					-- ===================	
					local reinforcementsList = gen.createUnit(object.uGurkhas, object.pAllies, {{73,155,0}, {62,162,0}, {40,180,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacementGurkhasCost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A regiment of new "..object.uGurkhas.name.." arrives in "..reinforcementCity.name.." at a cost of "..param.replacementGurkhasCost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacementGurkhasCost)
								return smallNestedMenu("menu4")
							else
								civ.ui.text("A regiment of new " .. object.uGurkhas.name .. " arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementGurkhasCost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacementGurkhasCost)
								return smallNestedMenu("menu4")
							end
						else
							text.simple("Our replacement "..object.uGurkhas.name.." never arrived.")
						end	
					-- ===================	
					-- else
						-- civ.ui.text("The current number of " .. totalGurkhas .. " '" .. object.uGurkhas.name .. "' equals the maximun allowed!")
					-- end
				else
					civ.ui.text("It requires " .. param.replacementGurkhasCost .. " supplies to procure a new " .. object.uGurkhas.name .. " unit!")
					return smallNestedMenu("menu4")
				end	
				
			-- INDIAN 25PDR
			elseif menu4choice_sub2 == 5 then	
				if object.pAllies.money >= param.replacementIndian25pdrArtCost then
					-- if totalIndian25pdrArt < counter.value("# Indian 25pdr Art") then -- Cannot purchase unit if exceed maximum allowable
					-- ===================	
					local reinforcementsList = gen.createUnit(object.uIndian25pdrArt, object.pAllies, {{73,155,0}, {62,162,0}, {40,180,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacementIndian25pdrArtCost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A regiment of new "..object.uIndian25pdrArt.name.." arrives in "..reinforcementCity.name.." at a cost of "..param.replacementIndian25pdrArtCost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacementIndian25pdrArtCost)
								return smallNestedMenu("menu4")
							else
								civ.ui.text("A regiment of new " .. object.uIndian25pdrArt.name .. " arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementIndian25pdrArtCost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacementIndian25pdrArtCost)
								return smallNestedMenu("menu4")
							end
						else
							text.simple("Our replacement "..object.uIndian25pdrArt.name.." never arrived.")
						end	
					-- ===================	
					-- else
						-- civ.ui.text("The current number of " .. totalIndian25pdrArt .. " '" .. object.uIndian25pdrArt.name .. "' equals the maximun allowed!")
					-- end
				else
					civ.ui.text("It requires " .. param.replacementIndian25pdrArtCost .. " supplies to procure a new " .. object.uIndian25pdrArt.name .. " unit!")
					return smallNestedMenu("menu4")
				end	
				
			-- EXIT MENUS
			elseif menu4choice_sub2 == 6 then
				-- civ.ui.text("Return to main menu!")
				return smallNestedMenu("menu1")	
			elseif menu4choice_sub2 == 7 then
				-- civ.ui.text("Exit procurement menu!")
				return 	
			end
	
		-- NEW ZEALAND REPLACEMENTS
		elseif menu4choice == 3 then

			local menuTitle = "New Zealand Replacements"
			
			-- Allows you to insert conditions within the menu if you want to prevent certain menu options from displaying
			local menuOptions = {}
			
			menuOptions[1]="Return to Allied Replacements menu!"
			if totalNZMotInf < counter.value("# NZ Mot Inf") and flag.value("New Zealand units arrive") == true then -- 
				menuOptions[2]="" .. object.uNZMotInf.name .. " at " .. param.replacementNZMotInfCost .. " supplies: " .. tostring(counter.value("# NZ Mot Inf") - totalNZMotInf) .. " available to build."
			end
			if totalNZSherman < counter.value("# NZ Sherman") and flag.value("New Zealand units arrive") == true then
				menuOptions[3]="" .. object.uNZShermanIII.name .. " at " .. param.replacementNZShermanCost .. " supplies: " .. tostring(counter.value("# NZ Sherman") - totalNZSherman) .. " available to build."
			end
			if totalNZSexton < counter.value("# NZ 25pdr Art") and flag.value("New Zealand units arrive") == true then
				menuOptions[4]="" .. object.uNZ25pdrArt.name .. " at " .. param.replacementNZ25pdrArtCost .. " supplies: " .. tostring(counter.value("# NZ 25pdr Art") - totalNZSexton) .. " available to build."
			end

			menuOptions[5]="Return to main menu!"
			menuOptions[6]="Exit procurement menu!"

			local menuText = "Which type of unit do you wish to procure?\n^(Current stock of supplies: ".. object.pAllies.money..")"	
			local menu4choice_sub3 = text.menu(menuOptions,menuText,menuTitle)		

			-- RETURN TO ALLIED REPLACEMENTS MENU
			if menu4choice_sub3 == 1 then
				-- civ.ui.text("Don't procure any New Zealand replacements!")
				return smallNestedMenu("menu4")

			-- NEW ZEALAND MOTORIZED INFANTRY
			elseif menu4choice_sub3 == 2 then
				if object.pAllies.money >= param.replacementNZMotInfCost then
					-- if totalNZMotInf < counter.value("# NZ Mot Inf") then -- Cannot purchase unit if exceed maximum allowable
					-- ===================	
					local reinforcementsList = gen.createUnit(object.uNZMotInf, object.pAllies, {{73,155,0}, {62,162,0}, {40,180,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacementNZMotInfCost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A regiment of new "..object.uNZMotInf.name.." arrives in "..reinforcementCity.name.." at a cost of "..param.replacementNZMotInfCost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacementNZMotInfCost)
								return smallNestedMenu("menu4")
							else
								civ.ui.text("A regiment of new " .. object.uNZMotInf.name .. " arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementNZMotInfCost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacementNZMotInfCost)
								return smallNestedMenu("menu4")
							end
						else
							text.simple("Our replacement "..object.uNZMotInf.name.." never arrived.")
						end	
					-- ===================	
					-- else
						-- civ.ui.text("The current number of " .. totalNZMotInf .. " '" .. object.uNZMotInf.name .. "' equals the maximun allowed!")
					-- end
				else
					civ.ui.text("It requires " .. param.replacementNZMotInfCost .. " supplies to procure a new " .. object.uNZMotInf.name .. " unit!")
					return smallNestedMenu("menu4")
				end	

			-- NEW ZEALAND SHERMAN
			elseif menu4choice_sub3 == 3 then	
				if object.pAllies.money >= param.replacementNZShermanCost then
					-- if totalNZSherman < counter.value("# NZ Sherman") then -- Cannot purchase unit if exceed maximum allowable
					-- ===================	
					local reinforcementsList = gen.createUnit(object.uNZShermanIII, object.pAllies, {{73,155,0}, {62,162,0}, {40,180,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacementNZShermanCost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A regiment of new "..object.uNZShermanIII.name.." arrives in "..reinforcementCity.name.." at a cost of "..param.replacementNZShermanCost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacementNZShermanCost)
								return smallNestedMenu("menu4")
							else
								civ.ui.text("A regiment of new " .. object.uNZShermanIII.name .. " arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementNZShermanCost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacementNZShermanCost)
								return smallNestedMenu("menu4")
							end
						else
							text.simple("Our replacement "..object.uNZShermanIII.name.." never arrived.")
						end	
					-- ===================	
					-- else
						-- civ.ui.text("The current number of " .. totalNZSherman .. " '" .. object.uNZShermanIII.name .. "' equals the maximun allowed!")
					-- end
				else
					civ.ui.text("It requires " .. param.replacementNZShermanCost .. " supplies to procure a new " .. object.uNZShermanIII.name .. " unit!")
					return smallNestedMenu("menu4")
				end	
				
			-- NEW ZEALAND SEXTON
			elseif menu4choice_sub3 == 4 then	
				if object.pAllies.money >= param.replacementNZ25pdrArtCost then
					-- if totalNZSexton < counter.value("# NZ 25pdr Art") then -- Cannot purchase unit if exceed maximum allowable
					-- ===================	
					local reinforcementsList = gen.createUnit(object.uNZ25pdrArt, object.pAllies, {{73,155,0}, {62,162,0}, {40,180,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacementNZ25pdrArtCost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A regiment of new "..object.uNZ25pdrArt.name.." arrives in "..reinforcementCity.name.." at a cost of "..param.replacementNZ25pdrArtCost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacementNZ25pdrArtCost)
								return smallNestedMenu("menu4")
							else
								civ.ui.text("A regiment of new " .. object.uNZ25pdrArt.name .. " arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementNZ25pdrArtCost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacementNZ25pdrArtCost)
								return smallNestedMenu("menu4")
							end
						else
							text.simple("Our replacement "..object.uNZ25pdrArt.name.." never arrived.")
						end	
					-- ===================	
					-- else
						-- civ.ui.text("The current number of " .. totalNZSexton .. " '" .. object.uNZ25pdrArt.name .. "' equals the maximun allowed!")
					-- end
				else
					civ.ui.text("It requires " .. param.replacementNZ25pdrArtCost .. " supplies to procure a new " .. object.uNZ25pdrArt.name .. " unit!")
					return smallNestedMenu("menu4")
				end	
				
			-- EXIT MENUS
			elseif menu4choice_sub3 == 5 then
				-- civ.ui.text("Return to main menu!")
				return smallNestedMenu("menu1")	
			elseif menu4choice_sub3 == 6 then
				-- civ.ui.text("Exit procurement menu!")
				return 	
			end

		-- SOUTH AFRICAN REPLACEMENTS
		elseif menu4choice == 4 then

			local menuTitle = "South African Replacements"
			
			-- Allows you to insert conditions within the menu if you want to prevent certain menu options from displaying
			local menuOptions = {}

			menuOptions[1]="Return to Allied Replacements menu!"
			if totalSAMotInf < counter.value("# SA Mot Inf") and flag.value("South African units arrive") == true then -- 
				menuOptions[2]="" .. object.uSAMotInf.name .. " at " .. param.replacementSAMotInfCost .. " supplies: " .. tostring(counter.value("# SA Mot Inf") - totalSAMotInf) .. " available to build."
			end
			if totalSASherman < counter.value("# SA Sherman") and flag.value("South African units arrive") == true then
				menuOptions[3]="" .. object.uSAShermanIII.name .. " at " .. param.replacementSAShermanCost .. " supplies: " .. tostring(counter.value("# SA Sherman") - totalSASherman) .. " available to build."
			end
			if totalSASexton < counter.value("# SA Sexton") and flag.value("South African units arrive") == true then
				menuOptions[4]="" .. object.uSASexton.name .. " at " .. param.replacementSASextonCost .. " supplies: " .. tostring(counter.value("# SA Sexton") - totalSASexton) .. " available to build."
			end
			if totalSABrenCarrier < counter.value("# SA Bren Carrier") and flag.value("South African units arrive") == true then
				menuOptions[5]="" .. object.uSAMotorTroops.name .. " at " .. param.replacementSABrenCarrierCost .. " supplies: " .. tostring(counter.value("# SA Bren Carrier") - totalSABrenCarrier) .. " available to build."
			end

			menuOptions[6]="Return to main menu!"
			menuOptions[7]="Exit procurement menu!"

			local menuText = "Which type of unit do you wish to procure?\n^(Current stock of supplies: ".. object.pAllies.money..")"	
			local menu4choice_sub4 = text.menu(menuOptions,menuText,menuTitle)		

			-- RETURN TO ALLIED REPLACEMENTS MENU
			if menu4choice_sub4 == 1 then
				-- civ.ui.text("Don't procure any South African replacements!")
				return smallNestedMenu("menu4")
				
			-- SOUTH AFRICAN MOTORIZED INFANTRY
			elseif menu4choice_sub4 == 2 then
				if object.pAllies.money >= param.replacementSAMotInfCost then
					-- if totalSAMotInf < counter.value("# SA Mot Inf") then -- Cannot purchase unit if exceed maximum allowable
					-- ===================	
					local reinforcementsList = gen.createUnit(object.uSAMotInf, object.pAllies, {{73,155,0}, {62,162,0}, {40,180,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacementSAMotInfCost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A regiment of new "..object.uSAMotInf.name.." arrives in "..reinforcementCity.name.." at a cost of "..param.replacementSAMotInfCost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacementSAMotInfCost)
								return smallNestedMenu("menu4")
							else
								civ.ui.text("A regiment of new " .. object.uSAMotInf.name .. " arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementSAMotInfCost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacementSAMotInfCost)
								return smallNestedMenu("menu4")
							end
						else
							text.simple("Our replacement "..object.uSAMotInf.name.." never arrived.")
						end	
					-- ===================	
					-- else
						-- civ.ui.text("The current number of " .. totalSAMotInf .. " '" .. object.uSAMotInf.name .. "' equals the maximun allowed!")
					-- end
				else
					civ.ui.text("It requires " .. param.replacementSAMotInfCost .. " supplies to procure a new " .. object.uSAMotInf.name .. " unit!")
					return smallNestedMenu("menu4")
				end	

			-- SOUTH AFRICAN SHERMAN
			elseif menu4choice_sub4 == 3 then	
				if object.pAllies.money >= param.replacementSAShermanCost then
					-- if totalSASherman < counter.value("# SA Sherman") then -- Cannot purchase unit if exceed maximum allowable
					-- ===================	
					local reinforcementsList = gen.createUnit(object.uSAShermanIII, object.pAllies, {{73,155,0}, {62,162,0}, {40,180,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacementSAShermanCost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A regiment of new "..object.uSAShermanIII.name.." arrives in "..reinforcementCity.name.." at a cost of "..param.replacementSAShermanCost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacementSAShermanCost)
								return smallNestedMenu("menu4")
							else
								civ.ui.text("A regiment of new " .. object.uSAShermanIII.name .. " arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementSAShermanCost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacementSAShermanCost)
								return smallNestedMenu("menu4")
							end
						else
							text.simple("Our replacement "..object.uSAShermanIII.name.." never arrived.")
						end	
					-- ===================	
					-- else
						-- civ.ui.text("The current number of " .. totalSASherman .. " '" .. object.uSAShermanIII.name .. "' equals the maximun allowed!")
					-- end
				else
					civ.ui.text("It requires " .. param.replacementSAShermanCost .. " supplies to procure a new " .. object.uSAShermanIII.name .. " unit!")
					return smallNestedMenu("menu4")
				end	
				
			-- SOUTH AFRICAN SEXTON
			elseif menu4choice_sub4 == 4 then	
				if object.pAllies.money >= param.replacementSASextonCost then
					-- if totalSASexton < counter.value("# SA Sexton") then -- Cannot purchase unit if exceed maximum allowable
					-- ===================	
					local reinforcementsList = gen.createUnit(object.uSASexton, object.pAllies, {{73,155,0}, {62,162,0}, {40,180,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacementSASextonCost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A regiment of new "..object.uSASexton.name.." arrives in "..reinforcementCity.name.." at a cost of "..param.replacementSASextonCost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacementSASextonCost)
								return smallNestedMenu("menu4")
							else
								civ.ui.text("A regiment of new " .. object.uSASexton.name .. " arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementSASextonCost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacementSASextonCost)
								return smallNestedMenu("menu4")
							end
						else
							text.simple("Our replacement "..object.uSASexton.name.." never arrived.")
						end	
					-- ===================	
					-- else
						-- civ.ui.text("The current number of " .. totalSASexton .. " '" .. object.uSASexton.name .. "' equals the maximun allowed!")
					-- end
				else
					civ.ui.text("It requires " .. param.replacementSASextonCost .. " supplies to procure a new " .. object.uSASexton.name .. " unit!")
					return smallNestedMenu("menu4")
				end

			-- SOUTH AFRICAN BREN CARRIER
			elseif menu4choice_sub4 == 5 then	
				if object.pAllies.money >= param.replacementSABrenCarrierCost then
					-- if totalSABrenCarrier < counter.value("# SA Bren Carrier") then -- Cannot purchase unit if exceed maximum allowable
					-- ===================	
					local reinforcementsList = gen.createUnit(object.uSAMotorTroops, object.pAllies, {{73,155,0}, {62,162,0}, {40,180,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacementSABrenCarrierCost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A regiment of new "..object.uSAMotorTroops.name.." arrives in "..reinforcementCity.name.." at a cost of "..param.replacementSABrenCarrierCost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacementSABrenCarrierCost)
								return smallNestedMenu("menu4")
							else
								civ.ui.text("A regiment of new " .. object.uSAMotorTroops.name .. " arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementSABrenCarrierCost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacementSABrenCarrierCost)
								return smallNestedMenu("menu4")
							end
						else
							text.simple("Our replacement "..object.uSAMotorTroops.name.." never arrived.")
						end	
					-- ===================	
					-- else
						-- civ.ui.text("The current number of " .. totalSABrenCarrier .. " '" .. object.uSAMotorTroops.name .. "' equals the maximun allowed!")
					-- end
				else
					civ.ui.text("It requires " .. param.replacementSABrenCarrierCost .. " supplies to procure a new " .. object.uSAMotorTroops.name .. " unit!")
					return smallNestedMenu("menu4")
				end					
				
			-- EXIT MENUS
			elseif menu4choice_sub4 == 6 then
				-- civ.ui.text("Return to main menu!")
				return smallNestedMenu("menu1")	
			elseif menu4choice_sub4 == 7 then
				-- civ.ui.text("Exit procurement menu!")
				return 
			end

		-- BRAZIL et Al. REPLACEMENTS
		elseif menu4choice == 5 then

			local menuTitle = "Brazil et Al. Replacements"
			
			-- Allows you to insert conditions within the menu if you want to prevent certain menu options from displaying
			local menuOptions = {}

			menuOptions[1]="Return to Allied Replacements menu!"
			if totalBraz1stInf < counter.value("# Braz 1st Inf") and flag.value("Brazil Infantry units arrive") == true then -- 
				menuOptions[2]="" .. object.uBraz1stInf.name .. " at " .. param.replacementBraz1stInfCost .. " supplies: " .. tostring(counter.value("# Braz 1st Inf") - totalBraz1stInf) .. " available to build."
			end
			if totalGreekMtnBde < counter.value("# Greek Mtn Bde") and flag.value("Greek Infantry units arrive") == true then -- 
				menuOptions[3]="" .. object.uGreekMtnBde.name .. " at " .. param.replacementGreekMtnBdeCost .. " supplies: " .. tostring(counter.value("# Greek Mtn Bde") - totalGreekMtnBde) .. " available to build."
			end
			if totalJewishBde < counter.value("# Jewish Bde") and flag.value("Jewish Infantry units arrive") == true then -- 
				menuOptions[4]="" .. object.uJewishBde.name .. " at " .. param.replacementJewishBdeCost .. " supplies: " .. tostring(counter.value("# Jewish Bde") - totalJewishBde) .. " available to build."
			end			

			menuOptions[5]="Return to main menu!"
			menuOptions[6]="Exit procurement menu!"
			
			local menuText = "Which type of unit do you wish to procure?\n^(Current stock of supplies: ".. object.pAllies.money..")"	
			local menu4choice_sub5 = text.menu(menuOptions,menuText,menuTitle)

			-- RETURN TO ALLIED REPLACEMENTS MENU
			if menu4choice_sub5 == 1 then
				-- civ.ui.text("Don't procure any Brazilian et Al. replacements!")
				return smallNestedMenu("menu4")
				
			-- BRAZILIAN INFANTRY
			elseif menu4choice_sub5 == 2 then
				if object.pAllies.money >= param.replacementBraz1stInfCost then
					-- if totalBraz1stInf < counter.value("# Braz 1st Inf") then -- Cannot purchase unit if exceed maximum allowable
					-- ===================	
					local reinforcementsList = gen.createUnit(object.uBraz1stInf, object.pAllies, {{0,136,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacementBraz1stInfCost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A regiment of new "..object.uBraz1stInf.name.." arrives in "..reinforcementCity.name.." at a cost of "..param.replacementBraz1stInfCost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacementBraz1stInfCost)
								return smallNestedMenu("menu4")
							else
								civ.ui.text("A regiment of new " .. object.uBraz1stInf.name .. " arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementBraz1stInfCost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacementBraz1stInfCost)
								return smallNestedMenu("menu4")
							end
						else
							text.simple("Our replacement "..object.uBraz1stInf.name.." never arrived.")
						end	
					-- ===================	
					-- else
						-- civ.ui.text("The current number of " .. totalBraz1stInf .. " '" .. object.uBraz1stInf.name .. "' equals the maximun allowed!")
					-- end
				else
					civ.ui.text("It requires " .. param.replacementBraz1stInfCost .. " supplies to procure a new " .. object.uBraz1stInf.name .. " unit!")
					return smallNestedMenu("menu4")
				end	

			-- GREEK MOUNTAIN INFANTRY	
			elseif menu4choice_sub5 == 3 then
				if object.pAllies.money >= param.replacementGreekMtnBdeCost then
					-- if totalGreekMtnBde < counter.value("# Greek Mtn Bde") then -- Cannot purchase unit if exceed maximum allowable
					-- ===================	
					local reinforcementsList = gen.createUnit(object.uGreekMtnBde, object.pAllies, {{0,136,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacementGreekMtnBdeCost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A regiment of new "..object.uGreekMtnBde.name.." arrives in "..reinforcementCity.name.." at a cost of "..param.replacementGreekMtnBdeCost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacementGreekMtnBdeCost)
								return smallNestedMenu("menu4")
							else
								civ.ui.text("A regiment of new " .. object.uGreekMtnBde.name .. " arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementGreekMtnBdeCost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacementGreekMtnBdeCost)
								return smallNestedMenu("menu4")
							end
						else
							text.simple("Our replacement "..object.uGreekMtnBde.name.." never arrived.")
						end	
					-- ===================	
					-- else
						-- civ.ui.text("The current number of " .. totalGreekMtnBde .. " '" .. object.uGreekMtnBde.name .. "' equals the maximun allowed!")
					-- end
				else
					civ.ui.text("It requires " .. param.replacementGreekMtnBdeCost .. " supplies to procure a new " .. object.uGreekMtnBde.name .. " unit!")
					return smallNestedMenu("menu4")
				end

			-- JEWISH INFANTRY	
			elseif menu4choice_sub5 == 4 then
				if object.pAllies.money >= param.replacementJewishBdeCost then
					-- if totalJewishBde < counter.value("# Jewish Bde") then -- Cannot purchase unit if exceed maximum allowable
					-- ===================	
					local reinforcementsList = gen.createUnit(object.uJewishBde, object.pAllies, {{0,136,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacementJewishBdeCost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A regiment of new "..object.uJewishBde.name.." arrives in "..reinforcementCity.name.." at a cost of "..param.replacementJewishBdeCost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacementJewishBdeCost)
								return smallNestedMenu("menu4")
							else
								civ.ui.text("A regiment of new " .. object.uJewishBde.name .. " arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementJewishBdeCost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacementJewishBdeCost)
								return smallNestedMenu("menu4")
							end
						else
							text.simple("Our replacement "..object.uJewishBde.name.." never arrived.")
						end	
					-- ===================	
					-- else
						-- civ.ui.text("The current number of " .. totalJewishBde .. " '" .. object.uJewishBde.name .. "' equals the maximun allowed!")
					-- end
				else
					civ.ui.text("It requires " .. param.replacementJewishBdeCost .. " supplies to procure a new " .. object.uJewishBde.name .. " unit!")
					return smallNestedMenu("menu4")
				end
				
			-- EXIT MENUS
			elseif menu4choice_sub5 == 5 then
				-- civ.ui.text("Return to main menu!")
				return smallNestedMenu("menu1")	
			elseif menu4choice_sub5 == 6 then
				-- civ.ui.text("Exit procurement menu!")
				return 
			end

		-- FRENCH REPLACEMENTS
		elseif menu4choice == 6 then

			local menuTitle = "French Replacements"
			
			-- Allows you to insert conditions within the menu if you want to prevent certain menu options from displaying
			local menuOptions = {}

			menuOptions[1]="Return to Allied Replacements menu!"
			if totalInfanterieColoniale < counter.value("# Infanterie Coloniale") and flag.value("Free French units arrive") == true then -- 
				menuOptions[2]="" .. object.uInfanterieColoniale.name .. " at " .. param.replacementInfanterieColonialeCost .. " supplies: " .. tostring(counter.value("# Infanterie Coloniale") - totalInfanterieColoniale) .. " available to build."
			end
			if totalGoumierMarocain < counter.value("# Goumier Marocain") and flag.value("Goumier Marocain units arrive") == true then -- 
				menuOptions[3]="" .. object.uGoumierMarocain.name .. " at " .. param.replacementGoumierMarocainCost .. " supplies: " .. tostring(counter.value("# Goumier Marocain") - totalGoumierMarocain) .. " available to build."
			end
			if totalTirailleurAlgrien < counter.value("# Tirailleur Algerien") and flag.value("Tirailleur Algérien units arrive") == true then
				menuOptions[4]="" .. object.uTirailleurAlgerien.name .. " at " .. param.replacementTirailleurAlgrienCost .. " supplies: " .. tostring(counter.value("# Tirailleur Algerien") - totalTirailleurAlgrien) .. " available to build."
			end
			if totalFreeFrenchInfantry < counter.value("# Free French Infantry") and flag.value("Free French units arrive") == true then
				menuOptions[5]="" .. object.uFreeFrenchInfantry.name .. " at " .. param.replacementFreeFrenchInfantryCost .. " supplies: " .. tostring(counter.value("# Free French Infantry") - totalFreeFrenchInfantry) .. " available to build."
			end
			if totalFreeFrench105Art < counter.value("# Free French 105Art") and flag.value("Free French units arrive") == true then
				menuOptions[6]="" .. object.uFreeFrench105Art.name .. " at " .. param.replacementFreeFrench105ArtCost .. " supplies: " .. tostring(counter.value("# Free French 105Art") - totalFreeFrench105Art) .. " available to build."
			end
			if totalFreeFrenchM10 < counter.value("# FreeFrenchM10") and flag.value("Free French units arrive") == true then
				menuOptions[7]="" .. object.uFreeFrenchM10.name .. " at " .. param.replacementFreeFrenchM10Cost .. " supplies: " .. tostring(counter.value("# FreeFrenchM10") - totalFreeFrenchM10) .. " available to build."
			end

			menuOptions[8]="Return to main menu!"
			menuOptions[9]="Exit procurement menu!"
			
			local menuText = "Which type of unit do you wish to procure?\n^(Current stock of supplies: ".. object.pAllies.money..")"	
			local menu4choice_sub6 = text.menu(menuOptions,menuText,menuTitle)		

			-- RETURN TO ALLIED REPLACEMENTS MENU
			if menu4choice_sub6 == 1 then
				-- civ.ui.text("Don't procure any French replacements!")
				return smallNestedMenu("menu4")
				
			-- FRENCH INFANTERIE COLONIALE
			elseif menu4choice_sub6 == 2 then
				if object.pAllies.money >= param.replacementInfanterieColonialeCost then
					-- if totalInfanterieColoniale < counter.value("# Infanterie Coloniale") then -- Cannot purchase unit if exceed maximum allowable
					-- ===================	
					local reinforcementsList = gen.createUnit(object.uInfanterieColoniale, object.pAllies, {{44,140,0},{0,136,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacementInfanterieColonialeCost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A regiment of new "..object.uInfanterieColoniale.name.." arrives in "..reinforcementCity.name.." at a cost of "..param.replacementInfanterieColonialeCost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacementInfanterieColonialeCost)
								return smallNestedMenu("menu4")
							else
								civ.ui.text("A regiment of new " .. object.uInfanterieColoniale.name .. " arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementInfanterieColonialeCost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacementInfanterieColonialeCost)
								return smallNestedMenu("menu4")
							end
						else
							text.simple("Our replacement "..object.uInfanterieColoniale.name.." never arrived.")
						end	
					-- ===================	
					-- else
						-- civ.ui.text("The current number of " .. totalInfanterieColoniale .. " '" .. object.uInfanterieColoniale.name .. "' equals the maximun allowed!")
					-- end
				else
					civ.ui.text("It requires " .. param.replacementInfanterieColonialeCost .. " supplies to procure a new " .. object.uInfanterieColoniale.name .. " unit!")
					return smallNestedMenu("menu4")
				end				
			
			-- FRENCH GOUMIER MAROCAIN
			elseif menu4choice_sub6 == 3 then
				if object.pAllies.money >= param.replacementGoumierMarocainCost then
					-- if totalGoumierMarocain < counter.value("# Goumier Marocain") then -- Cannot purchase unit if exceed maximum allowable
					-- ===================	
					local reinforcementsList = gen.createUnit(object.uGoumierMarocain, object.pAllies, {{44,140,0},{0,136,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacementGoumierMarocainCost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A regiment of new "..object.uGoumierMarocain.name.." arrives in "..reinforcementCity.name.." at a cost of "..param.replacementGoumierMarocainCost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacementGoumierMarocainCost)
								return smallNestedMenu("menu4")
							else
								civ.ui.text("A regiment of new " .. object.uGoumierMarocain.name .. " arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementGoumierMarocainCost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacementGoumierMarocainCost)
								return smallNestedMenu("menu4")
							end
						else
							text.simple("Our replacement "..object.uGoumierMarocain.name.." never arrived.")
						end	
					-- ===================	
					-- else
						-- civ.ui.text("The current number of " .. totalGoumierMarocain .. " '" .. object.uGoumierMarocain.name .. "' equals the maximun allowed!")
					-- end
				else
					civ.ui.text("It requires " .. param.replacementGoumierMarocainCost .. " supplies to procure a new " .. object.uGoumierMarocain.name .. " unit!")
					return smallNestedMenu("menu4")
				end	
				
			-- FRENCH TIRAILLEUR ALGERIEN
			elseif menu4choice_sub6 == 4 then
					if object.pAllies.money >= param.replacementTirailleurAlgrienCost then
					-- if totalTirailleurAlgrien < counter.value("# Tirailleur Algerien") then -- Cannot purchase unit if exceed maximum allowable
					-- ===================	
					local reinforcementsList = gen.createUnit(object.uTirailleurAlgerien, object.pAllies, {{44,140,0},{0,136,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacementTirailleurAlgrienCost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A regiment of new "..object.uTirailleurAlgerien.name.." arrives in "..reinforcementCity.name.." at a cost of "..param.replacementTirailleurAlgrienCost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacementTirailleurAlgrienCost)
								return smallNestedMenu("menu4")
							else
								civ.ui.text("A regiment of new " .. object.uTirailleurAlgerien.name .. " arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementTirailleurAlgrienCost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacementTirailleurAlgrienCost)
								return smallNestedMenu("menu4")
							end
						else
							text.simple("Our replacement "..object.uTirailleurAlgerien.name.." never arrived.")
						end	
					-- ===================	
					-- else
						-- civ.ui.text("The current number of " .. totalTirailleurAlgrien .. " '" .. object.uTirailleurAlgerien.name .. "' equals the maximun allowed!")
					-- end
				else
					civ.ui.text("It requires " .. param.replacementTirailleurAlgrienCost .. " supplies to procure a new " .. object.uTirailleurAlgerien.name .. " unit!")
					return smallNestedMenu("menu4")
				end	
		
			-- FREE FRENCH INFANTRY
			elseif menu4choice_sub6 == 5 then
					if object.pAllies.money >= param.replacementFreeFrenchInfantryCost then
					-- if totalFreeFrenchInfantry < counter.value("# Free French Infantry") then -- Cannot purchase unit if exceed maximum allowable
					-- ===================	
					local reinforcementsList = gen.createUnit(object.uFreeFrenchInfantry, object.pAllies, {{44,140,0},{0,136,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacementFreeFrenchInfantryCost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A regiment of new "..object.uFreeFrenchInfantry.name.." arrives in "..reinforcementCity.name.." at a cost of "..param.replacementFreeFrenchInfantryCost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacementFreeFrenchInfantryCost)
								return smallNestedMenu("menu4")
							else
								civ.ui.text("A regiment of new " .. object.uFreeFrenchInfantry.name .. " arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementFreeFrenchInfantryCost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacementFreeFrenchInfantryCost)
								return smallNestedMenu("menu4")
							end
						else
							text.simple("Our replacement "..object.uFreeFrenchInfantry.name.." never arrived.")
						end	
					-- ===================	
					-- else
						-- civ.ui.text("The current number of " .. totalFreeFrenchInfantry .. " '" .. object.uFreeFrenchInfantry.name .. "' equals the maximun allowed!")
					-- end
				else
					civ.ui.text("It requires " .. param.replacementFreeFrenchInfantryCost .. " supplies to procure a new " .. object.uFreeFrenchInfantry.name .. " unit!")
					return smallNestedMenu("menu4")
				end	
				
			-- FREE FRENCH 105MM ART
			elseif menu4choice_sub6 == 6 then
					if object.pAllies.money >= param.replacementFreeFrench105ArtCost then
					-- if totalFreeFrench105Art < counter.value("# Free French 105Art") then -- Cannot purchase unit if exceed maximum allowable
					-- ===================	
					local reinforcementsList = gen.createUnit(object.uFreeFrench105Art, object.pAllies, {{44,140,0},{0,136,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacementFreeFrench105ArtCost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A regiment of new "..object.uFreeFrench105Art.name.." arrives in "..reinforcementCity.name.." at a cost of "..param.replacementFreeFrench105ArtCost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacementFreeFrench105ArtCost)
								return smallNestedMenu("menu4")
							else
								civ.ui.text("A regiment of new " .. object.uFreeFrench105Art.name .. " arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementFreeFrench105ArtCost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacementFreeFrench105ArtCost)
								return smallNestedMenu("menu4")
							end
						else
							text.simple("Our replacement "..object.uFreeFrench105Art.name.." never arrived.")
						end	
					-- ===================	
					-- else
						-- civ.ui.text("The current number of " .. totalFreeFrench105Art .. " '" .. object.uFreeFrench105Art.name .. "' equals the maximun allowed!")
					-- end
				else
					civ.ui.text("It requires " .. param.replacementFreeFrench105ArtCost .. " supplies to procure a new " .. object.uFreeFrench105Art.name .. " unit!")
					return smallNestedMenu("menu4")
				end
				
			-- FREE FRENCH M10
			elseif menu4choice_sub6 == 7 then			
					if object.pAllies.money >= param.replacementFreeFrenchM10Cost then
					-- if totalFreeFrenchM10 < counter.value("# FreeFrenchM10") then -- Cannot purchase unit if exceed maximum allowable
					-- ===================	
					local reinforcementsList = gen.createUnit(object.uFreeFrenchM10, object.pAllies, {{44,140,0},{0,136,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacementFreeFrenchM10Cost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A regiment of new "..object.uFreeFrenchM10.name.." arrives in "..reinforcementCity.name.." at a cost of "..param.replacementFreeFrenchM10Cost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacementFreeFrenchM10Cost)
								return smallNestedMenu("menu4")
							else
								civ.ui.text("A regiment of new " .. object.uFreeFrenchM10.name .. " arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementFreeFrenchM10Cost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacementFreeFrenchM10Cost)
								return smallNestedMenu("menu4")
							end
						else
							text.simple("Our replacement "..object.uFreeFrenchM10.name.." never arrived.")
						end	
					-- ===================	
					-- else
						-- civ.ui.text("The current number of " .. totalFreeFrenchM10 .. " '" .. object.uFreeFrenchM10.name .. "' equals the maximun allowed!")
					-- end
				else
					civ.ui.text("It requires " .. param.replacementFreeFrenchM10Cost .. " supplies to procure a new " .. object.uFreeFrenchM10.name .. " unit!")
					return smallNestedMenu("menu4")
				end
				
			-- EXIT MENUS
			elseif menu4choice_sub6 == 8 then
				-- civ.ui.text("Return to main menu!")
				return smallNestedMenu("menu1")	
			elseif menu4choice_sub6 == 9 then
				-- civ.ui.text("Exit procurement menu!")
				return 
			end

		-- POLISH REPLACEMENTS
		elseif menu4choice == 7 then

			local menuTitle = "Polish Replacements"
			
			-- Allows you to insert conditions within the menu if you want to prevent certain menu options from displaying
			local menuOptions = {}

			menuOptions[1]="Return to Allied Replacements menu!"
			if totalPolishSherman < counter.value("# Polish Sherman") and flag.value("Polish units arrive") == true then -- 
				menuOptions[2]="" .. object.uPolishShermanIII.name .. " at " .. param.replacementPolishShermanCost .. " supplies: " .. tostring(counter.value("# Polish Sherman") - totalPolishSherman) .. " available to build."
			end
			if totalPolishInfantry < counter.value("# Polish Infantry") and flag.value("Polish units arrive") == true then
				menuOptions[3]="" .. object.uPolishInfantry.name .. " at " .. param.replacementPolishInfantryCost .. " supplies: " .. tostring(counter.value("# Polish Infantry") - totalPolishInfantry) .. " available to build."
			end
			if totalPolish25pdrArt < counter.value("# Polish 25pdr Art") and flag.value("Polish units arrive") == true then
				menuOptions[4]="" .. object.uPolish25pdrArt.name .. " at " .. param.replacementPolish25pdrArtCost .. " supplies: " .. tostring(counter.value("# Polish 25pdr Art") - totalPolish25pdrArt) .. " available to build."
			end

			menuOptions[5]="Return to main menu!"
			menuOptions[6]="Exit procurement menu!"
			
			local menuText = "Which type of unit do you wish to procure?\n^(Current stock of supplies: ".. object.pAllies.money..")"	
			local menu4choice_sub7 = text.menu(menuOptions,menuText,menuTitle)		

			-- RETURN TO ALLIED REPLACEMENTS MENU
			if menu4choice_sub7 == 1 then
				-- civ.ui.text("Don't procure any Polish replacements!")
				return smallNestedMenu("menu4")
				
			-- POLISH SHERMAN
			elseif menu4choice_sub7 == 2 then
				if object.pAllies.money >= param.replacementPolishShermanCost then
					-- if totalPolishSherman < counter.value("# Polish Sherman") then -- Cannot purchase unit if exceed maximum allowable
					-- ===================	
					local reinforcementsList = gen.createUnit(object.uPolishShermanIII, object.pAllies, {{73,155,0}, {62,162,0}, {40,180,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacementPolishShermanCost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A regiment of new "..object.uPolishShermanIII.name.." arrives in "..reinforcementCity.name.." at a cost of "..param.replacementPolishShermanCost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacementPolishShermanCost)
								return smallNestedMenu("menu4")
							else
								civ.ui.text("A regiment of new " .. object.uPolishShermanIII.name .. " arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementPolishShermanCost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacementPolishShermanCost)
								return smallNestedMenu("menu4")
							end
						else
							text.simple("Our replacement "..object.uPolishShermanIII.name.." never arrived.")
						end	
					-- ===================	
					-- else
						-- civ.ui.text("The current number of " .. totalPolishSherman .. " '" .. object.uPolishShermanIII.name .. "' equals the maximun allowed!")
					-- end
				else
					civ.ui.text("It requires " .. param.replacementPolishShermanCost .. " supplies to procure a new " .. object.uPolishShermanIII.name .. " unit!")
					return smallNestedMenu("menu4")
				end	

			-- POLISH INFANTRY
			elseif menu4choice_sub7 == 3 then	
				if object.pAllies.money >= param.replacementPolishInfantryCost then
					-- if totalPolishInfantry < counter.value("# Polish Infantry") then -- Cannot purchase unit if exceed maximum allowable
					-- ===================	
					local reinforcementsList = gen.createUnit(object.uPolishInfantry, object.pAllies, {{73,155,0}, {62,162,0}, {40,180,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacementPolishInfantryCost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A regiment of new "..object.uPolishInfantry.name.." arrives in "..reinforcementCity.name.." at a cost of "..param.replacementPolishInfantryCost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacementPolishInfantryCost)
								return smallNestedMenu("menu4")
							else
								civ.ui.text("A regiment of new " .. object.uPolishInfantry.name .. " arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementPolishInfantryCost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacementPolishInfantryCost)
								return smallNestedMenu("menu4")
							end
						else
							text.simple("Our replacement "..object.uPolishInfantry.name.." never arrived.")
						end	
					-- ===================	
					-- else
						-- civ.ui.text("The current number of " .. totalPolishInfantry .. " '" .. object.uPolishInfantry.name .. "' equals the maximun allowed!")
					-- end
				else
					civ.ui.text("It requires " .. param.replacementPolishInfantryCost .. " supplies to procure a new " .. object.uPolishInfantry.name .. " unit!")
					return smallNestedMenu("menu4")
				end

			-- POLISH 25 PDR
			elseif menu4choice_sub7 == 4 then	
				if object.pAllies.money >= param.replacementPolish25pdrArtCost then
					-- if totalPolish25pdrArt < counter.value("# Polish 25pdr Art") then -- Cannot purchase unit if exceed maximum allowable
					-- ===================	
					local reinforcementsList = gen.createUnit(object.uPolish25pdrArt, object.pAllies, {{73,155,0}, {62,162,0}, {40,180,0}}, {randomize=false, veteran=false})
						if reinforcementsList[1] then -- make sure there is actually a reinforcement created
							object.pAllies.money = object.pAllies.money - param.replacementPolish25pdrArtCost
							local firstUnit = reinforcementsList[1]
							local reinforcementCity = firstUnit.location.city
							if reinforcementCity then
								text.simple("A regiment of new "..object.uPolish25pdrArt.name.." arrives in "..reinforcementCity.name.." at a cost of "..param.replacementPolish25pdrArtCost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
								counter.add("# Supplies Spent in Campaign",param.replacementPolish25pdrArtCost)
								return smallNestedMenu("menu4")
							else
								civ.ui.text("A regiment of new " .. object.uPolish25pdrArt.name .. " arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementPolish25pdrArtCost .. " supplies!")	
								counter.add("# Supplies Spent in Campaign",param.replacementPolish25pdrArtCost)
								return smallNestedMenu("menu4")
							end
						else
							text.simple("Our replacement "..object.uPolish25pdrArt.name.." never arrived.")
						end	
					-- ===================	
					-- else
						-- civ.ui.text("The current number of " .. totalPolish25pdrArt .. " '" .. object.uPolish25pdrArt.name .. "' equals the maximun allowed!")
					-- end
				else
					civ.ui.text("It requires " .. param.replacementPolish25pdrArtCost .. " supplies to procure a new " .. object.uPolish25pdrArt.name .. " unit!")
					return smallNestedMenu("menu4")
				end					
				
			-- EXIT MENUS
			elseif menu4choice_sub7 == 5 then
				-- civ.ui.text("Return to main menu!")
				return smallNestedMenu("menu1")	
			elseif menu4choice_sub7 == 6 then
				-- civ.ui.text("Exit procurement menu!")
				return 
			end
			
		-- Return to main menu
		elseif menu4choice == 8 then
            return smallNestedMenu("menu1")			
		
		-- Exit procurement menu
		elseif menu4choice == 9 then
            return 		
        end
	end	

	-- ROYAL NAVY PROCUREMENT MENU
	if menuType == "menu5" then

		local menuTitle = "Royal Navy and USN Replacements"
		
		-- Allows you to insert conditions within the menu if you want to prevent certain menu options from displaying
		local menuOptions = {}

		menuOptions[1]="Return to Royal Navy and USN Replacements menu!"
		if totalDestroyers < counter.value("# Tribal Class DD") then -- 
			menuOptions[2]="" .. object.uTribalClassDD.name .. " at " .. param.replacementDestroyersCost .. " supplies: " .. tostring(counter.value("# Tribal Class DD") - totalDestroyers) .. " available to build."
		end
		if totalLightCruiser < counter.value("# Leander Class CL") then
			menuOptions[3]="" .. object.uLeanderClassCL.name .. " at " .. param.replacementLightCruisersCost .. " supplies: " .. tostring(counter.value("# Leander Class CL") - totalLightCruiser) .. " available to build."
		end
		if totalHeavyCruisers < counter.value("# York Class CA") then
			menuOptions[4]="" .. object.uYorkClassCA.name .. " at " .. param.replacementHeavyCruisersCost .. " supplies: " .. tostring(counter.value("# York Class CA") - totalHeavyCruisers) .. " available to build."
		end
		if totalSubmarines < counter.value("# S-Class") then
			menuOptions[5]="" .. object.uSClass.name .. " at " .. param.replacementSubmarinesCost .. " supplies: " .. tostring(counter.value("# S-Class") - totalSubmarines) .. " available to build."
		end
		if totalLibertyShips < counter.value("# Liberty Ship") then
			menuOptions[6]="" .. object.uLibertyShip.name .. " at " .. param.replacementLibertyShipsCost .. " supplies: " .. tostring(counter.value("# Liberty Ship") - totalLibertyShips) .. " available to build."
		end
		if totalOilTankers < counter.value("# Total Oil Tankers") then
			menuOptions[7]="" .. object.uOilTankerF.name .. " at " .. param.replacementOilTankersCost .. " supplies: " .. tostring(counter.value("# Total Oil Tankers") - totalOilTankers) .. " available to build."
		end
		if totalDUKW < counter.value("# DUKW") then
			menuOptions[8]="" .. object.uDUKW.name .. " at " .. param.replacementDUKWsCost .. " supplies: " .. tostring(counter.value("# DUKW") - totalDUKW) .. " available to build."
		end
		
		menuOptions[9]="Return to main menu!"
		menuOptions[10]="Exit procurement menu!"
		
		local menuText = "Which type of unit do you wish to procure?\n^(Current stock of supplies: ".. object.pAllies.money..")"	
		local menu5choice_sub1 = text.menu(menuOptions,menuText,menuTitle)		

		-- RETURN TO RN and USN REPLACEMENTS MENU
		if menu5choice_sub1 == 1 then
			-- civ.ui.text("Don't procure any RN & USN replacements!")
			return smallNestedMenu("menu5")
			
		-- DESTROYERS
		elseif menu5choice_sub1 == 2 then
			if object.pAllies.money >= param.replacementDestroyersCost then
				-- if totalDestroyers < counter.value("# Tribal Class DD") then -- Cannot purchase unit if exceed maximum allowable
				-- ===================	
				local reinforcementsList = gen.createUnit(object.uTribalClassDD, object.pAllies, {{0,136,0}, {40,180,0}}, {randomize=true, veteran=false})
					if reinforcementsList[1] then -- make sure there is actually a reinforcement created
						object.pAllies.money = object.pAllies.money - param.replacementDestroyersCost
						local firstUnit = reinforcementsList[1]
						local reinforcementCity = firstUnit.location.city
						if reinforcementCity then
							text.simple("A regiment of new "..object.uTribalClassDD.name.." arrives in "..reinforcementCity.name.." at a cost of "..param.replacementDestroyersCost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
							counter.add("# Supplies Spent in Campaign",param.replacementDestroyersCost)
							return smallNestedMenu("menu5")
						else
							civ.ui.text("A regiment of new " .. object.uTribalClassDD.name .. " arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementDestroyersCost .. " supplies!")	
							counter.add("# Supplies Spent in Campaign",param.replacementDestroyersCost)
							return smallNestedMenu("menu5")
						end
					else
						text.simple("Our replacement "..object.uTribalClassDD.name.." never arrived.")
					end	
				-- ===================	
				-- else
					-- civ.ui.text("The current number of " .. totalDestroyers .. " '" .. object.uTribalClassDD.name .. "' equals the maximun allowed!")
				-- end
			else
				civ.ui.text("It requires " .. param.replacementDestroyersCost .. " supplies to procure a new " .. object.uTribalClassDD.name .. " unit!")
				return smallNestedMenu("menu5")
			end	

		-- LIGHT CRUISERS
		elseif menu5choice_sub1 == 3 then	
			if object.pAllies.money >= param.replacementLightCruisersCost then
				-- if totalLightCruiser < counter.value("# Leander Class CL") then -- Cannot purchase unit if exceed maximum allowable
				-- ===================	
				local reinforcementsList = gen.createUnit(object.uLeanderClassCL, object.pAllies, {{0,136,0}, {40,180,0}}, {randomize=true, veteran=false})
					if reinforcementsList[1] then -- make sure there is actually a reinforcement created
						object.pAllies.money = object.pAllies.money - param.replacementLightCruisersCost
						local firstUnit = reinforcementsList[1]
						local reinforcementCity = firstUnit.location.city
						if reinforcementCity then
							text.simple("A regiment of new "..object.uLeanderClassCL.name.." arrives in "..reinforcementCity.name.." at a cost of "..param.replacementLightCruisersCost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
							counter.add("# Supplies Spent in Campaign",param.replacementLightCruisersCost)
							return smallNestedMenu("menu5")
						else
							civ.ui.text("A regiment of new " .. object.uLeanderClassCL.name .. " arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementLightCruisersCost .. " supplies!")	
							counter.add("# Supplies Spent in Campaign",param.replacementLightCruisersCost)
							return smallNestedMenu("menu5")
						end
					else
						text.simple("Our replacement "..object.uLeanderClassCL.name.." never arrived.")
					end	
				-- ===================	
				-- else
					-- civ.ui.text("The current number of " .. totalLightCruiser .. " '" .. object.uLeanderClassCL.name .. "' equals the maximun allowed!")
				-- end
			else
				civ.ui.text("It requires " .. param.replacementLightCruisersCost .. " supplies to procure a new " .. object.uLeanderClassCL.name .. " unit!")
				return smallNestedMenu("menu5")
			end

		-- HEAVY CRUISERS
		elseif menu5choice_sub1 == 4 then	
			if object.pAllies.money >= param.replacementHeavyCruisersCost then
				-- if totalHeavyCruisers < counter.value("# York Class CA") then -- Cannot purchase unit if exceed maximum allowable
				-- ===================	
				local reinforcementsList = gen.createUnit(object.uYorkClassCA, object.pAllies, {{0,136,0}, {40,180,0}}, {randomize=true, veteran=false})
					if reinforcementsList[1] then -- make sure there is actually a reinforcement created
						object.pAllies.money = object.pAllies.money - param.replacementHeavyCruisersCost
						local firstUnit = reinforcementsList[1]
						local reinforcementCity = firstUnit.location.city
						if reinforcementCity then
							text.simple("A regiment of new "..object.uYorkClassCA.name.." arrives in "..reinforcementCity.name.." at a cost of "..param.replacementHeavyCruisersCost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
							counter.add("# Supplies Spent in Campaign",param.replacementHeavyCruisersCost)
							return smallNestedMenu("menu5")
						else
							civ.ui.text("A regiment of new " .. object.uYorkClassCA.name .. " arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementHeavyCruisersCost .. " supplies!")	
							counter.add("# Supplies Spent in Campaign",param.replacementHeavyCruisersCost)
							return smallNestedMenu("menu5")
						end
					else
						text.simple("Our replacement "..object.uYorkClassCA.name.." never arrived.")
					end	
				-- ===================	
				-- else
					-- civ.ui.text("The current number of " .. totalHeavyCruisers .. " '" .. object.uYorkClassCA.name .. "' equals the maximun allowed!")
				-- end
			else
				civ.ui.text("It requires " .. param.replacementHeavyCruisersCost .. " supplies to procure a new " .. object.uYorkClassCA.name .. " unit!")
				return smallNestedMenu("menu4")
			end					

		-- SUBMARINES
		elseif menu5choice_sub1 == 5 then	
			if object.pAllies.money >= param.replacementSubmarinesCost then
				-- if totalSubmarines < counter.value("# S-Class") then -- Cannot purchase unit if exceed maximum allowable
				-- ===================	
				local reinforcementsList = gen.createUnit(object.uSClass, object.pAllies, {{0,136,0}, {40,180,0}}, {randomize=true, veteran=false})
					if reinforcementsList[1] then -- make sure there is actually a reinforcement created
						object.pAllies.money = object.pAllies.money - param.replacementSubmarinesCost
						local firstUnit = reinforcementsList[1]
						local reinforcementCity = firstUnit.location.city
						if reinforcementCity then
							text.simple("A regiment of new "..object.uSClass.name.." arrives in "..reinforcementCity.name.." at a cost of "..param.replacementSubmarinesCost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
							counter.add("# Supplies Spent in Campaign",param.replacementSubmarinesCost)
							return smallNestedMenu("menu5")
						else
							civ.ui.text("A regiment of new " .. object.uSClass.name .. " arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementSubmarinesCost .. " supplies!")	
							counter.add("# Supplies Spent in Campaign",param.replacementSubmarinesCost)
							return smallNestedMenu("menu5")
						end
					else
						text.simple("Our replacement "..object.uSClass.name.." never arrived.")
					end	
				-- ===================	
				-- else
					-- civ.ui.text("The current number of " .. totalSubmarines .. " '" .. object.uSClass.name .. "' equals the maximun allowed!")
				-- end
			else
				civ.ui.text("It requires " .. param.replacementSubmarinesCost .. " supplies to procure a new " .. object.uSClass.name .. " unit!")
				return smallNestedMenu("menu4")
			end	

		-- LIBERTY SHIPS
		elseif menu5choice_sub1 == 6 then	
			if object.pAllies.money >= param.replacementLibertyShipsCost then
				-- if totalLibertyShips < counter.value("# Liberty Ship") then -- Cannot purchase unit if exceed maximum allowable
				-- ===================	
				local reinforcementsList = gen.createUnit(object.uLibertyShip, object.pAllies, {{0,136,0}, {40,180,0}}, {randomize=true, veteran=false})
					if reinforcementsList[1] then -- make sure there is actually a reinforcement created
						object.pAllies.money = object.pAllies.money - param.replacementLibertyShipsCost
						local firstUnit = reinforcementsList[1]
						local reinforcementCity = firstUnit.location.city
						if reinforcementCity then
							text.simple("A regiment of new "..object.uLibertyShip.name.." arrives in "..reinforcementCity.name.." at a cost of "..param.replacementLibertyShipsCost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
							counter.add("# Supplies Spent in Campaign",param.replacementLibertyShipsCost)
							return smallNestedMenu("menu5")
						else
							civ.ui.text("A regiment of new " .. object.uLibertyShip.name .. " arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementLibertyShipsCost .. " supplies!")	
							counter.add("# Supplies Spent in Campaign",param.replacementLibertyShipsCost)
							return smallNestedMenu("menu5")
						end
					else
						text.simple("Our replacement "..object.uLibertyShip.name.." never arrived.")
					end	
				-- ===================	
				-- else
					-- civ.ui.text("The current number of " .. totalLibertyShips .. " '" .. object.uLibertyShip.name .. "' equals the maximun allowed!")
				-- end
			else
				civ.ui.text("It requires " .. param.replacementLibertyShipsCost .. " supplies to procure a new " .. object.uLibertyShip.name .. " unit!")
				return smallNestedMenu("menu4")
			end	
			
		-- OIL TANKERS (F)
		elseif menu5choice_sub1 == 7 then	
			if object.pAllies.money >= param.replacementOilTankersCost then
				-- if totalOilTankers < counter.value("# Total Oil Tankers") then -- Cannot purchase unit if exceed maximum allowable
				-- ===================	
				local reinforcementsList = gen.createUnit(object.uOilTankerF, object.pAllies, {{0,136,0}, {40,180,0}}, {randomize=true, veteran=false})
					if reinforcementsList[1] then -- make sure there is actually a reinforcement created
						object.pAllies.money = object.pAllies.money - param.replacementOilTankersCost
						local firstUnit = reinforcementsList[1]
						local reinforcementCity = firstUnit.location.city
						if reinforcementCity then
							text.simple("A regiment of new "..object.uOilTankerF.name.." arrives in "..reinforcementCity.name.." at a cost of "..param.replacementOilTankersCost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
							counter.add("# Supplies Spent in Campaign",param.replacementOilTankersCost)
							return smallNestedMenu("menu5")
						else
							civ.ui.text("A regiment of new " .. object.uOilTankerF.name .. " arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementOilTankersCost .. " supplies!")	
							counter.add("# Supplies Spent in Campaign",param.replacementOilTankersCost)
							return smallNestedMenu("menu5")
						end
					else
						text.simple("Our replacement "..object.uOilTankerF.name.." never arrived.")
					end	
				-- ===================	
				-- else
					-- civ.ui.text("The current number of " .. totalOilTankers .. " '" .. object.uOilTankerF.name .. "' equals the maximun allowed!")
				-- end
			else
				civ.ui.text("It requires " .. param.replacementOilTankersCost .. " supplies to procure a new " .. object.uOilTankerF.name .. " unit!")
				return smallNestedMenu("menu4")
			end	

		-- DUKW'S
		elseif menu5choice_sub1 == 8 then	
			if object.pAllies.money >= param.replacementDUKWsCost then
				-- if totalDUKW < counter.value("# DUKW") then -- Cannot purchase unit if exceed maximum allowable
				-- ===================	
				local reinforcementsList = gen.createUnit(object.uDUKW, object.pAllies, {{73,155,0}, {62,162,0}, {40,180,0}}, {randomize=false, veteran=false})
					if reinforcementsList[1] then -- make sure there is actually a reinforcement created
						object.pAllies.money = object.pAllies.money - param.replacementDUKWsCost
						local firstUnit = reinforcementsList[1]
						local reinforcementCity = firstUnit.location.city
						if reinforcementCity then
							text.simple("A regiment of new "..object.uDUKW.name.." arrives in "..reinforcementCity.name.." at a cost of "..param.replacementDUKWsCost.." supplies!\n^\r^You have ".. object.pAllies.money.." supplies remaining!","Supply Officer: ".. object.pAllies.money.." supplies")
							counter.add("# Supplies Spent in Campaign",param.replacementDUKWsCost)
							return smallNestedMenu("menu5")
						else
							civ.ui.text("A regiment of new " .. object.uDUKW.name .. " arrives on tile (" ..text.coordinates(firstUnit.location).. ") at a cost of " .. param.replacementDUKWsCost .. " supplies!")	
							counter.add("# Supplies Spent in Campaign",param.replacementDUKWsCost)
							return smallNestedMenu("menu5")
						end
					else
						text.simple("Our replacement "..object.uDUKW.name.." never arrived.")
					end	
				-- ===================	
				-- else
					-- civ.ui.text("The current number of " .. totalDUKW .. " '" .. object.uDUKW.name .. "' equals the maximun allowed!")
				-- end
			else
				civ.ui.text("It requires " .. param.replacementDUKWsCost .. " supplies to procure a new " .. object.uDUKW.name .. " unit!")
				return smallNestedMenu("menu4")
			end	

		-- EXIT MENUS
		elseif menu5choice_sub1 == 9 then
			-- civ.ui.text("Return to main menu!")
			return smallNestedMenu("menu1")	
		elseif menu5choice_sub1 == 10 then
			-- civ.ui.text("Exit procurement menu!")
			return 
		end

	end
	
	-- EXIT PROCUREMENT MENU
	if menuType == "menu6" then
	--elseif choice == 4 then
		-- civ.ui.text("Exit Primary Menu")
		return
	end
		
-- ALLIED REPLACEMENT PROCUREMENT - End ===========================================================
	
end

return {smallNestedMenu = smallNestedMenu}

